import d3d9;
import std.string;
import std.c.stdio;
import win32.ansi.windows;

extern (C) void gc_init();
extern (C) void gc_term();
extern (C) void _minit();
extern (C) void _moduleCtor();
//extern (C) void _moduleUnitTests();

extern(Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, INT nCmdShow)
{
	int result;
	gc_init();
	_minit();

	try
	{
		_moduleCtor();
		//_moduleUnitTests();
		result=myWinMain(hInstance, hPrevInstance, lpszCmdLine, nCmdShow);
	}
	catch (Object o)
	{
		MessageBox(null,cast(char*)o.toString(),"Error",MB_OK | MB_ICONEXCLAMATION);
		result=0;
	}

	gc_term();
	return result;
}

// ------------------------------------------------------------------------------------------------

IDirect3D9 gpD3D;
IDirect3DDevice9 gpD3DDevice;

int myWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, INT nCmdShow)
{
	try
		Graphics3D(800,600,1);
	catch(Object e)
	{
		DXError dxe=cast(DXError)e;
		if(!dxe)
			MessageBox(null,e.toString(),"Error",MB_OK);
		else
			MessageBox(null,dxe.toString(),"Error",MB_OK);
		return 1;
	}

	uint t=timeGetTime();

	while(timeGetTime()-t<2000)
	{
		ProcessWinMessages();
		gpD3DDevice.Clear(0,null,D3DCLEAR_TARGET,D3DCOLOR_XRGB(0,0,255),1.0f,0);
		
		gpD3DDevice.BeginScene();

		gpD3DDevice.EndScene();

		gpD3DDevice.Present(null,null,null,null);
	}

	gpD3DDevice.Release();
	gpD3D.Release();

	return 0;
}

enum GWinType
{
	Fullscreen=0,
	Windowed,
	Static,
	Scalable,
	NoBorder
};

uint gGraphicsWidth=0, gGraphicsHeight=0;
D3DFORMAT gGraphicsFormat=D3DFMT_UNKNOWN;
bit gGraphicsWindowed=1;
GWinType gWindowType=GWinType.Windowed;
WNDCLASSEX gwc;
HINSTANCE ghInst;
HANDLE ghWnd;
char[] gEntryBuffer="";

class DXError : Error
{
public:
	this(char[] s, HRESULT h)
	{
		super(s);
		hr=h;
	}
	
	char[] toString()
	{
		//char* text=DXGetErrorDescription9(hr);
		//char[] t=text[0..strlen(text)];
		return this.classinfo.name~"\n"~std.string.toString(hr);
	}

	HRESULT hr;
}

void ProcessWinMessages()
{
	MSG msg;
	while(PeekMessage(&msg,NULL,0,0,PM_REMOVE)!=0) { TranslateMessage(&msg); DispatchMessage(&msg); }
}

extern(Windows)
LRESULT WinProc(HWND ghWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
		case WM_CHAR:
			if(gEntryBuffer.length<=256) gEntryBuffer~=toString(cast(char)wParam);
			break;

		//case WM_DESTROY:
			//CleanupGame();
			//exit(0);
			//break;

		//case WM_QUIT:
			//CleanupGame();
			//exit(0);
			//break;
	}

	return DefWindowProc(ghWnd, msg, wParam, lParam);
}

void CreateGameWindow(int w, int h, GWinType wintype)
{
	gGraphicsWidth=w;
	gGraphicsHeight=h;
	if(ghWnd)
	{
		switch(wintype)
		{
			case GWinType.Static:
				// compensate for the window borders
				w=w+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE);
				h=h+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE)+GetSystemMetrics(SM_CYCAPTION);
				SetWindowLong(ghWnd,GWL_STYLE,WS_OVERLAPPEDWINDOW&~WS_THICKFRAME);
				break;

			case GWinType.Scalable:
				// compensate for the window borders
				w=w+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE);
				h=h+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE)+GetSystemMetrics(SM_CYCAPTION);
				SetWindowLong(ghWnd,GWL_STYLE,WS_OVERLAPPEDWINDOW);
				break;

			case GWinType.NoBorder:
				SetWindowLong(ghWnd,GWL_STYLE,WS_POPUP|WS_VISIBLE);
				break;

			default:
				throw new Error("Invalid window type!");
				break;
		}

		SetWindowPos(ghWnd,NULL,(GetSystemMetrics(0)/2)-(w/2),(GetSystemMetrics(1)/2)-(h/2),w,h,SWP_NOZORDER);
	}
	else
	{
		with(gwc)
		{
			cbSize=WNDCLASSEX.sizeof;
			style=CS_CLASSDC;
			lpfnWndProc=&WinProc;
			cbClsExtra=0L;
			cbWndExtra=0L;
			hInstance=GetModuleHandle(NULL);
			hIcon=NULL;
			hCursor=NULL;
			hbrBackground=NULL;
			lpszMenuName=NULL;
			lpszClassName="DXwindow01";
			hIconSm=NULL;
		}
		RegisterClassEx(&gwc);

		switch(wintype)
		{
			case GWinType.Static:
				// compensate for the window borders
				w=w+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE);
				h=h+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE)+GetSystemMetrics(SM_CYCAPTION);
				ghWnd=CreateWindow("DXwindow01","",WS_OVERLAPPEDWINDOW&~WS_THICKFRAME,(GetSystemMetrics(0)/2)-(w/2),(GetSystemMetrics(1)/2)-(h/2),w,h,GetDesktopWindow(),null,gwc.hInstance,null);
				break;

			case GWinType.Scalable:
				// compensate for the window borders
				w=w+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE);
				h=h+GetSystemMetrics(SM_CXFRAME)+GetSystemMetrics(SM_CXEDGE)+GetSystemMetrics(SM_CYCAPTION);
				ghWnd=CreateWindow("DXwindow01","",WS_OVERLAPPEDWINDOW,(GetSystemMetrics(0)/2)-(w/2),(GetSystemMetrics(1)/2)-(h/2),w,h,GetDesktopWindow(),NULL,gwc.hInstance,NULL);
				break;

			case GWinType.NoBorder:
				ghWnd=CreateWindow("DXwindow01","",WS_POPUP|WS_VISIBLE,(GetSystemMetrics(0)/2)-(w/2),(GetSystemMetrics(1)/2)-(h/2),w,h,GetDesktopWindow(),NULL,gwc.hInstance,NULL);
				break;

			default:
				throw new Error("Invalid window type!");
				break;
		}
	}
	ShowWindow(ghWnd,SW_SHOWDEFAULT);
	UpdateWindow(ghWnd);
}

void Graphics3D(int width, int height, bit windowed=1, GWinType wintype=GWinType.Static, bit force16=0)
{
	Direct3DCreate9(31);

	if(windowed==1)
	{
		CreateGameWindow(width,height,wintype);
		InitD3D(width,height,D3DFMT_UNKNOWN,1);
		gGraphicsWindowed=1;
		gWindowType=wintype;
	}
	else
	{
		CreateGameWindow(width,height,GWinType.NoBorder);
		D3DFORMAT d32=Check3DDisplayMode(width,height,32);
		D3DFORMAT d16=Check3DDisplayMode(width,height,16);
		if(force16)
		{
			if(d16==D3DFMT_UNKNOWN)
			{
				if(d32==D3DFMT_UNKNOWN)
					throw new Error("Could not set display mode!\n"~toString(width)~"x"~toString(height));
				else
				{
					InitD3D(width,height,d32,0);
					gGraphicsFormat=d32;
				}
			}
			else
			{
 				InitD3D(width,height,d16,0);
				gGraphicsFormat=d16;
			}
		}
		else
		{
			if(d32==D3DFMT_UNKNOWN)
			{
				if(d16==D3DFMT_UNKNOWN)
					throw new Error("Could not set display mode!\n"~toString(width)~"x"~toString(height));
				else
				{
					InitD3D(width,height,d16,0);
					gGraphicsFormat=d16;
				}
			}
			else
			{
 				InitD3D(width,height,d32,0);
				gGraphicsFormat=d32;
			}
		}

		//HidePointer();
		gGraphicsWindowed=0;
		gWindowType=GWinType.NoBorder;
	}

	gpD3DDevice.SetRenderState(D3DRS_COLORVERTEX,false);
}

D3DFORMAT Check3DDisplayMode(uint nWidth, uint nHeight, uint nDepth)
{
	uint x;
	D3DDISPLAYMODE d3ddm;

	if(nDepth==32)
	{
		for(x=0; x<gpD3D.GetAdapterModeCount(D3DADAPTER_DEFAULT,D3DFMT_X8R8G8B8); x++)
		{
			gpD3D.EnumAdapterModes(D3DADAPTER_DEFAULT,D3DFMT_X8R8G8B8,x,&d3ddm);
			if(d3ddm.Width==nWidth && d3ddm.Height==nHeight)
				return d3ddm.Format;
		}
	}
	else if(nDepth==16)
	{
		for(x=0; x<gpD3D.GetAdapterModeCount(D3DADAPTER_DEFAULT,D3DFMT_R5G6B5); x++)
		{
			gpD3D.EnumAdapterModes(D3DADAPTER_DEFAULT,D3DFMT_R5G6B5,x,&d3ddm);
			if(d3ddm.Width==nWidth && d3ddm.Height==nHeight)
				return d3ddm.Format;
		}
	}
	return D3DFMT_UNKNOWN;
}

void InitD3D(int width, int height, D3DFORMAT format, bit windowed)
{
	HRESULT hr;
	D3DDISPLAYMODE d3ddm;
	gpD3D.GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&d3ddm);

	//gpD3D.GetDeviceCaps(0,D3DDEVTYPE_HAL,&gD3DCaps);

	if(format!=D3DFMT_UNKNOWN) d3ddm.Format=format;

	D3DPRESENT_PARAMETERS d3dpp;
	ZeroMemory(&d3dpp,d3dpp.sizeof);

	d3dpp.Windowed=windowed;
	d3dpp.SwapEffect=D3DSWAPEFFECT_FLIP;
	d3dpp.BackBufferFormat=d3ddm.Format;
	if(!windowed)
	{
		d3dpp.BackBufferWidth=width;
		d3dpp.BackBufferHeight=height;
	}
	else
		gGraphicsFormat=d3ddm.Format;

	d3dpp.PresentationInterval=D3DPRESENT_INTERVAL_ONE;

	if((hr=gpD3D.CheckDeviceFormat(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,d3ddm.Format,D3DUSAGE_DEPTHSTENCIL,D3DRTYPE_SURFACE,D3DFMT_D32))==D3D_OK)
	{
		d3dpp.AutoDepthStencilFormat=D3DFMT_D32;
		d3dpp.EnableAutoDepthStencil=TRUE;
	}
	else if((hr=gpD3D.CheckDeviceFormat(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,d3ddm.Format,D3DUSAGE_DEPTHSTENCIL,D3DRTYPE_SURFACE,D3DFMT_D24X8))==D3D_OK)
	{
		d3dpp.AutoDepthStencilFormat=D3DFMT_D24X8;
		d3dpp.EnableAutoDepthStencil=TRUE;
	}
	else if((hr=gpD3D.CheckDeviceFormat(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,d3ddm.Format,D3DUSAGE_DEPTHSTENCIL,D3DRTYPE_SURFACE,D3DFMT_D16))==D3D_OK)
	{
		d3dpp.AutoDepthStencilFormat=D3DFMT_D16;
		d3dpp.EnableAutoDepthStencil=TRUE;
	}
	else
	{
		throw new DXError("Could not set up Z buffer!",hr);
	}

	/*if(gpD3DDevice)
	{
		d3dpp.hDeviceWindow=ghWnd;
		for(std::vector<Font*>::iterator fi=FontVec.begin(); fi!=FontVec.end(); fi++)
		{
			Font* f=*fi;
			hr=f->pFont->OnLostDevice();
		}

		for(std::vector<Effect*>::iterator efi=EffectVec.begin(); efi!=EffectVec.end(); efi++)
		{
			Effect* ef=*efi;
			ef->effect->OnLostDevice();
		}

		for(std::vector<TextureBase*>::iterator ti=TextureVec.begin(); ti!=TextureVec.end(); ti++)
		{
			TextureBase* t=*ti;
			if(t->m_type==tRender) RenderTextureOnLostDevice((Texture*)t);
			if(t->m_type==tRenderCube) RenderCubeTextureOnLostDevice((CubeTexture*)t);
		}

		gFontSprite->OnLostDevice();

		if(FAILED(hr=gpD3DDevice->Reset(&d3dpp)))
  			DXRuntimeError("Could not reset device!",hr);

		gFontSprite->OnResetDevice();

		for(fi=FontVec.begin(); fi!=FontVec.end(); fi++)
		{
			Font* f=*fi;
			f->pFont->OnResetDevice();
		}

		for(efi=EffectVec.begin(); efi!=EffectVec.end(); efi++)
		{
			Effect* ef=*efi;
			ef->effect->OnResetDevice();
		}

		for(ti=TextureVec.begin(); ti!=TextureVec.end(); ti++)
		{
			TextureBase* t=*ti;
			if(t->m_type==tRender) RenderTextureOnResetDevice((Texture*)t);
			if(t->m_type==tRenderCube) RenderCubeTextureOnResetDevice((CubeTexture*)t);
		}

		for(std::vector<std::vector<Entity*>*>::iterator evi=EntityVec.begin(); evi!=EntityVec.end(); evi++)
			for(std::vector<Entity*>::iterator ei=(*evi)->begin(); ei!=(*evi)->end(); ei++)
			{
				Entity* e=*ei;
				if(e->Type()==eLight)
					((EntityLight*)e)->Update();
			}
	}
	else*/
	{
		if(FAILED(hr=gpD3D.CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,ghWnd,D3DCREATE_HARDWARE_VERTEXPROCESSING,&d3dpp,&gpD3DDevice)))
			throw new DXError("Could not create device!",hr);

		/*if(FAILED(hr=D3DXCreateSprite(gpD3DDevice,&gFontSprite)))
			DXRuntimeError("Could not initialize font interface!",hr);*/
	}

	gpD3DDevice.SetRenderState(D3DRS_CULLMODE,D3DCULL_CCW);
	gpD3DDevice.SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
	gpD3DDevice.SetRenderState(D3DRS_FILLMODE,D3DFILL_SOLID);
	gpD3DDevice.SetRenderState(D3DRS_NORMALIZENORMALS,TRUE);
	gpD3DDevice.SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);
	gpD3DDevice.SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
	gpD3DDevice.SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
	gpD3DDevice.SetRenderState(D3DRS_SPECULARENABLE,TRUE);
	if(d3ddm.Format==D3DFMT_R5G6B5)
		gpD3DDevice.SetRenderState(D3DRS_DITHERENABLE,1);
	else
		gpD3DDevice.SetRenderState(D3DRS_DITHERENABLE,0);

	for(int i=0; i<8; i++)
	{
		gpD3DDevice.SetSamplerState(i,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);
		gpD3DDevice.SetSamplerState(i,D3DSAMP_MINFILTER,D3DTEXF_LINEAR);
		gpD3DDevice.SetSamplerState(i,D3DSAMP_MIPFILTER,D3DTEXF_LINEAR);
	}

	for(int i=0; i<8; i++)
	{
		gpD3DDevice.SetTextureStageState(i,D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2);
	}

	gpD3DDevice.SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_MODULATE);

	if(FAILED(hr=gpD3DDevice.SetRenderState(D3DRS_LIGHTING,TRUE)))
		throw new DXError("Could not initialize lights!",hr);

	//gpD3DDevice.SetRenderState(D3DRS_AMBIENT, gAmbientLight);
}

