module win32.ansi.winerror;

// Translated from Microsoft Platform SDK August 2001 Edition
// by Y.Tomino (demoonlit@inter7.jp)

import win32.ansi.winnt;

// #ifndef _WINERROR_
// #define _WINERROR_

// #if defined (_MSC_VER) && (_MSC_VER >= 1020) && !defined(__midl)
// #pragma once
// #endif

enum : uint { FACILITY_WINDOWS_CE = 24 }
enum : uint { FACILITY_WINDOWS = 8 }
enum : uint { FACILITY_URT = 19 }
enum : uint { FACILITY_UMI = 22 }
enum : uint { FACILITY_SXS = 23 }
enum : uint { FACILITY_STORAGE = 3 }
enum : uint { FACILITY_SSPI = 9 }
enum : uint { FACILITY_SCARD = 16 }
enum : uint { FACILITY_SETUPAPI = 15 }
enum : uint { FACILITY_SECURITY = 9 }
enum : uint { FACILITY_RPC = 1 }
enum : uint { FACILITY_WIN32 = 7 }
enum : uint { FACILITY_CONTROL = 10 }
enum : uint { FACILITY_NULL = 0 }
enum : uint { FACILITY_MSMQ = 14 }
enum : uint { FACILITY_MEDIASERVER = 13 }
enum : uint { FACILITY_INTERNET = 12 }
enum : uint { FACILITY_ITF = 4 }
enum : uint { FACILITY_HTTP = 25 }
enum : uint { FACILITY_DPLAY = 21 }
enum : uint { FACILITY_DISPATCH = 2 }
enum : uint { FACILITY_CONFIGURATION = 33 }
enum : uint { FACILITY_COMPLUS = 17 }
enum : uint { FACILITY_CERT = 11 }
enum : uint { FACILITY_BACKGROUNDCOPY = 32 }
enum : uint { FACILITY_ACS = 20 }
enum : uint { FACILITY_AAF = 18 }

enum : uint { ERROR_SUCCESS = 0 }

enum : uint { NO_ERROR = 0 }
enum : HRESULT { SEC_E_OK = cast(HRESULT)0x00000000 }

enum : uint { ERROR_INVALID_FUNCTION = 1 }

enum : uint { ERROR_FILE_NOT_FOUND = 2 }

enum : uint { ERROR_PATH_NOT_FOUND = 3 }

enum : uint { ERROR_TOO_MANY_OPEN_FILES = 4 }

enum : uint { ERROR_ACCESS_DENIED = 5 }

enum : uint { ERROR_INVALID_HANDLE = 6 }

enum : uint { ERROR_ARENA_TRASHED = 7 }

enum : uint { ERROR_NOT_ENOUGH_MEMORY = 8 }

enum : uint { ERROR_INVALID_BLOCK = 9 }

enum : uint { ERROR_BAD_ENVIRONMENT = 10 }

enum : uint { ERROR_BAD_FORMAT = 11 }

enum : uint { ERROR_INVALID_ACCESS = 12 }

enum : uint { ERROR_INVALID_DATA = 13 }

enum : uint { ERROR_OUTOFMEMORY = 14 }

enum : uint { ERROR_INVALID_DRIVE = 15 }

enum : uint { ERROR_CURRENT_DIRECTORY = 16 }

enum : uint { ERROR_NOT_SAME_DEVICE = 17 }

enum : uint { ERROR_NO_MORE_FILES = 18 }

enum : uint { ERROR_WRITE_PROTECT = 19 }

enum : uint { ERROR_BAD_UNIT = 20 }

enum : uint { ERROR_NOT_READY = 21 }

enum : uint { ERROR_BAD_COMMAND = 22 }

enum : uint { ERROR_CRC = 23 }

enum : uint { ERROR_BAD_LENGTH = 24 }

enum : uint { ERROR_SEEK = 25 }

enum : uint { ERROR_NOT_DOS_DISK = 26 }

enum : uint { ERROR_SECTOR_NOT_FOUND = 27 }

enum : uint { ERROR_OUT_OF_PAPER = 28 }

enum : uint { ERROR_WRITE_FAULT = 29 }

enum : uint { ERROR_READ_FAULT = 30 }

enum : uint { ERROR_GEN_FAILURE = 31 }

enum : uint { ERROR_SHARING_VIOLATION = 32 }

enum : uint { ERROR_LOCK_VIOLATION = 33 }

enum : uint { ERROR_WRONG_DISK = 34 }

enum : uint { ERROR_SHARING_BUFFER_EXCEEDED = 36 }

enum : uint { ERROR_HANDLE_EOF = 38 }

enum : uint { ERROR_HANDLE_DISK_FULL = 39 }

enum : uint { ERROR_NOT_SUPPORTED = 50 }

enum : uint { ERROR_REM_NOT_LIST = 51 }

enum : uint { ERROR_DUP_NAME = 52 }

enum : uint { ERROR_BAD_NETPATH = 53 }

enum : uint { ERROR_NETWORK_BUSY = 54 }

enum : uint { ERROR_DEV_NOT_EXIST = 55 }

enum : uint { ERROR_TOO_MANY_CMDS = 56 }

enum : uint { ERROR_ADAP_HDW_ERR = 57 }

enum : uint { ERROR_BAD_NET_RESP = 58 }

enum : uint { ERROR_UNEXP_NET_ERR = 59 }

enum : uint { ERROR_BAD_REM_ADAP = 60 }

enum : uint { ERROR_PRINTQ_FULL = 61 }

enum : uint { ERROR_NO_SPOOL_SPACE = 62 }

enum : uint { ERROR_PRINT_CANCELLED = 63 }

enum : uint { ERROR_NETNAME_DELETED = 64 }

enum : uint { ERROR_NETWORK_ACCESS_DENIED = 65 }

enum : uint { ERROR_BAD_DEV_TYPE = 66 }

enum : uint { ERROR_BAD_NET_NAME = 67 }

enum : uint { ERROR_TOO_MANY_NAMES = 68 }

enum : uint { ERROR_TOO_MANY_SESS = 69 }

enum : uint { ERROR_SHARING_PAUSED = 70 }

enum : uint { ERROR_REQ_NOT_ACCEP = 71 }

enum : uint { ERROR_REDIR_PAUSED = 72 }

enum : uint { ERROR_FILE_EXISTS = 80 }

enum : uint { ERROR_CANNOT_MAKE = 82 }

enum : uint { ERROR_FAIL_I24 = 83 }

enum : uint { ERROR_OUT_OF_STRUCTURES = 84 }

enum : uint { ERROR_ALREADY_ASSIGNED = 85 }

enum : uint { ERROR_INVALID_PASSWORD = 86 }

enum : uint { ERROR_INVALID_PARAMETER = 87 }

enum : uint { ERROR_NET_WRITE_FAULT = 88 }

enum : uint { ERROR_NO_PROC_SLOTS = 89 }

enum : uint { ERROR_TOO_MANY_SEMAPHORES = 100 }

enum : uint { ERROR_EXCL_SEM_ALREADY_OWNED = 101 }

enum : uint { ERROR_SEM_IS_SET = 102 }

enum : uint { ERROR_TOO_MANY_SEM_REQUESTS = 103 }

enum : uint { ERROR_INVALID_AT_INTERRUPT_TIME = 104 }

enum : uint { ERROR_SEM_OWNER_DIED = 105 }

enum : uint { ERROR_SEM_USER_LIMIT = 106 }

enum : uint { ERROR_DISK_CHANGE = 107 }

enum : uint { ERROR_DRIVE_LOCKED = 108 }

enum : uint { ERROR_BROKEN_PIPE = 109 }

enum : uint { ERROR_OPEN_FAILED = 110 }

enum : uint { ERROR_BUFFER_OVERFLOW = 111 }

enum : uint { ERROR_DISK_FULL = 112 }

enum : uint { ERROR_NO_MORE_SEARCH_HANDLES = 113 }

enum : uint { ERROR_INVALID_TARGET_HANDLE = 114 }

enum : uint { ERROR_INVALID_CATEGORY = 117 }

enum : uint { ERROR_INVALID_VERIFY_SWITCH = 118 }

enum : uint { ERROR_BAD_DRIVER_LEVEL = 119 }

enum : uint { ERROR_CALL_NOT_IMPLEMENTED = 120 }

enum : uint { ERROR_SEM_TIMEOUT = 121 }

enum : uint { ERROR_INSUFFICIENT_BUFFER = 122 }

enum : uint { ERROR_INVALID_NAME = 123 }

enum : uint { ERROR_INVALID_LEVEL = 124 }

enum : uint { ERROR_NO_VOLUME_LABEL = 125 }

enum : uint { ERROR_MOD_NOT_FOUND = 126 }

enum : uint { ERROR_PROC_NOT_FOUND = 127 }

enum : uint { ERROR_WAIT_NO_CHILDREN = 128 }

enum : uint { ERROR_CHILD_NOT_COMPLETE = 129 }

enum : uint { ERROR_DIRECT_ACCESS_HANDLE = 130 }

enum : uint { ERROR_NEGATIVE_SEEK = 131 }

enum : uint { ERROR_SEEK_ON_DEVICE = 132 }

enum : uint { ERROR_IS_JOIN_TARGET = 133 }

enum : uint { ERROR_IS_JOINED = 134 }

enum : uint { ERROR_IS_SUBSTED = 135 }

enum : uint { ERROR_NOT_JOINED = 136 }

enum : uint { ERROR_NOT_SUBSTED = 137 }

enum : uint { ERROR_JOIN_TO_JOIN = 138 }

enum : uint { ERROR_SUBST_TO_SUBST = 139 }

enum : uint { ERROR_JOIN_TO_SUBST = 140 }

enum : uint { ERROR_SUBST_TO_JOIN = 141 }

enum : uint { ERROR_BUSY_DRIVE = 142 }

enum : uint { ERROR_SAME_DRIVE = 143 }

enum : uint { ERROR_DIR_NOT_ROOT = 144 }

enum : uint { ERROR_DIR_NOT_EMPTY = 145 }

enum : uint { ERROR_IS_SUBST_PATH = 146 }

enum : uint { ERROR_IS_JOIN_PATH = 147 }

enum : uint { ERROR_PATH_BUSY = 148 }

enum : uint { ERROR_IS_SUBST_TARGET = 149 }

enum : uint { ERROR_SYSTEM_TRACE = 150 }

enum : uint { ERROR_INVALID_EVENT_COUNT = 151 }

enum : uint { ERROR_TOO_MANY_MUXWAITERS = 152 }

enum : uint { ERROR_INVALID_LIST_FORMAT = 153 }

enum : uint { ERROR_LABEL_TOO_LONG = 154 }

enum : uint { ERROR_TOO_MANY_TCBS = 155 }

enum : uint { ERROR_SIGNAL_REFUSED = 156 }

enum : uint { ERROR_DISCARDED = 157 }

enum : uint { ERROR_NOT_LOCKED = 158 }

enum : uint { ERROR_BAD_THREADID_ADDR = 159 }

enum : uint { ERROR_BAD_ARGUMENTS = 160 }

enum : uint { ERROR_BAD_PATHNAME = 161 }

enum : uint { ERROR_SIGNAL_PENDING = 162 }

enum : uint { ERROR_MAX_THRDS_REACHED = 164 }

enum : uint { ERROR_LOCK_FAILED = 167 }

enum : uint { ERROR_BUSY = 170 }

enum : uint { ERROR_CANCEL_VIOLATION = 173 }

enum : uint { ERROR_ATOMIC_LOCKS_NOT_SUPPORTED = 174 }

enum : uint { ERROR_INVALID_SEGMENT_NUMBER = 180 }

enum : uint { ERROR_INVALID_ORDINAL = 182 }

enum : uint { ERROR_ALREADY_EXISTS = 183 }

enum : uint { ERROR_INVALID_FLAG_NUMBER = 186 }

enum : uint { ERROR_SEM_NOT_FOUND = 187 }

enum : uint { ERROR_INVALID_STARTING_CODESEG = 188 }

enum : uint { ERROR_INVALID_STACKSEG = 189 }

enum : uint { ERROR_INVALID_MODULETYPE = 190 }

enum : uint { ERROR_INVALID_EXE_SIGNATURE = 191 }

enum : uint { ERROR_EXE_MARKED_INVALID = 192 }

enum : uint { ERROR_BAD_EXE_FORMAT = 193 }

enum : uint { ERROR_ITERATED_DATA_EXCEEDS_64k = 194 }

enum : uint { ERROR_INVALID_MINALLOCSIZE = 195 }

enum : uint { ERROR_DYNLINK_FROM_INVALID_RING = 196 }

enum : uint { ERROR_IOPL_NOT_ENABLED = 197 }

enum : uint { ERROR_INVALID_SEGDPL = 198 }

enum : uint { ERROR_AUTODATASEG_EXCEEDS_64k = 199 }

enum : uint { ERROR_RING2SEG_MUST_BE_MOVABLE = 200 }

enum : uint { ERROR_RELOC_CHAIN_XEEDS_SEGLIM = 201 }

enum : uint { ERROR_INFLOOP_IN_RELOC_CHAIN = 202 }

enum : uint { ERROR_ENVVAR_NOT_FOUND = 203 }

enum : uint { ERROR_NO_SIGNAL_SENT = 205 }

enum : uint { ERROR_FILENAME_EXCED_RANGE = 206 }

enum : uint { ERROR_RING2_STACK_IN_USE = 207 }

enum : uint { ERROR_META_EXPANSION_TOO_LONG = 208 }

enum : uint { ERROR_INVALID_SIGNAL_NUMBER = 209 }

enum : uint { ERROR_THREAD_1_INACTIVE = 210 }

enum : uint { ERROR_LOCKED = 212 }

enum : uint { ERROR_TOO_MANY_MODULES = 214 }

enum : uint { ERROR_NESTING_NOT_ALLOWED = 215 }

enum : uint { ERROR_EXE_MACHINE_TYPE_MISMATCH = 216 }

enum : uint { ERROR_BAD_PIPE = 230 }

enum : uint { ERROR_PIPE_BUSY = 231 }

enum : uint { ERROR_NO_DATA = 232 }

enum : uint { ERROR_PIPE_NOT_CONNECTED = 233 }

enum : uint { ERROR_MORE_DATA = 234 }

enum : uint { ERROR_VC_DISCONNECTED = 240 }

enum : uint { ERROR_INVALID_EA_NAME = 254 }

enum : uint { ERROR_EA_LIST_INCONSISTENT = 255 }

enum : uint { WAIT_TIMEOUT = 258 }

enum : uint { ERROR_NO_MORE_ITEMS = 259 }

enum : uint { ERROR_CANNOT_COPY = 266 }

enum : uint { ERROR_DIRECTORY = 267 }

enum : uint { ERROR_EAS_DIDNT_FIT = 275 }

enum : uint { ERROR_EA_FILE_CORRUPT = 276 }

enum : uint { ERROR_EA_TABLE_FULL = 277 }

enum : uint { ERROR_INVALID_EA_HANDLE = 278 }

enum : uint { ERROR_EAS_NOT_SUPPORTED = 282 }

enum : uint { ERROR_NOT_OWNER = 288 }

enum : uint { ERROR_TOO_MANY_POSTS = 298 }

enum : uint { ERROR_PARTIAL_COPY = 299 }

enum : uint { ERROR_OPLOCK_NOT_GRANTED = 300 }

enum : uint { ERROR_INVALID_OPLOCK_PROTOCOL = 301 }

enum : uint { ERROR_DISK_TOO_FRAGMENTED = 302 }

enum : uint { ERROR_DELETE_PENDING = 303 }

enum : uint { ERROR_MR_MID_NOT_FOUND = 317 }

enum : uint { ERROR_INVALID_ADDRESS = 487 }

enum : uint { ERROR_ARITHMETIC_OVERFLOW = 534 }

enum : uint { ERROR_PIPE_CONNECTED = 535 }

enum : uint { ERROR_PIPE_LISTENING = 536 }

enum : uint { ERROR_EA_ACCESS_DENIED = 994 }

enum : uint { ERROR_OPERATION_ABORTED = 995 }

enum : uint { ERROR_IO_INCOMPLETE = 996 }

enum : uint { ERROR_IO_PENDING = 997 }

enum : uint { ERROR_NOACCESS = 998 }

enum : uint { ERROR_SWAPERROR = 999 }

enum : uint { ERROR_STACK_OVERFLOW = 1001 }

enum : uint { ERROR_INVALID_MESSAGE = 1002 }

enum : uint { ERROR_CAN_NOT_COMPLETE = 1003 }

enum : uint { ERROR_INVALID_FLAGS = 1004 }

enum : uint { ERROR_UNRECOGNIZED_VOLUME = 1005 }

enum : uint { ERROR_FILE_INVALID = 1006 }

enum : uint { ERROR_FULLSCREEN_MODE = 1007 }

enum : uint { ERROR_NO_TOKEN = 1008 }

enum : uint { ERROR_BADDB = 1009 }

enum : uint { ERROR_BADKEY = 1010 }

enum : uint { ERROR_CANTOPEN = 1011 }

enum : uint { ERROR_CANTREAD = 1012 }

enum : uint { ERROR_CANTWRITE = 1013 }

enum : uint { ERROR_REGISTRY_RECOVERED = 1014 }

enum : uint { ERROR_REGISTRY_CORRUPT = 1015 }

enum : uint { ERROR_REGISTRY_IO_FAILED = 1016 }

enum : uint { ERROR_NOT_REGISTRY_FILE = 1017 }

enum : uint { ERROR_KEY_DELETED = 1018 }

enum : uint { ERROR_NO_LOG_SPACE = 1019 }

enum : uint { ERROR_KEY_HAS_CHILDREN = 1020 }

enum : uint { ERROR_CHILD_MUST_BE_VOLATILE = 1021 }

enum : uint { ERROR_NOTIFY_ENUM_DIR = 1022 }

enum : uint { ERROR_DEPENDENT_SERVICES_RUNNING = 1051 }

enum : uint { ERROR_INVALID_SERVICE_CONTROL = 1052 }

enum : uint { ERROR_SERVICE_REQUEST_TIMEOUT = 1053 }

enum : uint { ERROR_SERVICE_NO_THREAD = 1054 }

enum : uint { ERROR_SERVICE_DATABASE_LOCKED = 1055 }

enum : uint { ERROR_SERVICE_ALREADY_RUNNING = 1056 }

enum : uint { ERROR_INVALID_SERVICE_ACCOUNT = 1057 }

enum : uint { ERROR_SERVICE_DISABLED = 1058 }

enum : uint { ERROR_CIRCULAR_DEPENDENCY = 1059 }

enum : uint { ERROR_SERVICE_DOES_NOT_EXIST = 1060 }

enum : uint { ERROR_SERVICE_CANNOT_ACCEPT_CTRL = 1061 }

enum : uint { ERROR_SERVICE_NOT_ACTIVE = 1062 }

enum : uint { ERROR_FAILED_SERVICE_CONTROLLER_CONNECT = 1063 }

enum : uint { ERROR_EXCEPTION_IN_SERVICE = 1064 }

enum : uint { ERROR_DATABASE_DOES_NOT_EXIST = 1065 }

enum : uint { ERROR_SERVICE_SPECIFIC_ERROR = 1066 }

enum : uint { ERROR_PROCESS_ABORTED = 1067 }

enum : uint { ERROR_SERVICE_DEPENDENCY_FAIL = 1068 }

enum : uint { ERROR_SERVICE_LOGON_FAILED = 1069 }

enum : uint { ERROR_SERVICE_START_HANG = 1070 }

enum : uint { ERROR_INVALID_SERVICE_LOCK = 1071 }

enum : uint { ERROR_SERVICE_MARKED_FOR_DELETE = 1072 }

enum : uint { ERROR_SERVICE_EXISTS = 1073 }

enum : uint { ERROR_ALREADY_RUNNING_LKG = 1074 }

enum : uint { ERROR_SERVICE_DEPENDENCY_DELETED = 1075 }

enum : uint { ERROR_BOOT_ALREADY_ACCEPTED = 1076 }

enum : uint { ERROR_SERVICE_NEVER_STARTED = 1077 }

enum : uint { ERROR_DUPLICATE_SERVICE_NAME = 1078 }

enum : uint { ERROR_DIFFERENT_SERVICE_ACCOUNT = 1079 }

enum : uint { ERROR_CANNOT_DETECT_DRIVER_FAILURE = 1080 }

enum : uint { ERROR_CANNOT_DETECT_PROCESS_ABORT = 1081 }

enum : uint { ERROR_NO_RECOVERY_PROGRAM = 1082 }

enum : uint { ERROR_SERVICE_NOT_IN_EXE = 1083 }

enum : uint { ERROR_NOT_SAFEBOOT_SERVICE = 1084 }

enum : uint { ERROR_END_OF_MEDIA = 1100 }

enum : uint { ERROR_FILEMARK_DETECTED = 1101 }

enum : uint { ERROR_BEGINNING_OF_MEDIA = 1102 }

enum : uint { ERROR_SETMARK_DETECTED = 1103 }

enum : uint { ERROR_NO_DATA_DETECTED = 1104 }

enum : uint { ERROR_PARTITION_FAILURE = 1105 }

enum : uint { ERROR_INVALID_BLOCK_LENGTH = 1106 }

enum : uint { ERROR_DEVICE_NOT_PARTITIONED = 1107 }

enum : uint { ERROR_UNABLE_TO_LOCK_MEDIA = 1108 }

enum : uint { ERROR_UNABLE_TO_UNLOAD_MEDIA = 1109 }

enum : uint { ERROR_MEDIA_CHANGED = 1110 }

enum : uint { ERROR_BUS_RESET = 1111 }

enum : uint { ERROR_NO_MEDIA_IN_DRIVE = 1112 }

enum : uint { ERROR_NO_UNICODE_TRANSLATION = 1113 }

enum : uint { ERROR_DLL_INIT_FAILED = 1114 }

enum : uint { ERROR_SHUTDOWN_IN_PROGRESS = 1115 }

enum : uint { ERROR_NO_SHUTDOWN_IN_PROGRESS = 1116 }

enum : uint { ERROR_IO_DEVICE = 1117 }

enum : uint { ERROR_SERIAL_NO_DEVICE = 1118 }

enum : uint { ERROR_IRQ_BUSY = 1119 }

enum : uint { ERROR_MORE_WRITES = 1120 }

enum : uint { ERROR_COUNTER_TIMEOUT = 1121 }

enum : uint { ERROR_FLOPPY_ID_MARK_NOT_FOUND = 1122 }

enum : uint { ERROR_FLOPPY_WRONG_CYLINDER = 1123 }

enum : uint { ERROR_FLOPPY_UNKNOWN_ERROR = 1124 }

enum : uint { ERROR_FLOPPY_BAD_REGISTERS = 1125 }

enum : uint { ERROR_DISK_RECALIBRATE_FAILED = 1126 }

enum : uint { ERROR_DISK_OPERATION_FAILED = 1127 }

enum : uint { ERROR_DISK_RESET_FAILED = 1128 }

enum : uint { ERROR_EOM_OVERFLOW = 1129 }

enum : uint { ERROR_NOT_ENOUGH_SERVER_MEMORY = 1130 }

enum : uint { ERROR_POSSIBLE_DEADLOCK = 1131 }

enum : uint { ERROR_MAPPED_ALIGNMENT = 1132 }

enum : uint { ERROR_SET_POWER_STATE_VETOED = 1140 }

enum : uint { ERROR_SET_POWER_STATE_FAILED = 1141 }

enum : uint { ERROR_TOO_MANY_LINKS = 1142 }

enum : uint { ERROR_OLD_WIN_VERSION = 1150 }

enum : uint { ERROR_APP_WRONG_OS = 1151 }

enum : uint { ERROR_SINGLE_INSTANCE_APP = 1152 }

enum : uint { ERROR_RMODE_APP = 1153 }

enum : uint { ERROR_INVALID_DLL = 1154 }

enum : uint { ERROR_NO_ASSOCIATION = 1155 }

enum : uint { ERROR_DDE_FAIL = 1156 }

enum : uint { ERROR_DLL_NOT_FOUND = 1157 }

enum : uint { ERROR_NO_MORE_USER_HANDLES = 1158 }

enum : uint { ERROR_MESSAGE_SYNC_ONLY = 1159 }

enum : uint { ERROR_SOURCE_ELEMENT_EMPTY = 1160 }

enum : uint { ERROR_DESTINATION_ELEMENT_FULL = 1161 }

enum : uint { ERROR_ILLEGAL_ELEMENT_ADDRESS = 1162 }

enum : uint { ERROR_MAGAZINE_NOT_PRESENT = 1163 }

enum : uint { ERROR_DEVICE_REINITIALIZATION_NEEDED = 1164 }

enum : uint { ERROR_DEVICE_REQUIRES_CLEANING = 1165 }

enum : uint { ERROR_DEVICE_DOOR_OPEN = 1166 }

enum : uint { ERROR_DEVICE_NOT_CONNECTED = 1167 }

enum : uint { ERROR_NOT_FOUND = 1168 }

enum : uint { ERROR_NO_MATCH = 1169 }

enum : uint { ERROR_SET_NOT_FOUND = 1170 }

enum : uint { ERROR_POINT_NOT_FOUND = 1171 }

enum : uint { ERROR_NO_TRACKING_SERVICE = 1172 }

enum : uint { ERROR_NO_VOLUME_ID = 1173 }

enum : uint { ERROR_UNABLE_TO_REMOVE_REPLACED = 1175 }

enum : uint { ERROR_UNABLE_TO_MOVE_REPLACEMENT = 1176 }

enum : uint { ERROR_UNABLE_TO_MOVE_REPLACEMENT_2 = 1177 }

enum : uint { ERROR_JOURNAL_DELETE_IN_PROGRESS = 1178 }

enum : uint { ERROR_JOURNAL_NOT_ACTIVE = 1179 }

enum : uint { ERROR_POTENTIAL_FILE_FOUND = 1180 }

enum : uint { ERROR_JOURNAL_ENTRY_DELETED = 1181 }

enum : uint { ERROR_BAD_DEVICE = 1200 }

enum : uint { ERROR_CONNECTION_UNAVAIL = 1201 }

enum : uint { ERROR_DEVICE_ALREADY_REMEMBERED = 1202 }

enum : uint { ERROR_NO_NET_OR_BAD_PATH = 1203 }

enum : uint { ERROR_BAD_PROVIDER = 1204 }

enum : uint { ERROR_CANNOT_OPEN_PROFILE = 1205 }

enum : uint { ERROR_BAD_PROFILE = 1206 }

enum : uint { ERROR_NOT_CONTAINER = 1207 }

enum : uint { ERROR_EXTENDED_ERROR = 1208 }

enum : uint { ERROR_INVALID_GROUPNAME = 1209 }

enum : uint { ERROR_INVALID_COMPUTERNAME = 1210 }

enum : uint { ERROR_INVALID_EVENTNAME = 1211 }

enum : uint { ERROR_INVALID_DOMAINNAME = 1212 }

enum : uint { ERROR_INVALID_SERVICENAME = 1213 }

enum : uint { ERROR_INVALID_NETNAME = 1214 }

enum : uint { ERROR_INVALID_SHARENAME = 1215 }

enum : uint { ERROR_INVALID_PASSWORDNAME = 1216 }

enum : uint { ERROR_INVALID_MESSAGENAME = 1217 }

enum : uint { ERROR_INVALID_MESSAGEDEST = 1218 }

enum : uint { ERROR_SESSION_CREDENTIAL_CONFLICT = 1219 }

enum : uint { ERROR_REMOTE_SESSION_LIMIT_EXCEEDED = 1220 }

enum : uint { ERROR_DUP_DOMAINNAME = 1221 }

enum : uint { ERROR_NO_NETWORK = 1222 }

enum : uint { ERROR_CANCELLED = 1223 }

enum : uint { ERROR_USER_MAPPED_FILE = 1224 }

enum : uint { ERROR_CONNECTION_REFUSED = 1225 }

enum : uint { ERROR_GRACEFUL_DISCONNECT = 1226 }

enum : uint { ERROR_ADDRESS_ALREADY_ASSOCIATED = 1227 }

enum : uint { ERROR_ADDRESS_NOT_ASSOCIATED = 1228 }

enum : uint { ERROR_CONNECTION_INVALID = 1229 }

enum : uint { ERROR_CONNECTION_ACTIVE = 1230 }

enum : uint { ERROR_NETWORK_UNREACHABLE = 1231 }

enum : uint { ERROR_HOST_UNREACHABLE = 1232 }

enum : uint { ERROR_PROTOCOL_UNREACHABLE = 1233 }

enum : uint { ERROR_PORT_UNREACHABLE = 1234 }

enum : uint { ERROR_REQUEST_ABORTED = 1235 }

enum : uint { ERROR_CONNECTION_ABORTED = 1236 }

enum : uint { ERROR_RETRY = 1237 }

enum : uint { ERROR_CONNECTION_COUNT_LIMIT = 1238 }

enum : uint { ERROR_LOGIN_TIME_RESTRICTION = 1239 }

enum : uint { ERROR_LOGIN_WKSTA_RESTRICTION = 1240 }

enum : uint { ERROR_INCORRECT_ADDRESS = 1241 }

enum : uint { ERROR_ALREADY_REGISTERED = 1242 }

enum : uint { ERROR_SERVICE_NOT_FOUND = 1243 }

enum : uint { ERROR_NOT_AUTHENTICATED = 1244 }

enum : uint { ERROR_NOT_LOGGED_ON = 1245 }

enum : uint { ERROR_CONTINUE = 1246 }

enum : uint { ERROR_ALREADY_INITIALIZED = 1247 }

enum : uint { ERROR_NO_MORE_DEVICES = 1248 }

enum : uint { ERROR_NO_SUCH_SITE = 1249 }

enum : uint { ERROR_DOMAIN_CONTROLLER_EXISTS = 1250 }

enum : uint { ERROR_ONLY_IF_CONNECTED = 1251 }

enum : uint { ERROR_OVERRIDE_NOCHANGES = 1252 }

enum : uint { ERROR_BAD_USER_PROFILE = 1253 }

enum : uint { ERROR_NOT_SUPPORTED_ON_SBS = 1254 }

enum : uint { ERROR_SERVER_SHUTDOWN_IN_PROGRESS = 1255 }

enum : uint { ERROR_HOST_DOWN = 1256 }

enum : uint { ERROR_NON_ACCOUNT_SID = 1257 }

enum : uint { ERROR_NON_DOMAIN_SID = 1258 }

enum : uint { ERROR_APPHELP_BLOCK = 1259 }

enum : uint { ERROR_ACCESS_DISABLED_BY_POLICY = 1260 }

enum : uint { ERROR_REG_NAT_CONSUMPTION = 1261 }

enum : uint { ERROR_CSCSHARE_OFFLINE = 1262 }

enum : uint { ERROR_PKINIT_FAILURE = 1263 }

enum : uint { ERROR_SMARTCARD_SUBSYSTEM_FAILURE = 1264 }

enum : uint { ERROR_DOWNGRADE_DETECTED = 1265 }

enum : uint { SEC_E_SMARTCARD_CERT_REVOKED = 1266 }

enum : uint { SEC_E_ISSUING_CA_UNTRUSTED = 1267 }

enum : uint { SEC_E_REVOCATION_OFFLINE_C = 1268 }

enum : uint { SEC_E_PKINIT_CLIENT_FAILURE = 1269 }

enum : uint { SEC_E_SMARTCARD_CERT_EXPIRED = 1270 }

enum : uint { ERROR_MACHINE_LOCKED = 1271 }

enum : uint { ERROR_CALLBACK_SUPPLIED_INVALID_DATA = 1273 }

enum : uint { ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED = 1274 }

enum : uint { ERROR_DRIVER_BLOCKED = 1275 }

enum : uint { ERROR_INVALID_IMPORT_OF_NON_DLL = 1276 }

enum : uint { ERROR_NOT_ALL_ASSIGNED = 1300 }

enum : uint { ERROR_SOME_NOT_MAPPED = 1301 }

enum : uint { ERROR_NO_QUOTAS_FOR_ACCOUNT = 1302 }

enum : uint { ERROR_LOCAL_USER_SESSION_KEY = 1303 }

enum : uint { ERROR_NULL_LM_PASSWORD = 1304 }

enum : uint { ERROR_UNKNOWN_REVISION = 1305 }

enum : uint { ERROR_REVISION_MISMATCH = 1306 }

enum : uint { ERROR_INVALID_OWNER = 1307 }

enum : uint { ERROR_INVALID_PRIMARY_GROUP = 1308 }

enum : uint { ERROR_NO_IMPERSONATION_TOKEN = 1309 }

enum : uint { ERROR_CANT_DISABLE_MANDATORY = 1310 }

enum : uint { ERROR_NO_LOGON_SERVERS = 1311 }

enum : uint { ERROR_NO_SUCH_LOGON_SESSION = 1312 }

enum : uint { ERROR_NO_SUCH_PRIVILEGE = 1313 }

enum : uint { ERROR_PRIVILEGE_NOT_HELD = 1314 }

enum : uint { ERROR_INVALID_ACCOUNT_NAME = 1315 }

enum : uint { ERROR_USER_EXISTS = 1316 }

enum : uint { ERROR_NO_SUCH_USER = 1317 }

enum : uint { ERROR_GROUP_EXISTS = 1318 }

enum : uint { ERROR_NO_SUCH_GROUP = 1319 }

enum : uint { ERROR_MEMBER_IN_GROUP = 1320 }

enum : uint { ERROR_MEMBER_NOT_IN_GROUP = 1321 }

enum : uint { ERROR_LAST_ADMIN = 1322 }

enum : uint { ERROR_WRONG_PASSWORD = 1323 }

enum : uint { ERROR_ILL_FORMED_PASSWORD = 1324 }

enum : uint { ERROR_PASSWORD_RESTRICTION = 1325 }

enum : uint { ERROR_LOGON_FAILURE = 1326 }

enum : uint { ERROR_ACCOUNT_RESTRICTION = 1327 }

enum : uint { ERROR_INVALID_LOGON_HOURS = 1328 }

enum : uint { ERROR_INVALID_WORKSTATION = 1329 }

enum : uint { ERROR_PASSWORD_EXPIRED = 1330 }

enum : uint { ERROR_ACCOUNT_DISABLED = 1331 }

enum : uint { ERROR_NONE_MAPPED = 1332 }

enum : uint { ERROR_TOO_MANY_LUIDS_REQUESTED = 1333 }

enum : uint { ERROR_LUIDS_EXHAUSTED = 1334 }

enum : uint { ERROR_INVALID_SUB_AUTHORITY = 1335 }

enum : uint { ERROR_INVALID_ACL = 1336 }

enum : uint { ERROR_INVALID_SID = 1337 }

enum : uint { ERROR_INVALID_SECURITY_DESCR = 1338 }

enum : uint { ERROR_BAD_INHERITANCE_ACL = 1340 }

enum : uint { ERROR_SERVER_DISABLED = 1341 }

enum : uint { ERROR_SERVER_NOT_DISABLED = 1342 }

enum : uint { ERROR_INVALID_ID_AUTHORITY = 1343 }

enum : uint { ERROR_ALLOTTED_SPACE_EXCEEDED = 1344 }

enum : uint { ERROR_INVALID_GROUP_ATTRIBUTES = 1345 }

enum : uint { ERROR_BAD_IMPERSONATION_LEVEL = 1346 }

enum : uint { ERROR_CANT_OPEN_ANONYMOUS = 1347 }

enum : uint { ERROR_BAD_VALIDATION_CLASS = 1348 }

enum : uint { ERROR_BAD_TOKEN_TYPE = 1349 }

enum : uint { ERROR_NO_SECURITY_ON_OBJECT = 1350 }

enum : uint { ERROR_CANT_ACCESS_DOMAIN_INFO = 1351 }

enum : uint { ERROR_INVALID_SERVER_STATE = 1352 }

enum : uint { ERROR_INVALID_DOMAIN_STATE = 1353 }

enum : uint { ERROR_INVALID_DOMAIN_ROLE = 1354 }

enum : uint { ERROR_NO_SUCH_DOMAIN = 1355 }

enum : uint { ERROR_DOMAIN_EXISTS = 1356 }

enum : uint { ERROR_DOMAIN_LIMIT_EXCEEDED = 1357 }

enum : uint { ERROR_INTERNAL_DB_CORRUPTION = 1358 }

enum : uint { ERROR_INTERNAL_ERROR = 1359 }

enum : uint { ERROR_GENERIC_NOT_MAPPED = 1360 }

enum : uint { ERROR_BAD_DESCRIPTOR_FORMAT = 1361 }

enum : uint { ERROR_NOT_LOGON_PROCESS = 1362 }

enum : uint { ERROR_LOGON_SESSION_EXISTS = 1363 }

enum : uint { ERROR_NO_SUCH_PACKAGE = 1364 }

enum : uint { ERROR_BAD_LOGON_SESSION_STATE = 1365 }

enum : uint { ERROR_LOGON_SESSION_COLLISION = 1366 }

enum : uint { ERROR_INVALID_LOGON_TYPE = 1367 }

enum : uint { ERROR_CANNOT_IMPERSONATE = 1368 }

enum : uint { ERROR_RXACT_INVALID_STATE = 1369 }

enum : uint { ERROR_RXACT_COMMIT_FAILURE = 1370 }

enum : uint { ERROR_SPECIAL_ACCOUNT = 1371 }

enum : uint { ERROR_SPECIAL_GROUP = 1372 }

enum : uint { ERROR_SPECIAL_USER = 1373 }

enum : uint { ERROR_MEMBERS_PRIMARY_GROUP = 1374 }

enum : uint { ERROR_TOKEN_ALREADY_IN_USE = 1375 }

enum : uint { ERROR_NO_SUCH_ALIAS = 1376 }

enum : uint { ERROR_MEMBER_NOT_IN_ALIAS = 1377 }

enum : uint { ERROR_MEMBER_IN_ALIAS = 1378 }

enum : uint { ERROR_ALIAS_EXISTS = 1379 }

enum : uint { ERROR_LOGON_NOT_GRANTED = 1380 }

enum : uint { ERROR_TOO_MANY_SECRETS = 1381 }

enum : uint { ERROR_SECRET_TOO_LONG = 1382 }

enum : uint { ERROR_INTERNAL_DB_ERROR = 1383 }

enum : uint { ERROR_TOO_MANY_CONTEXT_IDS = 1384 }

enum : uint { ERROR_LOGON_TYPE_NOT_GRANTED = 1385 }

enum : uint { ERROR_NT_CROSS_ENCRYPTION_REQUIRED = 1386 }

enum : uint { ERROR_NO_SUCH_MEMBER = 1387 }

enum : uint { ERROR_INVALID_MEMBER = 1388 }

enum : uint { ERROR_TOO_MANY_SIDS = 1389 }

enum : uint { ERROR_LM_CROSS_ENCRYPTION_REQUIRED = 1390 }

enum : uint { ERROR_NO_INHERITANCE = 1391 }

enum : uint { ERROR_FILE_CORRUPT = 1392 }

enum : uint { ERROR_DISK_CORRUPT = 1393 }

enum : uint { ERROR_NO_USER_SESSION_KEY = 1394 }

enum : uint { ERROR_LICENSE_QUOTA_EXCEEDED = 1395 }

enum : uint { ERROR_WRONG_TARGET_NAME = 1396 }

enum : uint { ERROR_MUTUAL_AUTH_FAILED = 1397 }

enum : uint { ERROR_TIME_SKEW = 1398 }

enum : uint { ERROR_CURRENT_DOMAIN_NOT_ALLOWED = 1399 }

enum : uint { ERROR_INVALID_WINDOW_HANDLE = 1400 }

enum : uint { ERROR_INVALID_MENU_HANDLE = 1401 }

enum : uint { ERROR_INVALID_CURSOR_HANDLE = 1402 }

enum : uint { ERROR_INVALID_ACCEL_HANDLE = 1403 }

enum : uint { ERROR_INVALID_HOOK_HANDLE = 1404 }

enum : uint { ERROR_INVALID_DWP_HANDLE = 1405 }

enum : uint { ERROR_TLW_WITH_WSCHILD = 1406 }

enum : uint { ERROR_CANNOT_FIND_WND_CLASS = 1407 }

enum : uint { ERROR_WINDOW_OF_OTHER_THREAD = 1408 }

enum : uint { ERROR_HOTKEY_ALREADY_REGISTERED = 1409 }

enum : uint { ERROR_CLASS_ALREADY_EXISTS = 1410 }

enum : uint { ERROR_CLASS_DOES_NOT_EXIST = 1411 }

enum : uint { ERROR_CLASS_HAS_WINDOWS = 1412 }

enum : uint { ERROR_INVALID_INDEX = 1413 }

enum : uint { ERROR_INVALID_ICON_HANDLE = 1414 }

enum : uint { ERROR_PRIVATE_DIALOG_INDEX = 1415 }

enum : uint { ERROR_LISTBOX_ID_NOT_FOUND = 1416 }

enum : uint { ERROR_NO_WILDCARD_CHARACTERS = 1417 }

enum : uint { ERROR_CLIPBOARD_NOT_OPEN = 1418 }

enum : uint { ERROR_HOTKEY_NOT_REGISTERED = 1419 }

enum : uint { ERROR_WINDOW_NOT_DIALOG = 1420 }

enum : uint { ERROR_CONTROL_ID_NOT_FOUND = 1421 }

enum : uint { ERROR_INVALID_COMBOBOX_MESSAGE = 1422 }

enum : uint { ERROR_WINDOW_NOT_COMBOBOX = 1423 }

enum : uint { ERROR_INVALID_EDIT_HEIGHT = 1424 }

enum : uint { ERROR_DC_NOT_FOUND = 1425 }

enum : uint { ERROR_INVALID_HOOK_FILTER = 1426 }

enum : uint { ERROR_INVALID_FILTER_PROC = 1427 }

enum : uint { ERROR_HOOK_NEEDS_HMOD = 1428 }

enum : uint { ERROR_GLOBAL_ONLY_HOOK = 1429 }

enum : uint { ERROR_JOURNAL_HOOK_SET = 1430 }

enum : uint { ERROR_HOOK_NOT_INSTALLED = 1431 }

enum : uint { ERROR_INVALID_LB_MESSAGE = 1432 }

enum : uint { ERROR_SETCOUNT_ON_BAD_LB = 1433 }

enum : uint { ERROR_LB_WITHOUT_TABSTOPS = 1434 }

enum : uint { ERROR_DESTROY_OBJECT_OF_OTHER_THREAD = 1435 }

enum : uint { ERROR_CHILD_WINDOW_MENU = 1436 }

enum : uint { ERROR_NO_SYSTEM_MENU = 1437 }

enum : uint { ERROR_INVALID_MSGBOX_STYLE = 1438 }

enum : uint { ERROR_INVALID_SPI_VALUE = 1439 }

enum : uint { ERROR_SCREEN_ALREADY_LOCKED = 1440 }

enum : uint { ERROR_HWNDS_HAVE_DIFF_PARENT = 1441 }

enum : uint { ERROR_NOT_CHILD_WINDOW = 1442 }

enum : uint { ERROR_INVALID_GW_COMMAND = 1443 }

enum : uint { ERROR_INVALID_THREAD_ID = 1444 }

enum : uint { ERROR_NON_MDICHILD_WINDOW = 1445 }

enum : uint { ERROR_POPUP_ALREADY_ACTIVE = 1446 }

enum : uint { ERROR_NO_SCROLLBARS = 1447 }

enum : uint { ERROR_INVALID_SCROLLBAR_RANGE = 1448 }

enum : uint { ERROR_INVALID_SHOWWIN_COMMAND = 1449 }

enum : uint { ERROR_NO_SYSTEM_RESOURCES = 1450 }

enum : uint { ERROR_NONPAGED_SYSTEM_RESOURCES = 1451 }

enum : uint { ERROR_PAGED_SYSTEM_RESOURCES = 1452 }

enum : uint { ERROR_WORKING_SET_QUOTA = 1453 }

enum : uint { ERROR_PAGEFILE_QUOTA = 1454 }

enum : uint { ERROR_COMMITMENT_LIMIT = 1455 }

enum : uint { ERROR_MENU_ITEM_NOT_FOUND = 1456 }

enum : uint { ERROR_INVALID_KEYBOARD_HANDLE = 1457 }

enum : uint { ERROR_HOOK_TYPE_NOT_ALLOWED = 1458 }

enum : uint { ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION = 1459 }

enum : uint { ERROR_TIMEOUT = 1460 }

enum : uint { ERROR_INVALID_MONITOR_HANDLE = 1461 }

enum : uint { ERROR_EVENTLOG_FILE_CORRUPT = 1500 }

enum : uint { ERROR_EVENTLOG_CANT_START = 1501 }

enum : uint { ERROR_LOG_FILE_FULL = 1502 }

enum : uint { ERROR_EVENTLOG_FILE_CHANGED = 1503 }

enum : uint { ERROR_INSTALL_SERVICE_FAILURE = 1601 }

enum : uint { ERROR_INSTALL_USEREXIT = 1602 }

enum : uint { ERROR_INSTALL_FAILURE = 1603 }

enum : uint { ERROR_INSTALL_SUSPEND = 1604 }

enum : uint { ERROR_UNKNOWN_PRODUCT = 1605 }

enum : uint { ERROR_UNKNOWN_FEATURE = 1606 }

enum : uint { ERROR_UNKNOWN_COMPONENT = 1607 }

enum : uint { ERROR_UNKNOWN_PROPERTY = 1608 }

enum : uint { ERROR_INVALID_HANDLE_STATE = 1609 }

enum : uint { ERROR_BAD_CONFIGURATION = 1610 }

enum : uint { ERROR_INDEX_ABSENT = 1611 }

enum : uint { ERROR_INSTALL_SOURCE_ABSENT = 1612 }

enum : uint { ERROR_INSTALL_PACKAGE_VERSION = 1613 }

enum : uint { ERROR_PRODUCT_UNINSTALLED = 1614 }

enum : uint { ERROR_BAD_QUERY_SYNTAX = 1615 }

enum : uint { ERROR_INVALID_FIELD = 1616 }

enum : uint { ERROR_DEVICE_REMOVED = 1617 }

enum : uint { ERROR_INSTALL_ALREADY_RUNNING = 1618 }

enum : uint { ERROR_INSTALL_PACKAGE_OPEN_FAILED = 1619 }

enum : uint { ERROR_INSTALL_PACKAGE_INVALID = 1620 }

enum : uint { ERROR_INSTALL_UI_FAILURE = 1621 }

enum : uint { ERROR_INSTALL_LOG_FAILURE = 1622 }

enum : uint { ERROR_INSTALL_LANGUAGE_UNSUPPORTED = 1623 }

enum : uint { ERROR_INSTALL_TRANSFORM_FAILURE = 1624 }

enum : uint { ERROR_INSTALL_PACKAGE_REJECTED = 1625 }

enum : uint { ERROR_FUNCTION_NOT_CALLED = 1626 }

enum : uint { ERROR_FUNCTION_FAILED = 1627 }

enum : uint { ERROR_INVALID_TABLE = 1628 }

enum : uint { ERROR_DATATYPE_MISMATCH = 1629 }

enum : uint { ERROR_UNSUPPORTED_TYPE = 1630 }

enum : uint { ERROR_CREATE_FAILED = 1631 }

enum : uint { ERROR_INSTALL_TEMP_UNWRITABLE = 1632 }

enum : uint { ERROR_INSTALL_PLATFORM_UNSUPPORTED = 1633 }

enum : uint { ERROR_INSTALL_NOTUSED = 1634 }

enum : uint { ERROR_PATCH_PACKAGE_OPEN_FAILED = 1635 }

enum : uint { ERROR_PATCH_PACKAGE_INVALID = 1636 }

enum : uint { ERROR_PATCH_PACKAGE_UNSUPPORTED = 1637 }

enum : uint { ERROR_PRODUCT_VERSION = 1638 }

enum : uint { ERROR_INVALID_COMMAND_LINE = 1639 }

enum : uint { ERROR_INSTALL_REMOTE_DISALLOWED = 1640 }

enum : uint { ERROR_SUCCESS_REBOOT_INITIATED = 1641 }

enum : uint { ERROR_PATCH_TARGET_NOT_FOUND = 1642 }

enum : uint { ERROR_PATCH_PACKAGE_REJECTED = 1643 }

enum : uint { ERROR_INSTALL_TRANSFORM_REJECTED = 1644 }

enum : uint { RPC_S_INVALID_STRING_BINDING = 1700 }

enum : uint { RPC_S_WRONG_KIND_OF_BINDING = 1701 }

enum : uint { RPC_S_INVALID_BINDING = 1702 }

enum : uint { RPC_S_PROTSEQ_NOT_SUPPORTED = 1703 }

enum : uint { RPC_S_INVALID_RPC_PROTSEQ = 1704 }

enum : uint { RPC_S_INVALID_STRING_UUID = 1705 }

enum : uint { RPC_S_INVALID_ENDPOINT_FORMAT = 1706 }

enum : uint { RPC_S_INVALID_NET_ADDR = 1707 }

enum : uint { RPC_S_NO_ENDPOINT_FOUND = 1708 }

enum : uint { RPC_S_INVALID_TIMEOUT = 1709 }

enum : uint { RPC_S_OBJECT_NOT_FOUND = 1710 }

enum : uint { RPC_S_ALREADY_REGISTERED = 1711 }

enum : uint { RPC_S_TYPE_ALREADY_REGISTERED = 1712 }

enum : uint { RPC_S_ALREADY_LISTENING = 1713 }

enum : uint { RPC_S_NO_PROTSEQS_REGISTERED = 1714 }

enum : uint { RPC_S_NOT_LISTENING = 1715 }

enum : uint { RPC_S_UNKNOWN_MGR_TYPE = 1716 }

enum : uint { RPC_S_UNKNOWN_IF = 1717 }

enum : uint { RPC_S_NO_BINDINGS = 1718 }

enum : uint { RPC_S_NO_PROTSEQS = 1719 }

enum : uint { RPC_S_CANT_CREATE_ENDPOINT = 1720 }

enum : uint { RPC_S_OUT_OF_RESOURCES = 1721 }

enum : uint { RPC_S_SERVER_UNAVAILABLE = 1722 }

enum : uint { RPC_S_SERVER_TOO_BUSY = 1723 }

enum : uint { RPC_S_INVALID_NETWORK_OPTIONS = 1724 }

enum : uint { RPC_S_NO_CALL_ACTIVE = 1725 }

enum : uint { RPC_S_CALL_FAILED = 1726 }

enum : uint { RPC_S_CALL_FAILED_DNE = 1727 }

enum : uint { RPC_S_PROTOCOL_ERROR = 1728 }

enum : uint { RPC_S_UNSUPPORTED_TRANS_SYN = 1730 }

enum : uint { RPC_S_UNSUPPORTED_TYPE = 1732 }

enum : uint { RPC_S_INVALID_TAG = 1733 }

enum : uint { RPC_S_INVALID_BOUND = 1734 }

enum : uint { RPC_S_NO_ENTRY_NAME = 1735 }

enum : uint { RPC_S_INVALID_NAME_SYNTAX = 1736 }

enum : uint { RPC_S_UNSUPPORTED_NAME_SYNTAX = 1737 }

enum : uint { RPC_S_UUID_NO_ADDRESS = 1739 }

enum : uint { RPC_S_DUPLICATE_ENDPOINT = 1740 }

enum : uint { RPC_S_UNKNOWN_AUTHN_TYPE = 1741 }

enum : uint { RPC_S_MAX_CALLS_TOO_SMALL = 1742 }

enum : uint { RPC_S_STRING_TOO_LONG = 1743 }

enum : uint { RPC_S_PROTSEQ_NOT_FOUND = 1744 }

enum : uint { RPC_S_PROCNUM_OUT_OF_RANGE = 1745 }

enum : uint { RPC_S_BINDING_HAS_NO_AUTH = 1746 }

enum : uint { RPC_S_UNKNOWN_AUTHN_SERVICE = 1747 }

enum : uint { RPC_S_UNKNOWN_AUTHN_LEVEL = 1748 }

enum : uint { RPC_S_INVALID_AUTH_IDENTITY = 1749 }

enum : uint { RPC_S_UNKNOWN_AUTHZ_SERVICE = 1750 }

enum : uint { EPT_S_INVALID_ENTRY = 1751 }

enum : uint { EPT_S_CANT_PERFORM_OP = 1752 }

enum : uint { EPT_S_NOT_REGISTERED = 1753 }

enum : uint { RPC_S_NOTHING_TO_EXPORT = 1754 }

enum : uint { RPC_S_INCOMPLETE_NAME = 1755 }

enum : uint { RPC_S_INVALID_VERS_OPTION = 1756 }

enum : uint { RPC_S_NO_MORE_MEMBERS = 1757 }

enum : uint { RPC_S_NOT_ALL_OBJS_UNEXPORTED = 1758 }

enum : uint { RPC_S_INTERFACE_NOT_FOUND = 1759 }

enum : uint { RPC_S_ENTRY_ALREADY_EXISTS = 1760 }

enum : uint { RPC_S_ENTRY_NOT_FOUND = 1761 }

enum : uint { RPC_S_NAME_SERVICE_UNAVAILABLE = 1762 }

enum : uint { RPC_S_INVALID_NAF_ID = 1763 }

enum : uint { RPC_S_CANNOT_SUPPORT = 1764 }

enum : uint { RPC_S_NO_CONTEXT_AVAILABLE = 1765 }

enum : uint { RPC_S_INTERNAL_ERROR = 1766 }

enum : uint { RPC_S_ZERO_DIVIDE = 1767 }

enum : uint { RPC_S_ADDRESS_ERROR = 1768 }

enum : uint { RPC_S_FP_DIV_ZERO = 1769 }

enum : uint { RPC_S_FP_UNDERFLOW = 1770 }

enum : uint { RPC_S_FP_OVERFLOW = 1771 }

enum : uint { RPC_X_NO_MORE_ENTRIES = 1772 }

enum : uint { RPC_X_SS_CHAR_TRANS_OPEN_FAIL = 1773 }

enum : uint { RPC_X_SS_CHAR_TRANS_SHORT_FILE = 1774 }

enum : uint { RPC_X_SS_IN_NULL_CONTEXT = 1775 }

enum : uint { RPC_X_SS_CONTEXT_DAMAGED = 1777 }

enum : uint { RPC_X_SS_HANDLES_MISMATCH = 1778 }

enum : uint { RPC_X_SS_CANNOT_GET_CALL_HANDLE = 1779 }

enum : uint { RPC_X_NULL_REF_POINTER = 1780 }

enum : uint { RPC_X_ENUM_VALUE_OUT_OF_RANGE = 1781 }

enum : uint { RPC_X_BYTE_COUNT_TOO_SMALL = 1782 }

enum : uint { RPC_X_BAD_STUB_DATA = 1783 }

enum : uint { ERROR_INVALID_USER_BUFFER = 1784 }

enum : uint { ERROR_UNRECOGNIZED_MEDIA = 1785 }

enum : uint { ERROR_NO_TRUST_LSA_SECRET = 1786 }

enum : uint { ERROR_NO_TRUST_SAM_ACCOUNT = 1787 }

enum : uint { ERROR_TRUSTED_DOMAIN_FAILURE = 1788 }

enum : uint { ERROR_TRUSTED_RELATIONSHIP_FAILURE = 1789 }

enum : uint { ERROR_TRUST_FAILURE = 1790 }

enum : uint { RPC_S_CALL_IN_PROGRESS = 1791 }

enum : uint { ERROR_NETLOGON_NOT_STARTED = 1792 }

enum : uint { ERROR_ACCOUNT_EXPIRED = 1793 }

enum : uint { ERROR_REDIRECTOR_HAS_OPEN_HANDLES = 1794 }

enum : uint { ERROR_PRINTER_DRIVER_ALREADY_INSTALLED = 1795 }

enum : uint { ERROR_UNKNOWN_PORT = 1796 }

enum : uint { ERROR_UNKNOWN_PRINTER_DRIVER = 1797 }

enum : uint { ERROR_UNKNOWN_PRINTPROCESSOR = 1798 }

enum : uint { ERROR_INVALID_SEPARATOR_FILE = 1799 }

enum : uint { ERROR_INVALID_PRIORITY = 1800 }

enum : uint { ERROR_INVALID_PRINTER_NAME = 1801 }

enum : uint { ERROR_PRINTER_ALREADY_EXISTS = 1802 }

enum : uint { ERROR_INVALID_PRINTER_COMMAND = 1803 }

enum : uint { ERROR_INVALID_DATATYPE = 1804 }

enum : uint { ERROR_INVALID_ENVIRONMENT = 1805 }

enum : uint { RPC_S_NO_MORE_BINDINGS = 1806 }

enum : uint { ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT = 1807 }

enum : uint { ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT = 1808 }

enum : uint { ERROR_NOLOGON_SERVER_TRUST_ACCOUNT = 1809 }

enum : uint { ERROR_DOMAIN_TRUST_INCONSISTENT = 1810 }

enum : uint { ERROR_SERVER_HAS_OPEN_HANDLES = 1811 }

enum : uint { ERROR_RESOURCE_DATA_NOT_FOUND = 1812 }

enum : uint { ERROR_RESOURCE_TYPE_NOT_FOUND = 1813 }

enum : uint { ERROR_RESOURCE_NAME_NOT_FOUND = 1814 }

enum : uint { ERROR_RESOURCE_LANG_NOT_FOUND = 1815 }

enum : uint { ERROR_NOT_ENOUGH_QUOTA = 1816 }

enum : uint { RPC_S_NO_INTERFACES = 1817 }

enum : uint { RPC_S_CALL_CANCELLED = 1818 }

enum : uint { RPC_S_BINDING_INCOMPLETE = 1819 }

enum : uint { RPC_S_COMM_FAILURE = 1820 }

enum : uint { RPC_S_UNSUPPORTED_AUTHN_LEVEL = 1821 }

enum : uint { RPC_S_NO_PRINC_NAME = 1822 }

enum : uint { RPC_S_NOT_RPC_ERROR = 1823 }

enum : uint { RPC_S_UUID_LOCAL_ONLY = 1824 }

enum : uint { RPC_S_SEC_PKG_ERROR = 1825 }

enum : uint { RPC_S_NOT_CANCELLED = 1826 }

enum : uint { RPC_X_INVALID_ES_ACTION = 1827 }

enum : uint { RPC_X_WRONG_ES_VERSION = 1828 }

enum : uint { RPC_X_WRONG_STUB_VERSION = 1829 }

enum : uint { RPC_X_INVALID_PIPE_OBJECT = 1830 }

enum : uint { RPC_X_WRONG_PIPE_ORDER = 1831 }

enum : uint { RPC_X_WRONG_PIPE_VERSION = 1832 }

enum : uint { RPC_S_GROUP_MEMBER_NOT_FOUND = 1898 }

enum : uint { EPT_S_CANT_CREATE = 1899 }

enum : uint { RPC_S_INVALID_OBJECT = 1900 }

enum : uint { ERROR_INVALID_TIME = 1901 }

enum : uint { ERROR_INVALID_FORM_NAME = 1902 }

enum : uint { ERROR_INVALID_FORM_SIZE = 1903 }

enum : uint { ERROR_ALREADY_WAITING = 1904 }

enum : uint { ERROR_PRINTER_DELETED = 1905 }

enum : uint { ERROR_INVALID_PRINTER_STATE = 1906 }

enum : uint { ERROR_PASSWORD_MUST_CHANGE = 1907 }

enum : uint { ERROR_DOMAIN_CONTROLLER_NOT_FOUND = 1908 }

enum : uint { ERROR_ACCOUNT_LOCKED_OUT = 1909 }

enum : uint { OR_INVALID_OXID = 1910 }

enum : uint { OR_INVALID_OID = 1911 }

enum : uint { OR_INVALID_SET = 1912 }

enum : uint { RPC_S_SEND_INCOMPLETE = 1913 }

enum : uint { RPC_S_INVALID_ASYNC_HANDLE = 1914 }

enum : uint { RPC_S_INVALID_ASYNC_CALL = 1915 }

enum : uint { RPC_X_PIPE_CLOSED = 1916 }

enum : uint { RPC_X_PIPE_DISCIPLINE_ERROR = 1917 }

enum : uint { RPC_X_PIPE_EMPTY = 1918 }

enum : uint { ERROR_NO_SITENAME = 1919 }

enum : uint { ERROR_CANT_ACCESS_FILE = 1920 }

enum : uint { ERROR_CANT_RESOLVE_FILENAME = 1921 }

enum : uint { RPC_S_ENTRY_TYPE_MISMATCH = 1922 }

enum : uint { RPC_S_NOT_ALL_OBJS_EXPORTED = 1923 }

enum : uint { RPC_S_INTERFACE_NOT_EXPORTED = 1924 }

enum : uint { RPC_S_PROFILE_NOT_ADDED = 1925 }

enum : uint { RPC_S_PRF_ELT_NOT_ADDED = 1926 }

enum : uint { RPC_S_PRF_ELT_NOT_REMOVED = 1927 }

enum : uint { RPC_S_GRP_ELT_NOT_ADDED = 1928 }

enum : uint { RPC_S_GRP_ELT_NOT_REMOVED = 1929 }

enum : uint { ERROR_KM_DRIVER_BLOCKED = 1930 }

enum : uint { ERROR_CONTEXT_EXPIRED = 1931 }

enum : uint { ERROR_INVALID_PIXEL_FORMAT = 2000 }

enum : uint { ERROR_BAD_DRIVER = 2001 }

enum : uint { ERROR_INVALID_WINDOW_STYLE = 2002 }

enum : uint { ERROR_METAFILE_NOT_SUPPORTED = 2003 }

enum : uint { ERROR_TRANSFORM_NOT_SUPPORTED = 2004 }

enum : uint { ERROR_CLIPPING_NOT_SUPPORTED = 2005 }

enum : uint { ERROR_INVALID_CMM = 2010 }

enum : uint { ERROR_INVALID_PROFILE = 2011 }

enum : uint { ERROR_TAG_NOT_FOUND = 2012 }

enum : uint { ERROR_TAG_NOT_PRESENT = 2013 }

enum : uint { ERROR_DUPLICATE_TAG = 2014 }

enum : uint { ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE = 2015 }

enum : uint { ERROR_PROFILE_NOT_FOUND = 2016 }

enum : uint { ERROR_INVALID_COLORSPACE = 2017 }

enum : uint { ERROR_ICM_NOT_ENABLED = 2018 }

enum : uint { ERROR_DELETING_ICM_XFORM = 2019 }

enum : uint { ERROR_INVALID_TRANSFORM = 2020 }

enum : uint { ERROR_COLORSPACE_MISMATCH = 2021 }

enum : uint { ERROR_INVALID_COLORINDEX = 2022 }

enum : uint { ERROR_CONNECTED_OTHER_PASSWORD = 2108 }

enum : uint { ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT = 2109 }

enum : uint { ERROR_BAD_USERNAME = 2202 }

enum : uint { ERROR_NOT_CONNECTED = 2250 }

enum : uint { ERROR_OPEN_FILES = 2401 }

enum : uint { ERROR_ACTIVE_CONNECTIONS = 2402 }

enum : uint { ERROR_DEVICE_IN_USE = 2404 }

enum : uint { ERROR_UNKNOWN_PRINT_MONITOR = 3000 }

enum : uint { ERROR_PRINTER_DRIVER_IN_USE = 3001 }

enum : uint { ERROR_SPOOL_FILE_NOT_FOUND = 3002 }

enum : uint { ERROR_SPL_NO_STARTDOC = 3003 }

enum : uint { ERROR_SPL_NO_ADDJOB = 3004 }

enum : uint { ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED = 3005 }

enum : uint { ERROR_PRINT_MONITOR_ALREADY_INSTALLED = 3006 }

enum : uint { ERROR_INVALID_PRINT_MONITOR = 3007 }

enum : uint { ERROR_PRINT_MONITOR_IN_USE = 3008 }

enum : uint { ERROR_PRINTER_HAS_JOBS_QUEUED = 3009 }

enum : uint { ERROR_SUCCESS_REBOOT_REQUIRED = 3010 }

enum : uint { ERROR_SUCCESS_RESTART_REQUIRED = 3011 }

enum : uint { ERROR_PRINTER_NOT_FOUND = 3012 }

enum : uint { ERROR_PRINTER_DRIVER_WARNED = 3013 }

enum : uint { ERROR_PRINTER_DRIVER_BLOCKED = 3014 }

enum : uint { ERROR_WINS_INTERNAL = 4000 }

enum : uint { ERROR_CAN_NOT_DEL_LOCAL_WINS = 4001 }

enum : uint { ERROR_STATIC_INIT = 4002 }

enum : uint { ERROR_INC_BACKUP = 4003 }

enum : uint { ERROR_FULL_BACKUP = 4004 }

enum : uint { ERROR_REC_NON_EXISTENT = 4005 }

enum : uint { ERROR_RPL_NOT_ALLOWED = 4006 }

enum : uint { ERROR_DHCP_ADDRESS_CONFLICT = 4100 }

enum : uint { ERROR_WMI_GUID_NOT_FOUND = 4200 }

enum : uint { ERROR_WMI_INSTANCE_NOT_FOUND = 4201 }

enum : uint { ERROR_WMI_ITEMID_NOT_FOUND = 4202 }

enum : uint { ERROR_WMI_TRY_AGAIN = 4203 }

enum : uint { ERROR_WMI_DP_NOT_FOUND = 4204 }

enum : uint { ERROR_WMI_UNRESOLVED_INSTANCE_REF = 4205 }

enum : uint { ERROR_WMI_ALREADY_ENABLED = 4206 }

enum : uint { ERROR_WMI_GUID_DISCONNECTED = 4207 }

enum : uint { ERROR_WMI_SERVER_UNAVAILABLE = 4208 }

enum : uint { ERROR_WMI_DP_FAILED = 4209 }

enum : uint { ERROR_WMI_INVALID_MOF = 4210 }

enum : uint { ERROR_WMI_INVALID_REGINFO = 4211 }

enum : uint { ERROR_WMI_ALREADY_DISABLED = 4212 }

enum : uint { ERROR_WMI_READ_ONLY = 4213 }

enum : uint { ERROR_WMI_SET_FAILURE = 4214 }

enum : uint { ERROR_INVALID_MEDIA = 4300 }

enum : uint { ERROR_INVALID_LIBRARY = 4301 }

enum : uint { ERROR_INVALID_MEDIA_POOL = 4302 }

enum : uint { ERROR_DRIVE_MEDIA_MISMATCH = 4303 }

enum : uint { ERROR_MEDIA_OFFLINE = 4304 }

enum : uint { ERROR_LIBRARY_OFFLINE = 4305 }

enum : uint { ERROR_EMPTY = 4306 }

enum : uint { ERROR_NOT_EMPTY = 4307 }

enum : uint { ERROR_MEDIA_UNAVAILABLE = 4308 }

enum : uint { ERROR_RESOURCE_DISABLED = 4309 }

enum : uint { ERROR_INVALID_CLEANER = 4310 }

enum : uint { ERROR_UNABLE_TO_CLEAN = 4311 }

enum : uint { ERROR_OBJECT_NOT_FOUND = 4312 }

enum : uint { ERROR_DATABASE_FAILURE = 4313 }

enum : uint { ERROR_DATABASE_FULL = 4314 }

enum : uint { ERROR_MEDIA_INCOMPATIBLE = 4315 }

enum : uint { ERROR_RESOURCE_NOT_PRESENT = 4316 }

enum : uint { ERROR_INVALID_OPERATION = 4317 }

enum : uint { ERROR_MEDIA_NOT_AVAILABLE = 4318 }

enum : uint { ERROR_DEVICE_NOT_AVAILABLE = 4319 }

enum : uint { ERROR_REQUEST_REFUSED = 4320 }

enum : uint { ERROR_INVALID_DRIVE_OBJECT = 4321 }

enum : uint { ERROR_LIBRARY_FULL = 4322 }

enum : uint { ERROR_MEDIUM_NOT_ACCESSIBLE = 4323 }

enum : uint { ERROR_UNABLE_TO_LOAD_MEDIUM = 4324 }

enum : uint { ERROR_UNABLE_TO_INVENTORY_DRIVE = 4325 }

enum : uint { ERROR_UNABLE_TO_INVENTORY_SLOT = 4326 }

enum : uint { ERROR_UNABLE_TO_INVENTORY_TRANSPORT = 4327 }

enum : uint { ERROR_TRANSPORT_FULL = 4328 }

enum : uint { ERROR_CONTROLLING_IEPORT = 4329 }

enum : uint { ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA = 4330 }

enum : uint { ERROR_CLEANER_SLOT_SET = 4331 }

enum : uint { ERROR_CLEANER_SLOT_NOT_SET = 4332 }

enum : uint { ERROR_CLEANER_CARTRIDGE_SPENT = 4333 }

enum : uint { ERROR_UNEXPECTED_OMID = 4334 }

enum : uint { ERROR_CANT_DELETE_LAST_ITEM = 4335 }

enum : uint { ERROR_MESSAGE_EXCEEDS_MAX_SIZE = 4336 }

enum : uint { ERROR_VOLUME_CONTAINS_SYS_FILES = 4337 }

enum : uint { ERROR_INDIGENOUS_TYPE = 4338 }

enum : uint { ERROR_NO_SUPPORTING_DRIVES = 4339 }

enum : uint { ERROR_CLEANER_CARTRIDGE_INSTALLED = 4340 }

enum : uint { ERROR_FILE_OFFLINE = 4350 }

enum : uint { ERROR_REMOTE_STORAGE_NOT_ACTIVE = 4351 }

enum : uint { ERROR_REMOTE_STORAGE_MEDIA_ERROR = 4352 }

enum : uint { ERROR_NOT_A_REPARSE_POINT = 4390 }

enum : uint { ERROR_REPARSE_ATTRIBUTE_CONFLICT = 4391 }

enum : uint { ERROR_INVALID_REPARSE_DATA = 4392 }

enum : uint { ERROR_REPARSE_TAG_INVALID = 4393 }

enum : uint { ERROR_REPARSE_TAG_MISMATCH = 4394 }

enum : uint { ERROR_VOLUME_NOT_SIS_ENABLED = 4500 }

enum : uint { ERROR_DEPENDENT_RESOURCE_EXISTS = 5001 }

enum : uint { ERROR_DEPENDENCY_NOT_FOUND = 5002 }

enum : uint { ERROR_DEPENDENCY_ALREADY_EXISTS = 5003 }

enum : uint { ERROR_RESOURCE_NOT_ONLINE = 5004 }

enum : uint { ERROR_HOST_NODE_NOT_AVAILABLE = 5005 }

enum : uint { ERROR_RESOURCE_NOT_AVAILABLE = 5006 }

enum : uint { ERROR_RESOURCE_NOT_FOUND = 5007 }

enum : uint { ERROR_SHUTDOWN_CLUSTER = 5008 }

enum : uint { ERROR_CANT_EVICT_ACTIVE_NODE = 5009 }

enum : uint { ERROR_OBJECT_ALREADY_EXISTS = 5010 }

enum : uint { ERROR_OBJECT_IN_LIST = 5011 }

enum : uint { ERROR_GROUP_NOT_AVAILABLE = 5012 }

enum : uint { ERROR_GROUP_NOT_FOUND = 5013 }

enum : uint { ERROR_GROUP_NOT_ONLINE = 5014 }

enum : uint { ERROR_HOST_NODE_NOT_RESOURCE_OWNER = 5015 }

enum : uint { ERROR_HOST_NODE_NOT_GROUP_OWNER = 5016 }

enum : uint { ERROR_RESMON_CREATE_FAILED = 5017 }

enum : uint { ERROR_RESMON_ONLINE_FAILED = 5018 }

enum : uint { ERROR_RESOURCE_ONLINE = 5019 }

enum : uint { ERROR_QUORUM_RESOURCE = 5020 }

enum : uint { ERROR_NOT_QUORUM_CAPABLE = 5021 }

enum : uint { ERROR_CLUSTER_SHUTTING_DOWN = 5022 }

enum : uint { ERROR_INVALID_STATE = 5023 }

enum : uint { ERROR_RESOURCE_PROPERTIES_STORED = 5024 }

enum : uint { ERROR_NOT_QUORUM_CLASS = 5025 }

enum : uint { ERROR_CORE_RESOURCE = 5026 }

enum : uint { ERROR_QUORUM_RESOURCE_ONLINE_FAILED = 5027 }

enum : uint { ERROR_QUORUMLOG_OPEN_FAILED = 5028 }

enum : uint { ERROR_CLUSTERLOG_CORRUPT = 5029 }

enum : uint { ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE = 5030 }

enum : uint { ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE = 5031 }

enum : uint { ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND = 5032 }

enum : uint { ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE = 5033 }

enum : uint { ERROR_QUORUM_OWNER_ALIVE = 5034 }

enum : uint { ERROR_NETWORK_NOT_AVAILABLE = 5035 }

enum : uint { ERROR_NODE_NOT_AVAILABLE = 5036 }

enum : uint { ERROR_ALL_NODES_NOT_AVAILABLE = 5037 }

enum : uint { ERROR_RESOURCE_FAILED = 5038 }

enum : uint { ERROR_CLUSTER_INVALID_NODE = 5039 }

enum : uint { ERROR_CLUSTER_NODE_EXISTS = 5040 }

enum : uint { ERROR_CLUSTER_JOIN_IN_PROGRESS = 5041 }

enum : uint { ERROR_CLUSTER_NODE_NOT_FOUND = 5042 }

enum : uint { ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND = 5043 }

enum : uint { ERROR_CLUSTER_NETWORK_EXISTS = 5044 }

enum : uint { ERROR_CLUSTER_NETWORK_NOT_FOUND = 5045 }

enum : uint { ERROR_CLUSTER_NETINTERFACE_EXISTS = 5046 }

enum : uint { ERROR_CLUSTER_NETINTERFACE_NOT_FOUND = 5047 }

enum : uint { ERROR_CLUSTER_INVALID_REQUEST = 5048 }

enum : uint { ERROR_CLUSTER_INVALID_NETWORK_PROVIDER = 5049 }

enum : uint { ERROR_CLUSTER_NODE_DOWN = 5050 }

enum : uint { ERROR_CLUSTER_NODE_UNREACHABLE = 5051 }

enum : uint { ERROR_CLUSTER_NODE_NOT_MEMBER = 5052 }

enum : uint { ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS = 5053 }

enum : uint { ERROR_CLUSTER_INVALID_NETWORK = 5054 }

enum : uint { ERROR_CLUSTER_NODE_UP = 5056 }

enum : uint { ERROR_CLUSTER_IPADDR_IN_USE = 5057 }

enum : uint { ERROR_CLUSTER_NODE_NOT_PAUSED = 5058 }

enum : uint { ERROR_CLUSTER_NO_SECURITY_CONTEXT = 5059 }

enum : uint { ERROR_CLUSTER_NETWORK_NOT_INTERNAL = 5060 }

enum : uint { ERROR_CLUSTER_NODE_ALREADY_UP = 5061 }

enum : uint { ERROR_CLUSTER_NODE_ALREADY_DOWN = 5062 }

enum : uint { ERROR_CLUSTER_NETWORK_ALREADY_ONLINE = 5063 }

enum : uint { ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE = 5064 }

enum : uint { ERROR_CLUSTER_NODE_ALREADY_MEMBER = 5065 }

enum : uint { ERROR_CLUSTER_LAST_INTERNAL_NETWORK = 5066 }

enum : uint { ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS = 5067 }

enum : uint { ERROR_INVALID_OPERATION_ON_QUORUM = 5068 }

enum : uint { ERROR_DEPENDENCY_NOT_ALLOWED = 5069 }

enum : uint { ERROR_CLUSTER_NODE_PAUSED = 5070 }

enum : uint { ERROR_NODE_CANT_HOST_RESOURCE = 5071 }

enum : uint { ERROR_CLUSTER_NODE_NOT_READY = 5072 }

enum : uint { ERROR_CLUSTER_NODE_SHUTTING_DOWN = 5073 }

enum : uint { ERROR_CLUSTER_JOIN_ABORTED = 5074 }

enum : uint { ERROR_CLUSTER_INCOMPATIBLE_VERSIONS = 5075 }

enum : uint { ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED = 5076 }

enum : uint { ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED = 5077 }

enum : uint { ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND = 5078 }

enum : uint { ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED = 5079 }

enum : uint { ERROR_CLUSTER_RESNAME_NOT_FOUND = 5080 }

enum : uint { ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED = 5081 }

enum : uint { ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST = 5082 }

enum : uint { ERROR_CLUSTER_DATABASE_SEQMISMATCH = 5083 }

enum : uint { ERROR_RESMON_INVALID_STATE = 5084 }

enum : uint { ERROR_CLUSTER_GUM_NOT_LOCKER = 5085 }

enum : uint { ERROR_QUORUM_DISK_NOT_FOUND = 5086 }

enum : uint { ERROR_DATABASE_BACKUP_CORRUPT = 5087 }

enum : uint { ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT = 5088 }

enum : uint { ERROR_RESOURCE_PROPERTY_UNCHANGEABLE = 5089 }

enum : uint { ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE = 5890 }

enum : uint { ERROR_CLUSTER_QUORUMLOG_NOT_FOUND = 5891 }

enum : uint { ERROR_CLUSTER_MEMBERSHIP_HALT = 5892 }

enum : uint { ERROR_CLUSTER_INSTANCE_ID_MISMATCH = 5893 }

enum : uint { ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP = 5894 }

enum : uint { ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH = 5895 }

enum : uint { ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP = 5896 }

enum : uint { ERROR_CLUSTER_PARAMETER_MISMATCH = 5897 }

enum : uint { ERROR_NODE_CANNOT_BE_CLUSTERED = 5898 }

enum : uint { ERROR_CLUSTER_WRONG_OS_VERSION = 5899 }

enum : uint { ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME = 5900 }

enum : uint { ERROR_ENCRYPTION_FAILED = 6000 }

enum : uint { ERROR_DECRYPTION_FAILED = 6001 }

enum : uint { ERROR_FILE_ENCRYPTED = 6002 }

enum : uint { ERROR_NO_RECOVERY_POLICY = 6003 }

enum : uint { ERROR_NO_EFS = 6004 }

enum : uint { ERROR_WRONG_EFS = 6005 }

enum : uint { ERROR_NO_USER_KEYS = 6006 }

enum : uint { ERROR_FILE_NOT_ENCRYPTED = 6007 }

enum : uint { ERROR_NOT_EXPORT_FORMAT = 6008 }

enum : uint { ERROR_FILE_READ_ONLY = 6009 }

enum : uint { ERROR_DIR_EFS_DISALLOWED = 6010 }

enum : uint { ERROR_EFS_SERVER_NOT_TRUSTED = 6011 }

enum : uint { ERROR_BAD_RECOVERY_POLICY = 6012 }

enum : uint { ERROR_EFS_ALG_BLOB_TOO_BIG = 6013 }

enum : uint { ERROR_VOLUME_NOT_SUPPORT_EFS = 6014 }

enum : uint { ERROR_EFS_DISABLED = 6015 }

enum : uint { ERROR_EFS_VERSION_NOT_SUPPORT = 6016 }

enum : uint { ERROR_NO_BROWSER_SERVERS_FOUND = 6118 }

enum : uint { SCHED_E_SERVICE_NOT_LOCALSYSTEM = 6200 }

enum : uint { ERROR_CTX_WINSTATION_NAME_INVALID = 7001 }

enum : uint { ERROR_CTX_INVALID_PD = 7002 }

enum : uint { ERROR_CTX_PD_NOT_FOUND = 7003 }

enum : uint { ERROR_CTX_WD_NOT_FOUND = 7004 }

enum : uint { ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY = 7005 }

enum : uint { ERROR_CTX_SERVICE_NAME_COLLISION = 7006 }

enum : uint { ERROR_CTX_CLOSE_PENDING = 7007 }

enum : uint { ERROR_CTX_NO_OUTBUF = 7008 }

enum : uint { ERROR_CTX_MODEM_INF_NOT_FOUND = 7009 }

enum : uint { ERROR_CTX_INVALID_MODEMNAME = 7010 }

enum : uint { ERROR_CTX_MODEM_RESPONSE_ERROR = 7011 }

enum : uint { ERROR_CTX_MODEM_RESPONSE_TIMEOUT = 7012 }

enum : uint { ERROR_CTX_MODEM_RESPONSE_NO_CARRIER = 7013 }

enum : uint { ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE = 7014 }

enum : uint { ERROR_CTX_MODEM_RESPONSE_BUSY = 7015 }

enum : uint { ERROR_CTX_MODEM_RESPONSE_VOICE = 7016 }

enum : uint { ERROR_CTX_TD_ERROR = 7017 }

enum : uint { ERROR_CTX_WINSTATION_NOT_FOUND = 7022 }

enum : uint { ERROR_CTX_WINSTATION_ALREADY_EXISTS = 7023 }

enum : uint { ERROR_CTX_WINSTATION_BUSY = 7024 }

enum : uint { ERROR_CTX_BAD_VIDEO_MODE = 7025 }

enum : uint { ERROR_CTX_GRAPHICS_INVALID = 7035 }

enum : uint { ERROR_CTX_LOGON_DISABLED = 7037 }

enum : uint { ERROR_CTX_NOT_CONSOLE = 7038 }

enum : uint { ERROR_CTX_CLIENT_QUERY_TIMEOUT = 7040 }

enum : uint { ERROR_CTX_CONSOLE_DISCONNECT = 7041 }

enum : uint { ERROR_CTX_CONSOLE_CONNECT = 7042 }

enum : uint { ERROR_CTX_SHADOW_DENIED = 7044 }

enum : uint { ERROR_CTX_WINSTATION_ACCESS_DENIED = 7045 }

enum : uint { ERROR_CTX_INVALID_WD = 7049 }

enum : uint { ERROR_CTX_SHADOW_INVALID = 7050 }

enum : uint { ERROR_CTX_SHADOW_DISABLED = 7051 }

enum : uint { ERROR_CTX_CLIENT_LICENSE_IN_USE = 7052 }

enum : uint { ERROR_CTX_CLIENT_LICENSE_NOT_SET = 7053 }

enum : uint { ERROR_CTX_LICENSE_NOT_AVAILABLE = 7054 }

enum : uint { ERROR_CTX_LICENSE_CLIENT_INVALID = 7055 }

enum : uint { ERROR_CTX_LICENSE_EXPIRED = 7056 }

enum : uint { ERROR_CTX_SHADOW_NOT_RUNNING = 7057 }

enum : uint { ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE = 7058 }

enum : uint { FRS_ERR_INVALID_API_SEQUENCE = 8001 }

enum : uint { FRS_ERR_STARTING_SERVICE = 8002 }

enum : uint { FRS_ERR_STOPPING_SERVICE = 8003 }

enum : uint { FRS_ERR_INTERNAL_API = 8004 }

enum : uint { FRS_ERR_INTERNAL = 8005 }

enum : uint { FRS_ERR_SERVICE_COMM = 8006 }

enum : uint { FRS_ERR_INSUFFICIENT_PRIV = 8007 }

enum : uint { FRS_ERR_AUTHENTICATION = 8008 }

enum : uint { FRS_ERR_PARENT_INSUFFICIENT_PRIV = 8009 }

enum : uint { FRS_ERR_PARENT_AUTHENTICATION = 8010 }

enum : uint { FRS_ERR_CHILD_TO_PARENT_COMM = 8011 }

enum : uint { FRS_ERR_PARENT_TO_CHILD_COMM = 8012 }

enum : uint { FRS_ERR_SYSVOL_POPULATE = 8013 }

enum : uint { FRS_ERR_SYSVOL_POPULATE_TIMEOUT = 8014 }

enum : uint { FRS_ERR_SYSVOL_IS_BUSY = 8015 }

enum : uint { FRS_ERR_SYSVOL_DEMOTE = 8016 }

enum : uint { FRS_ERR_INVALID_SERVICE_PARAMETER = 8017 }

alias NO_ERROR DS_S_SUCCESS;

enum : uint { ERROR_DS_NOT_INSTALLED = 8200 }

enum : uint { ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY = 8201 }

enum : uint { ERROR_DS_NO_ATTRIBUTE_OR_VALUE = 8202 }

enum : uint { ERROR_DS_INVALID_ATTRIBUTE_SYNTAX = 8203 }

enum : uint { ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED = 8204 }

enum : uint { ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS = 8205 }

enum : uint { ERROR_DS_BUSY = 8206 }

enum : uint { ERROR_DS_UNAVAILABLE = 8207 }

enum : uint { ERROR_DS_NO_RIDS_ALLOCATED = 8208 }

enum : uint { ERROR_DS_NO_MORE_RIDS = 8209 }

enum : uint { ERROR_DS_INCORRECT_ROLE_OWNER = 8210 }

enum : uint { ERROR_DS_RIDMGR_INIT_ERROR = 8211 }

enum : uint { ERROR_DS_OBJ_CLASS_VIOLATION = 8212 }

enum : uint { ERROR_DS_CANT_ON_NON_LEAF = 8213 }

enum : uint { ERROR_DS_CANT_ON_RDN = 8214 }

enum : uint { ERROR_DS_CANT_MOD_OBJ_CLASS = 8215 }

enum : uint { ERROR_DS_CROSS_DOM_MOVE_ERROR = 8216 }

enum : uint { ERROR_DS_GC_NOT_AVAILABLE = 8217 }

enum : uint { ERROR_SHARED_POLICY = 8218 }

enum : uint { ERROR_POLICY_OBJECT_NOT_FOUND = 8219 }

enum : uint { ERROR_POLICY_ONLY_IN_DS = 8220 }

enum : uint { ERROR_PROMOTION_ACTIVE = 8221 }

enum : uint { ERROR_NO_PROMOTION_ACTIVE = 8222 }

enum : uint { ERROR_DS_OPERATIONS_ERROR = 8224 }

enum : uint { ERROR_DS_PROTOCOL_ERROR = 8225 }

enum : uint { ERROR_DS_TIMELIMIT_EXCEEDED = 8226 }

enum : uint { ERROR_DS_SIZELIMIT_EXCEEDED = 8227 }

enum : uint { ERROR_DS_ADMIN_LIMIT_EXCEEDED = 8228 }

enum : uint { ERROR_DS_COMPARE_FALSE = 8229 }

enum : uint { ERROR_DS_COMPARE_TRUE = 8230 }

enum : uint { ERROR_DS_AUTH_METHOD_NOT_SUPPORTED = 8231 }

enum : uint { ERROR_DS_STRONG_AUTH_REQUIRED = 8232 }

enum : uint { ERROR_DS_INAPPROPRIATE_AUTH = 8233 }

enum : uint { ERROR_DS_AUTH_UNKNOWN = 8234 }

enum : uint { ERROR_DS_REFERRAL = 8235 }

enum : uint { ERROR_DS_UNAVAILABLE_CRIT_EXTENSION = 8236 }

enum : uint { ERROR_DS_CONFIDENTIALITY_REQUIRED = 8237 }

enum : uint { ERROR_DS_INAPPROPRIATE_MATCHING = 8238 }

enum : uint { ERROR_DS_CONSTRAINT_VIOLATION = 8239 }

enum : uint { ERROR_DS_NO_SUCH_OBJECT = 8240 }

enum : uint { ERROR_DS_ALIAS_PROBLEM = 8241 }

enum : uint { ERROR_DS_INVALID_DN_SYNTAX = 8242 }

enum : uint { ERROR_DS_IS_LEAF = 8243 }

enum : uint { ERROR_DS_ALIAS_DEREF_PROBLEM = 8244 }

enum : uint { ERROR_DS_UNWILLING_TO_PERFORM = 8245 }

enum : uint { ERROR_DS_LOOP_DETECT = 8246 }

enum : uint { ERROR_DS_NAMING_VIOLATION = 8247 }

enum : uint { ERROR_DS_OBJECT_RESULTS_TOO_LARGE = 8248 }

enum : uint { ERROR_DS_AFFECTS_MULTIPLE_DSAS = 8249 }

enum : uint { ERROR_DS_SERVER_DOWN = 8250 }

enum : uint { ERROR_DS_LOCAL_ERROR = 8251 }

enum : uint { ERROR_DS_ENCODING_ERROR = 8252 }

enum : uint { ERROR_DS_DECODING_ERROR = 8253 }

enum : uint { ERROR_DS_FILTER_UNKNOWN = 8254 }

enum : uint { ERROR_DS_PARAM_ERROR = 8255 }

enum : uint { ERROR_DS_NOT_SUPPORTED = 8256 }

enum : uint { ERROR_DS_NO_RESULTS_RETURNED = 8257 }

enum : uint { ERROR_DS_CONTROL_NOT_FOUND = 8258 }

enum : uint { ERROR_DS_CLIENT_LOOP = 8259 }

enum : uint { ERROR_DS_REFERRAL_LIMIT_EXCEEDED = 8260 }

enum : uint { ERROR_DS_SORT_CONTROL_MISSING = 8261 }

enum : uint { ERROR_DS_OFFSET_RANGE_ERROR = 8262 }

enum : uint { ERROR_DS_ROOT_MUST_BE_NC = 8301 }

enum : uint { ERROR_DS_ADD_REPLICA_INHIBITED = 8302 }

enum : uint { ERROR_DS_ATT_NOT_DEF_IN_SCHEMA = 8303 }

enum : uint { ERROR_DS_MAX_OBJ_SIZE_EXCEEDED = 8304 }

enum : uint { ERROR_DS_OBJ_STRING_NAME_EXISTS = 8305 }

enum : uint { ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA = 8306 }

enum : uint { ERROR_DS_RDN_DOESNT_MATCH_SCHEMA = 8307 }

enum : uint { ERROR_DS_NO_REQUESTED_ATTS_FOUND = 8308 }

enum : uint { ERROR_DS_USER_BUFFER_TO_SMALL = 8309 }

enum : uint { ERROR_DS_ATT_IS_NOT_ON_OBJ = 8310 }

enum : uint { ERROR_DS_ILLEGAL_MOD_OPERATION = 8311 }

enum : uint { ERROR_DS_OBJ_TOO_LARGE = 8312 }

enum : uint { ERROR_DS_BAD_INSTANCE_TYPE = 8313 }

enum : uint { ERROR_DS_MASTERDSA_REQUIRED = 8314 }

enum : uint { ERROR_DS_OBJECT_CLASS_REQUIRED = 8315 }

enum : uint { ERROR_DS_MISSING_REQUIRED_ATT = 8316 }

enum : uint { ERROR_DS_ATT_NOT_DEF_FOR_CLASS = 8317 }

enum : uint { ERROR_DS_ATT_ALREADY_EXISTS = 8318 }

enum : uint { ERROR_DS_CANT_ADD_ATT_VALUES = 8320 }

enum : uint { ERROR_DS_SINGLE_VALUE_CONSTRAINT = 8321 }

enum : uint { ERROR_DS_RANGE_CONSTRAINT = 8322 }

enum : uint { ERROR_DS_ATT_VAL_ALREADY_EXISTS = 8323 }

enum : uint { ERROR_DS_CANT_REM_MISSING_ATT = 8324 }

enum : uint { ERROR_DS_CANT_REM_MISSING_ATT_VAL = 8325 }

enum : uint { ERROR_DS_ROOT_CANT_BE_SUBREF = 8326 }

enum : uint { ERROR_DS_NO_CHAINING = 8327 }

enum : uint { ERROR_DS_NO_CHAINED_EVAL = 8328 }

enum : uint { ERROR_DS_NO_PARENT_OBJECT = 8329 }

enum : uint { ERROR_DS_PARENT_IS_AN_ALIAS = 8330 }

enum : uint { ERROR_DS_CANT_MIX_MASTER_AND_REPS = 8331 }

enum : uint { ERROR_DS_CHILDREN_EXIST = 8332 }

enum : uint { ERROR_DS_OBJ_NOT_FOUND = 8333 }

enum : uint { ERROR_DS_ALIASED_OBJ_MISSING = 8334 }

enum : uint { ERROR_DS_BAD_NAME_SYNTAX = 8335 }

enum : uint { ERROR_DS_ALIAS_POINTS_TO_ALIAS = 8336 }

enum : uint { ERROR_DS_CANT_DEREF_ALIAS = 8337 }

enum : uint { ERROR_DS_OUT_OF_SCOPE = 8338 }

enum : uint { ERROR_DS_OBJECT_BEING_REMOVED = 8339 }

enum : uint { ERROR_DS_CANT_DELETE_DSA_OBJ = 8340 }

enum : uint { ERROR_DS_GENERIC_ERROR = 8341 }

enum : uint { ERROR_DS_DSA_MUST_BE_INT_MASTER = 8342 }

enum : uint { ERROR_DS_CLASS_NOT_DSA = 8343 }

enum : uint { ERROR_DS_INSUFF_ACCESS_RIGHTS = 8344 }

enum : uint { ERROR_DS_ILLEGAL_SUPERIOR = 8345 }

enum : uint { ERROR_DS_ATTRIBUTE_OWNED_BY_SAM = 8346 }

enum : uint { ERROR_DS_NAME_TOO_MANY_PARTS = 8347 }

enum : uint { ERROR_DS_NAME_TOO_LONG = 8348 }

enum : uint { ERROR_DS_NAME_VALUE_TOO_LONG = 8349 }

enum : uint { ERROR_DS_NAME_UNPARSEABLE = 8350 }

enum : uint { ERROR_DS_NAME_TYPE_UNKNOWN = 8351 }

enum : uint { ERROR_DS_NOT_AN_OBJECT = 8352 }

enum : uint { ERROR_DS_SEC_DESC_TOO_SHORT = 8353 }

enum : uint { ERROR_DS_SEC_DESC_INVALID = 8354 }

enum : uint { ERROR_DS_NO_DELETED_NAME = 8355 }

enum : uint { ERROR_DS_SUBREF_MUST_HAVE_PARENT = 8356 }

enum : uint { ERROR_DS_NCNAME_MUST_BE_NC = 8357 }

enum : uint { ERROR_DS_CANT_ADD_SYSTEM_ONLY = 8358 }

enum : uint { ERROR_DS_CLASS_MUST_BE_CONCRETE = 8359 }

enum : uint { ERROR_DS_INVALID_DMD = 8360 }

enum : uint { ERROR_DS_OBJ_GUID_EXISTS = 8361 }

enum : uint { ERROR_DS_NOT_ON_BACKLINK = 8362 }

enum : uint { ERROR_DS_NO_CROSSREF_FOR_NC = 8363 }

enum : uint { ERROR_DS_SHUTTING_DOWN = 8364 }

enum : uint { ERROR_DS_UNKNOWN_OPERATION = 8365 }

enum : uint { ERROR_DS_INVALID_ROLE_OWNER = 8366 }

enum : uint { ERROR_DS_COULDNT_CONTACT_FSMO = 8367 }

enum : uint { ERROR_DS_CROSS_NC_DN_RENAME = 8368 }

enum : uint { ERROR_DS_CANT_MOD_SYSTEM_ONLY = 8369 }

enum : uint { ERROR_DS_REPLICATOR_ONLY = 8370 }

enum : uint { ERROR_DS_OBJ_CLASS_NOT_DEFINED = 8371 }

enum : uint { ERROR_DS_OBJ_CLASS_NOT_SUBCLASS = 8372 }

enum : uint { ERROR_DS_NAME_REFERENCE_INVALID = 8373 }

enum : uint { ERROR_DS_CROSS_REF_EXISTS = 8374 }

enum : uint { ERROR_DS_CANT_DEL_MASTER_CROSSREF = 8375 }

enum : uint { ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD = 8376 }

enum : uint { ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX = 8377 }

enum : uint { ERROR_DS_DUP_RDN = 8378 }

enum : uint { ERROR_DS_DUP_OID = 8379 }

enum : uint { ERROR_DS_DUP_MAPI_ID = 8380 }

enum : uint { ERROR_DS_DUP_SCHEMA_ID_GUID = 8381 }

enum : uint { ERROR_DS_DUP_LDAP_DISPLAY_NAME = 8382 }

enum : uint { ERROR_DS_SEMANTIC_ATT_TEST = 8383 }

enum : uint { ERROR_DS_SYNTAX_MISMATCH = 8384 }

enum : uint { ERROR_DS_EXISTS_IN_MUST_HAVE = 8385 }

enum : uint { ERROR_DS_EXISTS_IN_MAY_HAVE = 8386 }

enum : uint { ERROR_DS_NONEXISTENT_MAY_HAVE = 8387 }

enum : uint { ERROR_DS_NONEXISTENT_MUST_HAVE = 8388 }

enum : uint { ERROR_DS_AUX_CLS_TEST_FAIL = 8389 }

enum : uint { ERROR_DS_NONEXISTENT_POSS_SUP = 8390 }

enum : uint { ERROR_DS_SUB_CLS_TEST_FAIL = 8391 }

enum : uint { ERROR_DS_BAD_RDN_ATT_ID_SYNTAX = 8392 }

enum : uint { ERROR_DS_EXISTS_IN_AUX_CLS = 8393 }

enum : uint { ERROR_DS_EXISTS_IN_SUB_CLS = 8394 }

enum : uint { ERROR_DS_EXISTS_IN_POSS_SUP = 8395 }

enum : uint { ERROR_DS_RECALCSCHEMA_FAILED = 8396 }

enum : uint { ERROR_DS_TREE_DELETE_NOT_FINISHED = 8397 }

enum : uint { ERROR_DS_CANT_DELETE = 8398 }

enum : uint { ERROR_DS_ATT_SCHEMA_REQ_ID = 8399 }

enum : uint { ERROR_DS_BAD_ATT_SCHEMA_SYNTAX = 8400 }

enum : uint { ERROR_DS_CANT_CACHE_ATT = 8401 }

enum : uint { ERROR_DS_CANT_CACHE_CLASS = 8402 }

enum : uint { ERROR_DS_CANT_REMOVE_ATT_CACHE = 8403 }

enum : uint { ERROR_DS_CANT_REMOVE_CLASS_CACHE = 8404 }

enum : uint { ERROR_DS_CANT_RETRIEVE_DN = 8405 }

enum : uint { ERROR_DS_MISSING_SUPREF = 8406 }

enum : uint { ERROR_DS_CANT_RETRIEVE_INSTANCE = 8407 }

enum : uint { ERROR_DS_CODE_INCONSISTENCY = 8408 }

enum : uint { ERROR_DS_DATABASE_ERROR = 8409 }

enum : uint { ERROR_DS_GOVERNSID_MISSING = 8410 }

enum : uint { ERROR_DS_MISSING_EXPECTED_ATT = 8411 }

enum : uint { ERROR_DS_NCNAME_MISSING_CR_REF = 8412 }

enum : uint { ERROR_DS_SECURITY_CHECKING_ERROR = 8413 }

enum : uint { ERROR_DS_SCHEMA_NOT_LOADED = 8414 }

enum : uint { ERROR_DS_SCHEMA_ALLOC_FAILED = 8415 }

enum : uint { ERROR_DS_ATT_SCHEMA_REQ_SYNTAX = 8416 }

enum : uint { ERROR_DS_GCVERIFY_ERROR = 8417 }

enum : uint { ERROR_DS_DRA_SCHEMA_MISMATCH = 8418 }

enum : uint { ERROR_DS_CANT_FIND_DSA_OBJ = 8419 }

enum : uint { ERROR_DS_CANT_FIND_EXPECTED_NC = 8420 }

enum : uint { ERROR_DS_CANT_FIND_NC_IN_CACHE = 8421 }

enum : uint { ERROR_DS_CANT_RETRIEVE_CHILD = 8422 }

enum : uint { ERROR_DS_SECURITY_ILLEGAL_MODIFY = 8423 }

enum : uint { ERROR_DS_CANT_REPLACE_HIDDEN_REC = 8424 }

enum : uint { ERROR_DS_BAD_HIERARCHY_FILE = 8425 }

enum : uint { ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED = 8426 }

enum : uint { ERROR_DS_CONFIG_PARAM_MISSING = 8427 }

enum : uint { ERROR_DS_COUNTING_AB_INDICES_FAILED = 8428 }

enum : uint { ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED = 8429 }

enum : uint { ERROR_DS_INTERNAL_FAILURE = 8430 }

enum : uint { ERROR_DS_UNKNOWN_ERROR = 8431 }

enum : uint { ERROR_DS_ROOT_REQUIRES_CLASS_TOP = 8432 }

enum : uint { ERROR_DS_REFUSING_FSMO_ROLES = 8433 }

enum : uint { ERROR_DS_MISSING_FSMO_SETTINGS = 8434 }

enum : uint { ERROR_DS_UNABLE_TO_SURRENDER_ROLES = 8435 }

enum : uint { ERROR_DS_DRA_GENERIC = 8436 }

enum : uint { ERROR_DS_DRA_INVALID_PARAMETER = 8437 }

enum : uint { ERROR_DS_DRA_BUSY = 8438 }

enum : uint { ERROR_DS_DRA_BAD_DN = 8439 }

enum : uint { ERROR_DS_DRA_BAD_NC = 8440 }

enum : uint { ERROR_DS_DRA_DN_EXISTS = 8441 }

enum : uint { ERROR_DS_DRA_INTERNAL_ERROR = 8442 }

enum : uint { ERROR_DS_DRA_INCONSISTENT_DIT = 8443 }

enum : uint { ERROR_DS_DRA_CONNECTION_FAILED = 8444 }

enum : uint { ERROR_DS_DRA_BAD_INSTANCE_TYPE = 8445 }

enum : uint { ERROR_DS_DRA_OUT_OF_MEM = 8446 }

enum : uint { ERROR_DS_DRA_MAIL_PROBLEM = 8447 }

enum : uint { ERROR_DS_DRA_REF_ALREADY_EXISTS = 8448 }

enum : uint { ERROR_DS_DRA_REF_NOT_FOUND = 8449 }

enum : uint { ERROR_DS_DRA_OBJ_IS_REP_SOURCE = 8450 }

enum : uint { ERROR_DS_DRA_DB_ERROR = 8451 }

enum : uint { ERROR_DS_DRA_NO_REPLICA = 8452 }

enum : uint { ERROR_DS_DRA_ACCESS_DENIED = 8453 }

enum : uint { ERROR_DS_DRA_NOT_SUPPORTED = 8454 }

enum : uint { ERROR_DS_DRA_RPC_CANCELLED = 8455 }

enum : uint { ERROR_DS_DRA_SOURCE_DISABLED = 8456 }

enum : uint { ERROR_DS_DRA_SINK_DISABLED = 8457 }

enum : uint { ERROR_DS_DRA_NAME_COLLISION = 8458 }

enum : uint { ERROR_DS_DRA_SOURCE_REINSTALLED = 8459 }

enum : uint { ERROR_DS_DRA_MISSING_PARENT = 8460 }

enum : uint { ERROR_DS_DRA_PREEMPTED = 8461 }

enum : uint { ERROR_DS_DRA_ABANDON_SYNC = 8462 }

enum : uint { ERROR_DS_DRA_SHUTDOWN = 8463 }

enum : uint { ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET = 8464 }

enum : uint { ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA = 8465 }

enum : uint { ERROR_DS_DRA_EXTN_CONNECTION_FAILED = 8466 }

enum : uint { ERROR_DS_INSTALL_SCHEMA_MISMATCH = 8467 }

enum : uint { ERROR_DS_DUP_LINK_ID = 8468 }

enum : uint { ERROR_DS_NAME_ERROR_RESOLVING = 8469 }

enum : uint { ERROR_DS_NAME_ERROR_NOT_FOUND = 8470 }

enum : uint { ERROR_DS_NAME_ERROR_NOT_UNIQUE = 8471 }

enum : uint { ERROR_DS_NAME_ERROR_NO_MAPPING = 8472 }

enum : uint { ERROR_DS_NAME_ERROR_DOMAIN_ONLY = 8473 }

enum : uint { ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING = 8474 }

enum : uint { ERROR_DS_CONSTRUCTED_ATT_MOD = 8475 }

enum : uint { ERROR_DS_WRONG_OM_OBJ_CLASS = 8476 }

enum : uint { ERROR_DS_DRA_REPL_PENDING = 8477 }

enum : uint { ERROR_DS_DS_REQUIRED = 8478 }

enum : uint { ERROR_DS_INVALID_LDAP_DISPLAY_NAME = 8479 }

enum : uint { ERROR_DS_NON_BASE_SEARCH = 8480 }

enum : uint { ERROR_DS_CANT_RETRIEVE_ATTS = 8481 }

enum : uint { ERROR_DS_BACKLINK_WITHOUT_LINK = 8482 }

enum : uint { ERROR_DS_EPOCH_MISMATCH = 8483 }

enum : uint { ERROR_DS_SRC_NAME_MISMATCH = 8484 }

enum : uint { ERROR_DS_SRC_AND_DST_NC_IDENTICAL = 8485 }

enum : uint { ERROR_DS_DST_NC_MISMATCH = 8486 }

enum : uint { ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC = 8487 }

enum : uint { ERROR_DS_SRC_GUID_MISMATCH = 8488 }

enum : uint { ERROR_DS_CANT_MOVE_DELETED_OBJECT = 8489 }

enum : uint { ERROR_DS_PDC_OPERATION_IN_PROGRESS = 8490 }

enum : uint { ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD = 8491 }

enum : uint { ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION = 8492 }

enum : uint { ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS = 8493 }

enum : uint { ERROR_DS_NC_MUST_HAVE_NC_PARENT = 8494 }

enum : uint { ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE = 8495 }

enum : uint { ERROR_DS_DST_DOMAIN_NOT_NATIVE = 8496 }

enum : uint { ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER = 8497 }

enum : uint { ERROR_DS_CANT_MOVE_ACCOUNT_GROUP = 8498 }

enum : uint { ERROR_DS_CANT_MOVE_RESOURCE_GROUP = 8499 }

enum : uint { ERROR_DS_INVALID_SEARCH_FLAG = 8500 }

enum : uint { ERROR_DS_NO_TREE_DELETE_ABOVE_NC = 8501 }

enum : uint { ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE = 8502 }

enum : uint { ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE = 8503 }

enum : uint { ERROR_DS_SAM_INIT_FAILURE = 8504 }

enum : uint { ERROR_DS_SENSITIVE_GROUP_VIOLATION = 8505 }

enum : uint { ERROR_DS_CANT_MOD_PRIMARYGROUPID = 8506 }

enum : uint { ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD = 8507 }

enum : uint { ERROR_DS_NONSAFE_SCHEMA_CHANGE = 8508 }

enum : uint { ERROR_DS_SCHEMA_UPDATE_DISALLOWED = 8509 }

enum : uint { ERROR_DS_CANT_CREATE_UNDER_SCHEMA = 8510 }

enum : uint { ERROR_DS_INSTALL_NO_SRC_SCH_VERSION = 8511 }

enum : uint { ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE = 8512 }

enum : uint { ERROR_DS_INVALID_GROUP_TYPE = 8513 }

enum : uint { ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN = 8514 }

enum : uint { ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN = 8515 }

enum : uint { ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER = 8516 }

enum : uint { ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER = 8517 }

enum : uint { ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER = 8518 }

enum : uint { ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER = 8519 }

enum : uint { ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER = 8520 }

enum : uint { ERROR_DS_HAVE_PRIMARY_MEMBERS = 8521 }

enum : uint { ERROR_DS_STRING_SD_CONVERSION_FAILED = 8522 }

enum : uint { ERROR_DS_NAMING_MASTER_GC = 8523 }

enum : uint { ERROR_DS_DNS_LOOKUP_FAILURE = 8524 }

enum : uint { ERROR_DS_COULDNT_UPDATE_SPNS = 8525 }

enum : uint { ERROR_DS_CANT_RETRIEVE_SD = 8526 }

enum : uint { ERROR_DS_KEY_NOT_UNIQUE = 8527 }

enum : uint { ERROR_DS_WRONG_LINKED_ATT_SYNTAX = 8528 }

enum : uint { ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD = 8529 }

enum : uint { ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY = 8530 }

enum : uint { ERROR_DS_CANT_START = 8531 }

enum : uint { ERROR_DS_INIT_FAILURE = 8532 }

enum : uint { ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION = 8533 }

enum : uint { ERROR_DS_SOURCE_DOMAIN_IN_FOREST = 8534 }

enum : uint { ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST = 8535 }

enum : uint { ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED = 8536 }

enum : uint { ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN = 8537 }

enum : uint { ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER = 8538 }

enum : uint { ERROR_DS_SRC_SID_EXISTS_IN_FOREST = 8539 }

enum : uint { ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH = 8540 }

enum : uint { ERROR_SAM_INIT_FAILURE = 8541 }

enum : uint { ERROR_DS_DRA_SCHEMA_INFO_SHIP = 8542 }

enum : uint { ERROR_DS_DRA_SCHEMA_CONFLICT = 8543 }

enum : uint { ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT = 8544 }

enum : uint { ERROR_DS_DRA_OBJ_NC_MISMATCH = 8545 }

enum : uint { ERROR_DS_NC_STILL_HAS_DSAS = 8546 }

enum : uint { ERROR_DS_GC_REQUIRED = 8547 }

enum : uint { ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY = 8548 }

enum : uint { ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS = 8549 }

enum : uint { ERROR_DS_CANT_ADD_TO_GC = 8550 }

enum : uint { ERROR_DS_NO_CHECKPOINT_WITH_PDC = 8551 }

enum : uint { ERROR_DS_SOURCE_AUDITING_NOT_ENABLED = 8552 }

enum : uint { ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC = 8553 }

enum : uint { ERROR_DS_INVALID_NAME_FOR_SPN = 8554 }

enum : uint { ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS = 8555 }

enum : uint { ERROR_DS_UNICODEPWD_NOT_IN_QUOTES = 8556 }

enum : uint { ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED = 8557 }

enum : uint { ERROR_DS_MUST_BE_RUN_ON_DST_DC = 8558 }

enum : uint { ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER = 8559 }

enum : uint { ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ = 8560 }

enum : uint { ERROR_DS_INIT_FAILURE_CONSOLE = 8561 }

enum : uint { ERROR_DS_SAM_INIT_FAILURE_CONSOLE = 8562 }

enum : uint { ERROR_DS_FOREST_VERSION_TOO_HIGH = 8563 }

enum : uint { ERROR_DS_DOMAIN_VERSION_TOO_HIGH = 8564 }

enum : uint { ERROR_DS_FOREST_VERSION_TOO_LOW = 8565 }

enum : uint { ERROR_DS_DOMAIN_VERSION_TOO_LOW = 8566 }

enum : uint { ERROR_DS_INCOMPATIBLE_VERSION = 8567 }

enum : uint { ERROR_DS_LOW_DSA_VERSION = 8568 }

enum : uint { ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN = 8569 }

enum : uint { ERROR_DS_NOT_SUPPORTED_SORT_ORDER = 8570 }

enum : uint { ERROR_DS_NAME_NOT_UNIQUE = 8571 }

enum : uint { ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4 = 8572 }

enum : uint { ERROR_DS_OUT_OF_VERSION_STORE = 8573 }

enum : uint { ERROR_DS_INCOMPATIBLE_CONTROLS_USED = 8574 }

enum : uint { ERROR_DS_NO_REF_DOMAIN = 8575 }

enum : uint { ERROR_DS_RESERVED_LINK_ID = 8576 }

enum : uint { ERROR_DS_LINK_ID_NOT_AVAILABLE = 8577 }

enum : uint { ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER = 8578 }

enum : uint { ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE = 8579 }

enum : uint { ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC = 8580 }

enum : uint { ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG = 8581 }

enum : uint { ERROR_DS_MODIFYDN_WRONG_GRANDPARENT = 8582 }

enum : uint { ERROR_DS_NAME_ERROR_TRUST_REFERRAL = 8583 }

enum : uint { ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER = 8584 }

enum : uint { ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD = 8585 }

enum : uint { ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2 = 8586 }

enum : uint { ERROR_DS_THREAD_LIMIT_EXCEEDED = 8587 }

enum : uint { ERROR_DS_NOT_CLOSEST = 8588 }

enum : uint { ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF = 8589 }

enum : uint { ERROR_DS_SINGLE_USER_MODE_FAILED = 8590 }

enum : uint { ERROR_DS_NTDSCRIPT_SYNTAX_ERROR = 8591 }

enum : uint { ERROR_DS_NTDSCRIPT_PROCESS_ERROR = 8592 }

enum : uint { ERROR_DS_DIFFERENT_REPL_EPOCHS = 8593 }

enum : uint { ERROR_DS_DRS_EXTENSIONS_CHANGED = 8594 }

enum : uint { ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR = 8595 }

enum : uint { ERROR_DS_NO_MSDS_INTID = 8596 }

enum : uint { ERROR_DS_DUP_MSDS_INTID = 8597 }

enum : uint { ERROR_DS_EXISTS_IN_RDNATTID = 8598 }

enum : uint { ERROR_DS_AUTHORIZATION_FAILED = 8599 }

enum : uint { ERROR_DS_INVALID_SCRIPT = 8600 }

enum : uint { ERROR_DS_REMOTE_CROSSREF_OP_FAILED = 8601 }

enum : uint { DNS_ERROR_RESPONSE_CODES_BASE = 9000 }

alias NO_ERROR DNS_ERROR_RCODE_NO_ERROR;

enum : uint { DNS_ERROR_MASK = 0x00002328 }

enum : uint { DNS_ERROR_RCODE_FORMAT_ERROR = 9001 }

enum : uint { DNS_ERROR_RCODE_SERVER_FAILURE = 9002 }

enum : uint { DNS_ERROR_RCODE_NAME_ERROR = 9003 }

enum : uint { DNS_ERROR_RCODE_NOT_IMPLEMENTED = 9004 }

enum : uint { DNS_ERROR_RCODE_REFUSED = 9005 }

enum : uint { DNS_ERROR_RCODE_YXDOMAIN = 9006 }

enum : uint { DNS_ERROR_RCODE_YXRRSET = 9007 }

enum : uint { DNS_ERROR_RCODE_NXRRSET = 9008 }

enum : uint { DNS_ERROR_RCODE_NOTAUTH = 9009 }

enum : uint { DNS_ERROR_RCODE_NOTZONE = 9010 }

enum : uint { DNS_ERROR_RCODE_BADSIG = 9016 }

enum : uint { DNS_ERROR_RCODE_BADKEY = 9017 }

enum : uint { DNS_ERROR_RCODE_BADTIME = 9018 }

alias DNS_ERROR_RCODE_BADTIME DNS_ERROR_RCODE_LAST;

enum : uint { DNS_ERROR_PACKET_FMT_BASE = 9500 }

enum : uint { DNS_INFO_NO_RECORDS = 9501 }

enum : uint { DNS_ERROR_BAD_PACKET = 9502 }

enum : uint { DNS_ERROR_NO_PACKET = 9503 }

enum : uint { DNS_ERROR_RCODE = 9504 }

enum : uint { DNS_ERROR_UNSECURE_PACKET = 9505 }

alias DNS_ERROR_UNSECURE_PACKET DNS_STATUS_PACKET_UNSECURE;

alias ERROR_OUTOFMEMORY DNS_ERROR_NO_MEMORY;
alias ERROR_INVALID_NAME DNS_ERROR_INVALID_NAME;
alias ERROR_INVALID_DATA DNS_ERROR_INVALID_DATA;

enum : uint { DNS_ERROR_GENERAL_API_BASE = 9550 }

enum : uint { DNS_ERROR_INVALID_TYPE = 9551 }

enum : uint { DNS_ERROR_INVALID_IP_ADDRESS = 9552 }

enum : uint { DNS_ERROR_INVALID_PROPERTY = 9553 }

enum : uint { DNS_ERROR_TRY_AGAIN_LATER = 9554 }

enum : uint { DNS_ERROR_NOT_UNIQUE = 9555 }

enum : uint { DNS_ERROR_NON_RFC_NAME = 9556 }

enum : uint { DNS_STATUS_FQDN = 9557 }

enum : uint { DNS_STATUS_DOTTED_NAME = 9558 }

enum : uint { DNS_STATUS_SINGLE_PART_NAME = 9559 }

enum : uint { DNS_ERROR_INVALID_NAME_CHAR = 9560 }

enum : uint { DNS_ERROR_NUMERIC_NAME = 9561 }

enum : uint { DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER = 9562 }

enum : uint { DNS_ERROR_ZONE_BASE = 9600 }

enum : uint { DNS_ERROR_ZONE_DOES_NOT_EXIST = 9601 }

enum : uint { DNS_ERROR_NO_ZONE_INFO = 9602 }

enum : uint { DNS_ERROR_INVALID_ZONE_OPERATION = 9603 }

enum : uint { DNS_ERROR_ZONE_CONFIGURATION_ERROR = 9604 }

enum : uint { DNS_ERROR_ZONE_HAS_NO_SOA_RECORD = 9605 }

enum : uint { DNS_ERROR_ZONE_HAS_NO_NS_RECORDS = 9606 }

enum : uint { DNS_ERROR_ZONE_LOCKED = 9607 }

enum : uint { DNS_ERROR_ZONE_CREATION_FAILED = 9608 }

enum : uint { DNS_ERROR_ZONE_ALREADY_EXISTS = 9609 }

enum : uint { DNS_ERROR_AUTOZONE_ALREADY_EXISTS = 9610 }

enum : uint { DNS_ERROR_INVALID_ZONE_TYPE = 9611 }

enum : uint { DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP = 9612 }

enum : uint { DNS_ERROR_ZONE_NOT_SECONDARY = 9613 }

enum : uint { DNS_ERROR_NEED_SECONDARY_ADDRESSES = 9614 }

enum : uint { DNS_ERROR_WINS_INIT_FAILED = 9615 }

enum : uint { DNS_ERROR_NEED_WINS_SERVERS = 9616 }

enum : uint { DNS_ERROR_NBSTAT_INIT_FAILED = 9617 }

enum : uint { DNS_ERROR_SOA_DELETE_INVALID = 9618 }

enum : uint { DNS_ERROR_FORWARDER_ALREADY_EXISTS = 9619 }

enum : uint { DNS_ERROR_ZONE_REQUIRES_MASTER_IP = 9620 }

enum : uint { DNS_ERROR_ZONE_IS_SHUTDOWN = 9621 }

enum : uint { DNS_ERROR_DATAFILE_BASE = 9650 }

enum : uint { DNS_ERROR_PRIMARY_REQUIRES_DATAFILE = 9651 }

enum : uint { DNS_ERROR_INVALID_DATAFILE_NAME = 9652 }

enum : uint { DNS_ERROR_DATAFILE_OPEN_FAILURE = 9653 }

enum : uint { DNS_ERROR_FILE_WRITEBACK_FAILED = 9654 }

enum : uint { DNS_ERROR_DATAFILE_PARSING = 9655 }

enum : uint { DNS_ERROR_DATABASE_BASE = 9700 }

enum : uint { DNS_ERROR_RECORD_DOES_NOT_EXIST = 9701 }

enum : uint { DNS_ERROR_RECORD_FORMAT = 9702 }

enum : uint { DNS_ERROR_NODE_CREATION_FAILED = 9703 }

enum : uint { DNS_ERROR_UNKNOWN_RECORD_TYPE = 9704 }

enum : uint { DNS_ERROR_RECORD_TIMED_OUT = 9705 }

enum : uint { DNS_ERROR_NAME_NOT_IN_ZONE = 9706 }

enum : uint { DNS_ERROR_CNAME_LOOP = 9707 }

enum : uint { DNS_ERROR_NODE_IS_CNAME = 9708 }

enum : uint { DNS_ERROR_CNAME_COLLISION = 9709 }

enum : uint { DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT = 9710 }

enum : uint { DNS_ERROR_RECORD_ALREADY_EXISTS = 9711 }

enum : uint { DNS_ERROR_SECONDARY_DATA = 9712 }

enum : uint { DNS_ERROR_NO_CREATE_CACHE_DATA = 9713 }

enum : uint { DNS_ERROR_NAME_DOES_NOT_EXIST = 9714 }

enum : uint { DNS_WARNING_PTR_CREATE_FAILED = 9715 }

enum : uint { DNS_WARNING_DOMAIN_UNDELETED = 9716 }

enum : uint { DNS_ERROR_DS_UNAVAILABLE = 9717 }

enum : uint { DNS_ERROR_DS_ZONE_ALREADY_EXISTS = 9718 }

enum : uint { DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE = 9719 }

enum : uint { DNS_ERROR_OPERATION_BASE = 9750 }

enum : uint { DNS_INFO_AXFR_COMPLETE = 9751 }

enum : uint { DNS_ERROR_AXFR = 9752 }

enum : uint { DNS_INFO_ADDED_LOCAL_WINS = 9753 }

enum : uint { DNS_ERROR_SECURE_BASE = 9800 }

enum : uint { DNS_STATUS_CONTINUE_NEEDED = 9801 }

enum : uint { DNS_ERROR_SETUP_BASE = 9850 }

enum : uint { DNS_ERROR_NO_TCPIP = 9851 }

enum : uint { DNS_ERROR_NO_DNS_SERVERS = 9852 }

enum : uint { DNS_ERROR_DP_BASE = 9900 }

enum : uint { DNS_ERROR_DP_DOES_NOT_EXIST = 9901 }

enum : uint { DNS_ERROR_DP_ALREADY_EXISTS = 9902 }

enum : uint { DNS_ERROR_DP_NOT_ENLISTED = 9903 }

enum : uint { DNS_ERROR_DP_ALREADY_ENLISTED = 9904 }

// #ifndef WSABASEERR
enum : uint { WSABASEERR = 10000 }

enum : uint { WSAEINTR = 10004 }

enum : uint { WSAEBADF = 10009 }

enum : uint { WSAEACCES = 10013 }

enum : uint { WSAEFAULT = 10014 }

enum : uint { WSAEINVAL = 10022 }

enum : uint { WSAEMFILE = 10024 }

enum : uint { WSAEWOULDBLOCK = 10035 }

enum : uint { WSAEINPROGRESS = 10036 }

enum : uint { WSAEALREADY = 10037 }

enum : uint { WSAENOTSOCK = 10038 }

enum : uint { WSAEDESTADDRREQ = 10039 }

enum : uint { WSAEMSGSIZE = 10040 }

enum : uint { WSAEPROTOTYPE = 10041 }

enum : uint { WSAENOPROTOOPT = 10042 }

enum : uint { WSAEPROTONOSUPPORT = 10043 }

enum : uint { WSAESOCKTNOSUPPORT = 10044 }

enum : uint { WSAEOPNOTSUPP = 10045 }

enum : uint { WSAEPFNOSUPPORT = 10046 }

enum : uint { WSAEAFNOSUPPORT = 10047 }

enum : uint { WSAEADDRINUSE = 10048 }

enum : uint { WSAEADDRNOTAVAIL = 10049 }

enum : uint { WSAENETDOWN = 10050 }

enum : uint { WSAENETUNREACH = 10051 }

enum : uint { WSAENETRESET = 10052 }

enum : uint { WSAECONNABORTED = 10053 }

enum : uint { WSAECONNRESET = 10054 }

enum : uint { WSAENOBUFS = 10055 }

enum : uint { WSAEISCONN = 10056 }

enum : uint { WSAENOTCONN = 10057 }

enum : uint { WSAESHUTDOWN = 10058 }

enum : uint { WSAETOOMANYREFS = 10059 }

enum : uint { WSAETIMEDOUT = 10060 }

enum : uint { WSAECONNREFUSED = 10061 }

enum : uint { WSAELOOP = 10062 }

enum : uint { WSAENAMETOOLONG = 10063 }

enum : uint { WSAEHOSTDOWN = 10064 }

enum : uint { WSAEHOSTUNREACH = 10065 }

enum : uint { WSAENOTEMPTY = 10066 }

enum : uint { WSAEPROCLIM = 10067 }

enum : uint { WSAEUSERS = 10068 }

enum : uint { WSAEDQUOT = 10069 }

enum : uint { WSAESTALE = 10070 }

enum : uint { WSAEREMOTE = 10071 }

enum : uint { WSASYSNOTREADY = 10091 }

enum : uint { WSAVERNOTSUPPORTED = 10092 }

enum : uint { WSANOTINITIALISED = 10093 }

enum : uint { WSAEDISCON = 10101 }

enum : uint { WSAENOMORE = 10102 }

enum : uint { WSAECANCELLED = 10103 }

enum : uint { WSAEINVALIDPROCTABLE = 10104 }

enum : uint { WSAEINVALIDPROVIDER = 10105 }

enum : uint { WSAEPROVIDERFAILEDINIT = 10106 }

enum : uint { WSASYSCALLFAILURE = 10107 }

enum : uint { WSASERVICE_NOT_FOUND = 10108 }

enum : uint { WSATYPE_NOT_FOUND = 10109 }

enum : uint { WSA_E_NO_MORE = 10110 }

enum : uint { WSA_E_CANCELLED = 10111 }

enum : uint { WSAEREFUSED = 10112 }

enum : uint { WSAHOST_NOT_FOUND = 11001 }

enum : uint { WSATRY_AGAIN = 11002 }

enum : uint { WSANO_RECOVERY = 11003 }

enum : uint { WSANO_DATA = 11004 }

enum : uint { WSA_QOS_RECEIVERS = 11005 }

enum : uint { WSA_QOS_SENDERS = 11006 }

enum : uint { WSA_QOS_NO_SENDERS = 11007 }

enum : uint { WSA_QOS_NO_RECEIVERS = 11008 }

enum : uint { WSA_QOS_REQUEST_CONFIRMED = 11009 }

enum : uint { WSA_QOS_ADMISSION_FAILURE = 11010 }

enum : uint { WSA_QOS_POLICY_FAILURE = 11011 }

enum : uint { WSA_QOS_BAD_STYLE = 11012 }

enum : uint { WSA_QOS_BAD_OBJECT = 11013 }

enum : uint { WSA_QOS_TRAFFIC_CTRL_ERROR = 11014 }

enum : uint { WSA_QOS_GENERIC_ERROR = 11015 }

enum : uint { WSA_QOS_ESERVICETYPE = 11016 }

enum : uint { WSA_QOS_EFLOWSPEC = 11017 }

enum : uint { WSA_QOS_EPROVSPECBUF = 11018 }

enum : uint { WSA_QOS_EFILTERSTYLE = 11019 }

enum : uint { WSA_QOS_EFILTERTYPE = 11020 }

enum : uint { WSA_QOS_EFILTERCOUNT = 11021 }

enum : uint { WSA_QOS_EOBJLENGTH = 11022 }

enum : uint { WSA_QOS_EFLOWCOUNT = 11023 }

enum : uint { WSA_QOS_EUNKOWNPSOBJ = 11024 }

enum : uint { WSA_QOS_EPOLICYOBJ = 11025 }

enum : uint { WSA_QOS_EFLOWDESC = 11026 }

enum : uint { WSA_QOS_EPSFLOWSPEC = 11027 }

enum : uint { WSA_QOS_EPSFILTERSPEC = 11028 }

enum : uint { WSA_QOS_ESDMODEOBJ = 11029 }

enum : uint { WSA_QOS_ESHAPERATEOBJ = 11030 }

enum : uint { WSA_QOS_RESERVED_PETYPE = 11031 }

// #endif // defined(WSABASEERR)

enum : uint { ERROR_SXS_SECTION_NOT_FOUND = 14000 }

enum : uint { ERROR_SXS_CANT_GEN_ACTCTX = 14001 }

enum : uint { ERROR_SXS_INVALID_ACTCTXDATA_FORMAT = 14002 }

enum : uint { ERROR_SXS_ASSEMBLY_NOT_FOUND = 14003 }

enum : uint { ERROR_SXS_MANIFEST_FORMAT_ERROR = 14004 }

enum : uint { ERROR_SXS_MANIFEST_PARSE_ERROR = 14005 }

enum : uint { ERROR_SXS_ACTIVATION_CONTEXT_DISABLED = 14006 }

enum : uint { ERROR_SXS_KEY_NOT_FOUND = 14007 }

enum : uint { ERROR_SXS_VERSION_CONFLICT = 14008 }

enum : uint { ERROR_SXS_WRONG_SECTION_TYPE = 14009 }

enum : uint { ERROR_SXS_THREAD_QUERIES_DISABLED = 14010 }

enum : uint { ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET = 14011 }

enum : uint { ERROR_SXS_UNKNOWN_ENCODING_GROUP = 14012 }

enum : uint { ERROR_SXS_UNKNOWN_ENCODING = 14013 }

enum : uint { ERROR_SXS_INVALID_XML_NAMESPACE_URI = 14014 }

enum : uint { ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED = 14015 }

enum : uint { ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED = 14016 }

enum : uint { ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE = 14017 }

enum : uint { ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE = 14018 }

enum : uint { ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE = 14019 }

enum : uint { ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT = 14020 }

enum : uint { ERROR_SXS_DUPLICATE_DLL_NAME = 14021 }

enum : uint { ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME = 14022 }

enum : uint { ERROR_SXS_DUPLICATE_CLSID = 14023 }

enum : uint { ERROR_SXS_DUPLICATE_IID = 14024 }

enum : uint { ERROR_SXS_DUPLICATE_TLBID = 14025 }

enum : uint { ERROR_SXS_DUPLICATE_PROGID = 14026 }

enum : uint { ERROR_SXS_DUPLICATE_ASSEMBLY_NAME = 14027 }

enum : uint { ERROR_SXS_FILE_HASH_MISMATCH = 14028 }

enum : uint { ERROR_SXS_POLICY_PARSE_ERROR = 14029 }

enum : uint { ERROR_SXS_XML_E_MISSINGQUOTE = 14030 }

enum : uint { ERROR_SXS_XML_E_COMMENTSYNTAX = 14031 }

enum : uint { ERROR_SXS_XML_E_BADSTARTNAMECHAR = 14032 }

enum : uint { ERROR_SXS_XML_E_BADNAMECHAR = 14033 }

enum : uint { ERROR_SXS_XML_E_BADCHARINSTRING = 14034 }

enum : uint { ERROR_SXS_XML_E_XMLDECLSYNTAX = 14035 }

enum : uint { ERROR_SXS_XML_E_BADCHARDATA = 14036 }

enum : uint { ERROR_SXS_XML_E_MISSINGWHITESPACE = 14037 }

enum : uint { ERROR_SXS_XML_E_EXPECTINGTAGEND = 14038 }

enum : uint { ERROR_SXS_XML_E_MISSINGSEMICOLON = 14039 }

enum : uint { ERROR_SXS_XML_E_UNBALANCEDPAREN = 14040 }

enum : uint { ERROR_SXS_XML_E_INTERNALERROR = 14041 }

enum : uint { ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE = 14042 }

enum : uint { ERROR_SXS_XML_E_INCOMPLETE_ENCODING = 14043 }

enum : uint { ERROR_SXS_XML_E_MISSING_PAREN = 14044 }

enum : uint { ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE = 14045 }

enum : uint { ERROR_SXS_XML_E_MULTIPLE_COLONS = 14046 }

enum : uint { ERROR_SXS_XML_E_INVALID_DECIMAL = 14047 }

enum : uint { ERROR_SXS_XML_E_INVALID_HEXIDECIMAL = 14048 }

enum : uint { ERROR_SXS_XML_E_INVALID_UNICODE = 14049 }

enum : uint { ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK = 14050 }

enum : uint { ERROR_SXS_XML_E_UNEXPECTEDENDTAG = 14051 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDTAG = 14052 }

enum : uint { ERROR_SXS_XML_E_DUPLICATEATTRIBUTE = 14053 }

enum : uint { ERROR_SXS_XML_E_MULTIPLEROOTS = 14054 }

enum : uint { ERROR_SXS_XML_E_INVALIDATROOTLEVEL = 14055 }

enum : uint { ERROR_SXS_XML_E_BADXMLDECL = 14056 }

enum : uint { ERROR_SXS_XML_E_MISSINGROOT = 14057 }

enum : uint { ERROR_SXS_XML_E_UNEXPECTEDEOF = 14058 }

enum : uint { ERROR_SXS_XML_E_BADPEREFINSUBSET = 14059 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDSTARTTAG = 14060 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDENDTAG = 14061 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDSTRING = 14062 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDCOMMENT = 14063 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDDECL = 14064 }

enum : uint { ERROR_SXS_XML_E_UNCLOSEDCDATA = 14065 }

enum : uint { ERROR_SXS_XML_E_RESERVEDNAMESPACE = 14066 }

enum : uint { ERROR_SXS_XML_E_INVALIDENCODING = 14067 }

enum : uint { ERROR_SXS_XML_E_INVALIDSWITCH = 14068 }

enum : uint { ERROR_SXS_XML_E_BADXMLCASE = 14069 }

enum : uint { ERROR_SXS_XML_E_INVALID_STANDALONE = 14070 }

enum : uint { ERROR_SXS_XML_E_UNEXPECTED_STANDALONE = 14071 }

enum : uint { ERROR_SXS_XML_E_INVALID_VERSION = 14072 }

enum : uint { ERROR_SXS_XML_E_MISSINGEQUALS = 14073 }

enum : uint { ERROR_SXS_PROTECTION_RECOVERY_FAILED = 14074 }

enum : uint { ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT = 14075 }

enum : uint { ERROR_SXS_PROTECTION_CATALOG_NOT_VALID = 14076 }

enum : uint { ERROR_SXS_UNTRANSLATABLE_HRESULT = 14077 }

enum : uint { ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING = 14078 }

enum : uint { ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE = 14079 }

enum : uint { ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME = 14080 }

enum : uint { ERROR_IPSEC_QM_POLICY_EXISTS = 13000 }

enum : uint { ERROR_IPSEC_QM_POLICY_NOT_FOUND = 13001 }

enum : uint { ERROR_IPSEC_QM_POLICY_IN_USE = 13002 }

enum : uint { ERROR_IPSEC_MM_POLICY_EXISTS = 13003 }

enum : uint { ERROR_IPSEC_MM_POLICY_NOT_FOUND = 13004 }

enum : uint { ERROR_IPSEC_MM_POLICY_IN_USE = 13005 }

enum : uint { ERROR_IPSEC_MM_FILTER_EXISTS = 13006 }

enum : uint { ERROR_IPSEC_MM_FILTER_NOT_FOUND = 13007 }

enum : uint { ERROR_IPSEC_TRANSPORT_FILTER_EXISTS = 13008 }

enum : uint { ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND = 13009 }

enum : uint { ERROR_IPSEC_MM_AUTH_EXISTS = 13010 }

enum : uint { ERROR_IPSEC_MM_AUTH_NOT_FOUND = 13011 }

enum : uint { ERROR_IPSEC_MM_AUTH_IN_USE = 13012 }

enum : uint { ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND = 13013 }

enum : uint { ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND = 13014 }

enum : uint { ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND = 13015 }

enum : uint { ERROR_IPSEC_TUNNEL_FILTER_EXISTS = 13016 }

enum : uint { ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND = 13017 }

enum : uint { ERROR_IPSEC_MM_FILTER_PENDING_DELETION = 13018 }

enum : uint { ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION = 13019 }

enum : uint { ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION = 13020 }

enum : uint { ERROR_IPSEC_MM_POLICY_PENDING_DELETION = 13021 }

enum : uint { ERROR_IPSEC_MM_AUTH_PENDING_DELETION = 13022 }

enum : uint { ERROR_IPSEC_QM_POLICY_PENDING_DELETION = 13023 }

enum : uint { ERROR_IPSEC_IKE_NEG_STATUS_BEGIN = 13800 }

enum : uint { ERROR_IPSEC_IKE_AUTH_FAIL = 13801 }

enum : uint { ERROR_IPSEC_IKE_ATTRIB_FAIL = 13802 }

enum : uint { ERROR_IPSEC_IKE_NEGOTIATION_PENDING = 13803 }

enum : uint { ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR = 13804 }

enum : uint { ERROR_IPSEC_IKE_TIMED_OUT = 13805 }

enum : uint { ERROR_IPSEC_IKE_NO_CERT = 13806 }

enum : uint { ERROR_IPSEC_IKE_SA_DELETED = 13807 }

enum : uint { ERROR_IPSEC_IKE_SA_REAPED = 13808 }

enum : uint { ERROR_IPSEC_IKE_MM_ACQUIRE_DROP = 13809 }

enum : uint { ERROR_IPSEC_IKE_QM_ACQUIRE_DROP = 13810 }

enum : uint { ERROR_IPSEC_IKE_QUEUE_DROP_MM = 13811 }

enum : uint { ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM = 13812 }

enum : uint { ERROR_IPSEC_IKE_DROP_NO_RESPONSE = 13813 }

enum : uint { ERROR_IPSEC_IKE_MM_DELAY_DROP = 13814 }

enum : uint { ERROR_IPSEC_IKE_QM_DELAY_DROP = 13815 }

enum : uint { ERROR_IPSEC_IKE_ERROR = 13816 }

enum : uint { ERROR_IPSEC_IKE_CRL_FAILED = 13817 }

enum : uint { ERROR_IPSEC_IKE_INVALID_KEY_USAGE = 13818 }

enum : uint { ERROR_IPSEC_IKE_INVALID_CERT_TYPE = 13819 }

enum : uint { ERROR_IPSEC_IKE_NO_PRIVATE_KEY = 13820 }

enum : uint { ERROR_IPSEC_IKE_DH_FAIL = 13822 }

enum : uint { ERROR_IPSEC_IKE_INVALID_HEADER = 13824 }

enum : uint { ERROR_IPSEC_IKE_NO_POLICY = 13825 }

enum : uint { ERROR_IPSEC_IKE_INVALID_SIGNATURE = 13826 }

enum : uint { ERROR_IPSEC_IKE_KERBEROS_ERROR = 13827 }

enum : uint { ERROR_IPSEC_IKE_NO_PUBLIC_KEY = 13828 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR = 13829 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_SA = 13830 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_PROP = 13831 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_TRANS = 13832 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_KE = 13833 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_ID = 13834 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_CERT = 13835 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ = 13836 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_HASH = 13837 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_SIG = 13838 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_NONCE = 13839 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY = 13840 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_DELETE = 13841 }

enum : uint { ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR = 13842 }

enum : uint { ERROR_IPSEC_IKE_INVALID_PAYLOAD = 13843 }

enum : uint { ERROR_IPSEC_IKE_LOAD_SOFT_SA = 13844 }

enum : uint { ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN = 13845 }

enum : uint { ERROR_IPSEC_IKE_INVALID_COOKIE = 13846 }

enum : uint { ERROR_IPSEC_IKE_NO_PEER_CERT = 13847 }

enum : uint { ERROR_IPSEC_IKE_PEER_CRL_FAILED = 13848 }

enum : uint { ERROR_IPSEC_IKE_POLICY_CHANGE = 13849 }

enum : uint { ERROR_IPSEC_IKE_NO_MM_POLICY = 13850 }

enum : uint { ERROR_IPSEC_IKE_NOTCBPRIV = 13851 }

enum : uint { ERROR_IPSEC_IKE_SECLOADFAIL = 13852 }

enum : uint { ERROR_IPSEC_IKE_FAILSSPINIT = 13853 }

enum : uint { ERROR_IPSEC_IKE_FAILQUERYSSP = 13854 }

enum : uint { ERROR_IPSEC_IKE_SRVACQFAIL = 13855 }

enum : uint { ERROR_IPSEC_IKE_SRVQUERYCRED = 13856 }

enum : uint { ERROR_IPSEC_IKE_GETSPIFAIL = 13857 }

enum : uint { ERROR_IPSEC_IKE_INVALID_FILTER = 13858 }

enum : uint { ERROR_IPSEC_IKE_OUT_OF_MEMORY = 13859 }

enum : uint { ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED = 13860 }

enum : uint { ERROR_IPSEC_IKE_INVALID_POLICY = 13861 }

enum : uint { ERROR_IPSEC_IKE_UNKNOWN_DOI = 13862 }

enum : uint { ERROR_IPSEC_IKE_INVALID_SITUATION = 13863 }

enum : uint { ERROR_IPSEC_IKE_DH_FAILURE = 13864 }

enum : uint { ERROR_IPSEC_IKE_INVALID_GROUP = 13865 }

enum : uint { ERROR_IPSEC_IKE_ENCRYPT = 13866 }

enum : uint { ERROR_IPSEC_IKE_DECRYPT = 13867 }

enum : uint { ERROR_IPSEC_IKE_POLICY_MATCH = 13868 }

enum : uint { ERROR_IPSEC_IKE_UNSUPPORTED_ID = 13869 }

enum : uint { ERROR_IPSEC_IKE_INVALID_HASH = 13870 }

enum : uint { ERROR_IPSEC_IKE_INVALID_HASH_ALG = 13871 }

enum : uint { ERROR_IPSEC_IKE_INVALID_HASH_SIZE = 13872 }

enum : uint { ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG = 13873 }

enum : uint { ERROR_IPSEC_IKE_INVALID_AUTH_ALG = 13874 }

enum : uint { ERROR_IPSEC_IKE_INVALID_SIG = 13875 }

enum : uint { ERROR_IPSEC_IKE_LOAD_FAILED = 13876 }

enum : uint { ERROR_IPSEC_IKE_RPC_DELETE = 13877 }

enum : uint { ERROR_IPSEC_IKE_BENIGN_REINIT = 13878 }

enum : uint { ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY = 13879 }

enum : uint { ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN = 13881 }

enum : uint { ERROR_IPSEC_IKE_MM_LIMIT = 13882 }

enum : uint { ERROR_IPSEC_IKE_NEGOTIATION_DISABLED = 13883 }

enum : uint { ERROR_IPSEC_IKE_NEG_STATUS_END = 13884 }

enum : uint { SEVERITY_SUCCESS = 0 }
enum : uint { SEVERITY_ERROR = 1 }

bit SUCCEEDED(HRESULT Status){ return Status >= 0; }

bit FAILED(HRESULT Status){ return Status < 0; }

// #define IS_ERROR(Status) ((unsigned long)(Status) >> 31 == SEVERITY_ERROR)

// #define HRESULT_CODE(hr) ((hr) & 0xFFFF)
// #define SCODE_CODE(sc) ((sc) & 0xFFFF)

// #define HRESULT_FACILITY(hr) (((hr) >> 16) & 0x1fff)
// #define SCODE_FACILITY(sc) (((sc) >> 16) & 0x1fff)

// #define HRESULT_SEVERITY(hr) (((hr) >> 31) & 0x1)
// #define SCODE_SEVERITY(sc) (((sc) >> 31) & 0x1)

// #define MAKE_HRESULT(sev,fac,code) ((HRESULT) (((unsigned long)(sev)<<31) | ((unsigned long)(fac)<<16) | ((unsigned long)(code))) )
// #define MAKE_SCODE(sev,fac,code) ((SCODE) (((unsigned long)(sev)<<31) | ((unsigned long)(fac)<<16) | ((unsigned long)(code))) )

enum : uint { FACILITY_NT_BIT = 0x10000000 }

// #define __HRESULT_FROM_WIN32(x) ((HRESULT)(x) <= 0 ? ((HRESULT)(x)) : ((HRESULT) (((x) & 0x0000FFFF) | (FACILITY_WIN32 << 16) | 0x80000000)))

// #ifdef INLINE_HRESULT_FROM_WIN32
// #ifndef _HRESULT_DEFINED
// #...
// ...
// #endif
// #ifndef __midl
// ...
// #else
// #...
// #endif
// #else
// #define HRESULT_FROM_WIN32(x) __HRESULT_FROM_WIN32(x)
// #endif

// #define HRESULT_FROM_NT(x) ((HRESULT) ((x) | FACILITY_NT_BIT))

// #define GetScode(hr) ((SCODE) (hr))

// #define ResultFromScode(sc) ((HRESULT) (sc))

// #define PropagateResult(hrPrevious, scBase) ((HRESULT) scBase)

// #ifdef RC_INVOKED
// #...
// #else // RC_INVOKED
// #define _HRESULT_TYPEDEF_(_sc) ((HRESULT)_sc)
// #endif // RC_INVOKED

enum : uint { NOERROR = 0 }

enum : HRESULT { E_UNEXPECTED = cast(HRESULT)0x8000FFFFL }

// #if defined(_WIN32) && !defined(_MAC)

enum : HRESULT { E_NOTIMPL = cast(HRESULT)0x80004001L }

enum : HRESULT { E_OUTOFMEMORY = cast(HRESULT)0x8007000EL }

enum : HRESULT { E_INVALIDARG = cast(HRESULT)0x80070057L }

enum : HRESULT { E_NOINTERFACE = cast(HRESULT)0x80004002L }

enum : HRESULT { E_POINTER = cast(HRESULT)0x80004003L }

enum : HRESULT { E_HANDLE = cast(HRESULT)0x80070006L }

enum : HRESULT { E_ABORT = cast(HRESULT)0x80004004L }

enum : HRESULT { E_FAIL = cast(HRESULT)0x80004005L }

enum : HRESULT { E_ACCESSDENIED = cast(HRESULT)0x80070005L }

// #else

// #...

// #...

// #...

// #...

// #...

// #...

// #...

// #...

// #...

// #endif //WIN32

enum : HRESULT { E_PENDING = cast(HRESULT)0x8000000AL }

enum : HRESULT { CO_E_INIT_TLS = cast(HRESULT)0x80004006L }

enum : HRESULT { CO_E_INIT_SHARED_ALLOCATOR = cast(HRESULT)0x80004007L }

enum : HRESULT { CO_E_INIT_MEMORY_ALLOCATOR = cast(HRESULT)0x80004008L }

enum : HRESULT { CO_E_INIT_CLASS_CACHE = cast(HRESULT)0x80004009L }

enum : HRESULT { CO_E_INIT_RPC_CHANNEL = cast(HRESULT)0x8000400AL }

enum : HRESULT { CO_E_INIT_TLS_SET_CHANNEL_CONTROL = cast(HRESULT)0x8000400BL }

enum : HRESULT { CO_E_INIT_TLS_CHANNEL_CONTROL = cast(HRESULT)0x8000400CL }

enum : HRESULT { CO_E_INIT_UNACCEPTED_USER_ALLOCATOR = cast(HRESULT)0x8000400DL }

enum : HRESULT { CO_E_INIT_SCM_MUTEX_EXISTS = cast(HRESULT)0x8000400EL }

enum : HRESULT { CO_E_INIT_SCM_FILE_MAPPING_EXISTS = cast(HRESULT)0x8000400FL }

enum : HRESULT { CO_E_INIT_SCM_MAP_VIEW_OF_FILE = cast(HRESULT)0x80004010L }

enum : HRESULT { CO_E_INIT_SCM_EXEC_FAILURE = cast(HRESULT)0x80004011L }

enum : HRESULT { CO_E_INIT_ONLY_SINGLE_THREADED = cast(HRESULT)0x80004012L }

enum : HRESULT { CO_E_CANT_REMOTE = cast(HRESULT)0x80004013L }

enum : HRESULT { CO_E_BAD_SERVER_NAME = cast(HRESULT)0x80004014L }

enum : HRESULT { CO_E_WRONG_SERVER_IDENTITY = cast(HRESULT)0x80004015L }

enum : HRESULT { CO_E_OLE1DDE_DISABLED = cast(HRESULT)0x80004016L }

enum : HRESULT { CO_E_RUNAS_SYNTAX = cast(HRESULT)0x80004017L }

enum : HRESULT { CO_E_CREATEPROCESS_FAILURE = cast(HRESULT)0x80004018L }

enum : HRESULT { CO_E_RUNAS_CREATEPROCESS_FAILURE = cast(HRESULT)0x80004019L }

enum : HRESULT { CO_E_RUNAS_LOGON_FAILURE = cast(HRESULT)0x8000401AL }

enum : HRESULT { CO_E_LAUNCH_PERMSSION_DENIED = cast(HRESULT)0x8000401BL }

enum : HRESULT { CO_E_START_SERVICE_FAILURE = cast(HRESULT)0x8000401CL }

enum : HRESULT { CO_E_REMOTE_COMMUNICATION_FAILURE = cast(HRESULT)0x8000401DL }

enum : HRESULT { CO_E_SERVER_START_TIMEOUT = cast(HRESULT)0x8000401EL }

enum : HRESULT { CO_E_CLSREG_INCONSISTENT = cast(HRESULT)0x8000401FL }

enum : HRESULT { CO_E_IIDREG_INCONSISTENT = cast(HRESULT)0x80004020L }

enum : HRESULT { CO_E_NOT_SUPPORTED = cast(HRESULT)0x80004021L }

enum : HRESULT { CO_E_RELOAD_DLL = cast(HRESULT)0x80004022L }

enum : HRESULT { CO_E_MSI_ERROR = cast(HRESULT)0x80004023L }

enum : HRESULT { CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT = cast(HRESULT)0x80004024L }

enum : HRESULT { CO_E_SERVER_PAUSED = cast(HRESULT)0x80004025L }

enum : HRESULT { CO_E_SERVER_NOT_PAUSED = cast(HRESULT)0x80004026L }

enum : HRESULT { CO_E_CLASS_DISABLED = cast(HRESULT)0x80004027L }

enum : HRESULT { CO_E_CLRNOTAVAILABLE = cast(HRESULT)0x80004028L }

enum : HRESULT { CO_E_ASYNC_WORK_REJECTED = cast(HRESULT)0x80004029L }

enum : HRESULT { CO_E_SERVER_INIT_TIMEOUT = cast(HRESULT)0x8000402AL }

enum : HRESULT { CO_E_NO_SECCTX_IN_ACTIVATE = cast(HRESULT)0x8000402BL }

enum : HRESULT { CO_E_TRACKER_CONFIG = cast(HRESULT)0x80004030L }

enum : HRESULT { CO_E_THREADPOOL_CONFIG = cast(HRESULT)0x80004031L }

enum : HRESULT { CO_E_SXS_CONFIG = cast(HRESULT)0x80004032L }

enum : HRESULT { CO_E_MALFORMED_SPN = cast(HRESULT)0x80004033L }

enum : HRESULT { S_OK = cast(HRESULT)0x00000000 }
enum : HRESULT { S_FALSE = cast(HRESULT)0x00000001 }

enum : HRESULT { OLE_E_FIRST = cast(HRESULT)0x80040000 }
enum : HRESULT { OLE_E_LAST = cast(HRESULT)0x800400FF }
enum : HRESULT { OLE_S_FIRST = cast(HRESULT)0x00040000 }
enum : HRESULT { OLE_S_LAST = cast(HRESULT)0x000400FF }

enum : HRESULT { OLE_E_OLEVERB = cast(HRESULT)0x80040000L }

enum : HRESULT { OLE_E_ADVF = cast(HRESULT)0x80040001L }

enum : HRESULT { OLE_E_ENUM_NOMORE = cast(HRESULT)0x80040002L }

enum : HRESULT { OLE_E_ADVISENOTSUPPORTED = cast(HRESULT)0x80040003L }

enum : HRESULT { OLE_E_NOCONNECTION = cast(HRESULT)0x80040004L }

enum : HRESULT { OLE_E_NOTRUNNING = cast(HRESULT)0x80040005L }

enum : HRESULT { OLE_E_NOCACHE = cast(HRESULT)0x80040006L }

enum : HRESULT { OLE_E_BLANK = cast(HRESULT)0x80040007L }

enum : HRESULT { OLE_E_CLASSDIFF = cast(HRESULT)0x80040008L }

enum : HRESULT { OLE_E_CANT_GETMONIKER = cast(HRESULT)0x80040009L }

enum : HRESULT { OLE_E_CANT_BINDTOSOURCE = cast(HRESULT)0x8004000AL }

enum : HRESULT { OLE_E_STATIC = cast(HRESULT)0x8004000BL }

enum : HRESULT { OLE_E_PROMPTSAVECANCELLED = cast(HRESULT)0x8004000CL }

enum : HRESULT { OLE_E_INVALIDRECT = cast(HRESULT)0x8004000DL }

enum : HRESULT { OLE_E_WRONGCOMPOBJ = cast(HRESULT)0x8004000EL }

enum : HRESULT { OLE_E_INVALIDHWND = cast(HRESULT)0x8004000FL }

enum : HRESULT { OLE_E_NOT_INPLACEACTIVE = cast(HRESULT)0x80040010L }

enum : HRESULT { OLE_E_CANTCONVERT = cast(HRESULT)0x80040011L }

enum : HRESULT { OLE_E_NOSTORAGE = cast(HRESULT)0x80040012L }

enum : HRESULT { DV_E_FORMATETC = cast(HRESULT)0x80040064L }

enum : HRESULT { DV_E_DVTARGETDEVICE = cast(HRESULT)0x80040065L }

enum : HRESULT { DV_E_STGMEDIUM = cast(HRESULT)0x80040066L }

enum : HRESULT { DV_E_STATDATA = cast(HRESULT)0x80040067L }

enum : HRESULT { DV_E_LINDEX = cast(HRESULT)0x80040068L }

enum : HRESULT { DV_E_TYMED = cast(HRESULT)0x80040069L }

enum : HRESULT { DV_E_CLIPFORMAT = cast(HRESULT)0x8004006AL }

enum : HRESULT { DV_E_DVASPECT = cast(HRESULT)0x8004006BL }

enum : HRESULT { DV_E_DVTARGETDEVICE_SIZE = cast(HRESULT)0x8004006CL }

enum : HRESULT { DV_E_NOIVIEWOBJECT = cast(HRESULT)0x8004006DL }

enum : uint { DRAGDROP_E_FIRST = 0x80040100 }
enum : uint { DRAGDROP_E_LAST = 0x8004010F }
enum : uint { DRAGDROP_S_FIRST = 0x00040100 }
enum : uint { DRAGDROP_S_LAST = 0x0004010F }

enum : HRESULT { DRAGDROP_E_NOTREGISTERED = cast(HRESULT)0x80040100L }

enum : HRESULT { DRAGDROP_E_ALREADYREGISTERED = cast(HRESULT)0x80040101L }

enum : HRESULT { DRAGDROP_E_INVALIDHWND = cast(HRESULT)0x80040102L }

enum : uint { CLASSFACTORY_E_FIRST = 0x80040110 }
enum : uint { CLASSFACTORY_E_LAST = 0x8004011F }
enum : uint { CLASSFACTORY_S_FIRST = 0x00040110 }
enum : uint { CLASSFACTORY_S_LAST = 0x0004011F }

enum : HRESULT { CLASS_E_NOAGGREGATION = cast(HRESULT)0x80040110L }

enum : HRESULT { CLASS_E_CLASSNOTAVAILABLE = cast(HRESULT)0x80040111L }

enum : HRESULT { CLASS_E_NOTLICENSED = cast(HRESULT)0x80040112L }

enum : uint { MARSHAL_E_FIRST = 0x80040120 }
enum : uint { MARSHAL_E_LAST = 0x8004012F }
enum : uint { MARSHAL_S_FIRST = 0x00040120 }
enum : uint { MARSHAL_S_LAST = 0x0004012F }
enum : uint { DATA_E_FIRST = 0x80040130 }
enum : uint { DATA_E_LAST = 0x8004013F }
enum : uint { DATA_S_FIRST = 0x00040130 }
enum : uint { DATA_S_LAST = 0x0004013F }
enum : uint { VIEW_E_FIRST = 0x80040140 }
enum : uint { VIEW_E_LAST = 0x8004014F }
enum : uint { VIEW_S_FIRST = 0x00040140 }
enum : uint { VIEW_S_LAST = 0x0004014F }

enum : HRESULT { VIEW_E_DRAW = cast(HRESULT)0x80040140L }

enum : uint { REGDB_E_FIRST = 0x80040150 }
enum : uint { REGDB_E_LAST = 0x8004015F }
enum : uint { REGDB_S_FIRST = 0x00040150 }
enum : uint { REGDB_S_LAST = 0x0004015F }

enum : HRESULT { REGDB_E_READREGDB = cast(HRESULT)0x80040150L }

enum : HRESULT { REGDB_E_WRITEREGDB = cast(HRESULT)0x80040151L }

enum : HRESULT { REGDB_E_KEYMISSING = cast(HRESULT)0x80040152L }

enum : HRESULT { REGDB_E_INVALIDVALUE = cast(HRESULT)0x80040153L }

enum : HRESULT { REGDB_E_CLASSNOTREG = cast(HRESULT)0x80040154L }

enum : HRESULT { REGDB_E_IIDNOTREG = cast(HRESULT)0x80040155L }

enum : HRESULT { REGDB_E_BADTHREADINGMODEL = cast(HRESULT)0x80040156L }

enum : uint { CAT_E_FIRST = 0x80040160 }
enum : uint { CAT_E_LAST = 0x80040161 }

enum : HRESULT { CAT_E_CATIDNOEXIST = cast(HRESULT)0x80040160L }

enum : HRESULT { CAT_E_NODESCRIPTION = cast(HRESULT)0x80040161L }

enum : uint { CS_E_FIRST = 0x80040164 }
enum : uint { CS_E_LAST = 0x8004016F }

enum : HRESULT { CS_E_PACKAGE_NOTFOUND = cast(HRESULT)0x80040164L }

enum : HRESULT { CS_E_NOT_DELETABLE = cast(HRESULT)0x80040165L }

enum : HRESULT { CS_E_CLASS_NOTFOUND = cast(HRESULT)0x80040166L }

enum : HRESULT { CS_E_INVALID_VERSION = cast(HRESULT)0x80040167L }

enum : HRESULT { CS_E_NO_CLASSSTORE = cast(HRESULT)0x80040168L }

enum : HRESULT { CS_E_OBJECT_NOTFOUND = cast(HRESULT)0x80040169L }

enum : HRESULT { CS_E_OBJECT_ALREADY_EXISTS = cast(HRESULT)0x8004016AL }

enum : HRESULT { CS_E_INVALID_PATH = cast(HRESULT)0x8004016BL }

enum : HRESULT { CS_E_NETWORK_ERROR = cast(HRESULT)0x8004016CL }

enum : HRESULT { CS_E_ADMIN_LIMIT_EXCEEDED = cast(HRESULT)0x8004016DL }

enum : HRESULT { CS_E_SCHEMA_MISMATCH = cast(HRESULT)0x8004016EL }

enum : HRESULT { CS_E_INTERNAL_ERROR = cast(HRESULT)0x8004016FL }

enum : uint { CACHE_E_FIRST = 0x80040170 }
enum : uint { CACHE_E_LAST = 0x8004017F }
enum : uint { CACHE_S_FIRST = 0x00040170 }
enum : uint { CACHE_S_LAST = 0x0004017F }

enum : HRESULT { CACHE_E_NOCACHE_UPDATED = cast(HRESULT)0x80040170L }

enum : uint { OLEOBJ_E_FIRST = 0x80040180 }
enum : uint { OLEOBJ_E_LAST = 0x8004018F }
enum : uint { OLEOBJ_S_FIRST = 0x00040180 }
enum : uint { OLEOBJ_S_LAST = 0x0004018F }

enum : HRESULT { OLEOBJ_E_NOVERBS = cast(HRESULT)0x80040180L }

enum : HRESULT { OLEOBJ_E_INVALIDVERB = cast(HRESULT)0x80040181L }

enum : uint { CLIENTSITE_E_FIRST = 0x80040190 }
enum : uint { CLIENTSITE_E_LAST = 0x8004019F }
enum : uint { CLIENTSITE_S_FIRST = 0x00040190 }
enum : uint { CLIENTSITE_S_LAST = 0x0004019F }

enum : HRESULT { INPLACE_E_NOTUNDOABLE = cast(HRESULT)0x800401A0L }

enum : HRESULT { INPLACE_E_NOTOOLSPACE = cast(HRESULT)0x800401A1L }

enum : uint { INPLACE_E_FIRST = 0x800401A0 }
enum : uint { INPLACE_E_LAST = 0x800401AF }
enum : uint { INPLACE_S_FIRST = 0x000401A0 }
enum : uint { INPLACE_S_LAST = 0x000401AF }
enum : uint { ENUM_E_FIRST = 0x800401B0 }
enum : uint { ENUM_E_LAST = 0x800401BF }
enum : uint { ENUM_S_FIRST = 0x000401B0 }
enum : uint { ENUM_S_LAST = 0x000401BF }
enum : uint { CONVERT10_E_FIRST = 0x800401C0 }
enum : uint { CONVERT10_E_LAST = 0x800401CF }
enum : uint { CONVERT10_S_FIRST = 0x000401C0 }
enum : uint { CONVERT10_S_LAST = 0x000401CF }

enum : HRESULT { CONVERT10_E_OLESTREAM_GET = cast(HRESULT)0x800401C0L }

enum : HRESULT { CONVERT10_E_OLESTREAM_PUT = cast(HRESULT)0x800401C1L }

enum : HRESULT { CONVERT10_E_OLESTREAM_FMT = cast(HRESULT)0x800401C2L }

enum : HRESULT { CONVERT10_E_OLESTREAM_BITMAP_TO_DIB = cast(HRESULT)0x800401C3L }

enum : HRESULT { CONVERT10_E_STG_FMT = cast(HRESULT)0x800401C4L }

enum : HRESULT { CONVERT10_E_STG_NO_STD_STREAM = cast(HRESULT)0x800401C5L }

enum : HRESULT { CONVERT10_E_STG_DIB_TO_BITMAP = cast(HRESULT)0x800401C6L }

enum : uint { CLIPBRD_E_FIRST = 0x800401D0 }
enum : uint { CLIPBRD_E_LAST = 0x800401DF }
enum : uint { CLIPBRD_S_FIRST = 0x000401D0 }
enum : uint { CLIPBRD_S_LAST = 0x000401DF }

enum : HRESULT { CLIPBRD_E_CANT_OPEN = cast(HRESULT)0x800401D0L }

enum : HRESULT { CLIPBRD_E_CANT_EMPTY = cast(HRESULT)0x800401D1L }

enum : HRESULT { CLIPBRD_E_CANT_SET = cast(HRESULT)0x800401D2L }

enum : HRESULT { CLIPBRD_E_BAD_DATA = cast(HRESULT)0x800401D3L }

enum : HRESULT { CLIPBRD_E_CANT_CLOSE = cast(HRESULT)0x800401D4L }

enum : uint { MK_E_FIRST = 0x800401E0 }
enum : uint { MK_E_LAST = 0x800401EF }
enum : uint { MK_S_FIRST = 0x000401E0 }
enum : uint { MK_S_LAST = 0x000401EF }

enum : HRESULT { MK_E_CONNECTMANUALLY = cast(HRESULT)0x800401E0L }

enum : HRESULT { MK_E_EXCEEDEDDEADLINE = cast(HRESULT)0x800401E1L }

enum : HRESULT { MK_E_NEEDGENERIC = cast(HRESULT)0x800401E2L }

enum : HRESULT { MK_E_UNAVAILABLE = cast(HRESULT)0x800401E3L }

enum : HRESULT { MK_E_SYNTAX = cast(HRESULT)0x800401E4L }

enum : HRESULT { MK_E_NOOBJECT = cast(HRESULT)0x800401E5L }

enum : HRESULT { MK_E_INVALIDEXTENSION = cast(HRESULT)0x800401E6L }

enum : HRESULT { MK_E_INTERMEDIATEINTERFACENOTSUPPORTED = cast(HRESULT)0x800401E7L }

enum : HRESULT { MK_E_NOTBINDABLE = cast(HRESULT)0x800401E8L }

enum : HRESULT { MK_E_NOTBOUND = cast(HRESULT)0x800401E9L }

enum : HRESULT { MK_E_CANTOPENFILE = cast(HRESULT)0x800401EAL }

enum : HRESULT { MK_E_MUSTBOTHERUSER = cast(HRESULT)0x800401EBL }

enum : HRESULT { MK_E_NOINVERSE = cast(HRESULT)0x800401ECL }

enum : HRESULT { MK_E_NOSTORAGE = cast(HRESULT)0x800401EDL }

enum : HRESULT { MK_E_NOPREFIX = cast(HRESULT)0x800401EEL }

enum : HRESULT { MK_E_ENUMERATION_FAILED = cast(HRESULT)0x800401EFL }

enum : uint { CO_E_FIRST = 0x800401F0 }
enum : uint { CO_E_LAST = 0x800401FF }
enum : uint { CO_S_FIRST = 0x000401F0 }
enum : uint { CO_S_LAST = 0x000401FF }

enum : HRESULT { CO_E_NOTINITIALIZED = cast(HRESULT)0x800401F0L }

enum : HRESULT { CO_E_ALREADYINITIALIZED = cast(HRESULT)0x800401F1L }

enum : HRESULT { CO_E_CANTDETERMINECLASS = cast(HRESULT)0x800401F2L }

enum : HRESULT { CO_E_CLASSSTRING = cast(HRESULT)0x800401F3L }

enum : HRESULT { CO_E_IIDSTRING = cast(HRESULT)0x800401F4L }

enum : HRESULT { CO_E_APPNOTFOUND = cast(HRESULT)0x800401F5L }

enum : HRESULT { CO_E_APPSINGLEUSE = cast(HRESULT)0x800401F6L }

enum : HRESULT { CO_E_ERRORINAPP = cast(HRESULT)0x800401F7L }

enum : HRESULT { CO_E_DLLNOTFOUND = cast(HRESULT)0x800401F8L }

enum : HRESULT { CO_E_ERRORINDLL = cast(HRESULT)0x800401F9L }

enum : HRESULT { CO_E_WRONGOSFORAPP = cast(HRESULT)0x800401FAL }

enum : HRESULT { CO_E_OBJNOTREG = cast(HRESULT)0x800401FBL }

enum : HRESULT { CO_E_OBJISREG = cast(HRESULT)0x800401FCL }

enum : HRESULT { CO_E_OBJNOTCONNECTED = cast(HRESULT)0x800401FDL }

enum : HRESULT { CO_E_APPDIDNTREG = cast(HRESULT)0x800401FEL }

enum : HRESULT { CO_E_RELEASED = cast(HRESULT)0x800401FFL }

enum : uint { EVENT_E_FIRST = 0x80040200 }
enum : uint { EVENT_E_LAST = 0x8004021F }
enum : uint { EVENT_S_FIRST = 0x00040200 }
enum : uint { EVENT_S_LAST = 0x0004021F }

enum : HRESULT { EVENT_S_SOME_SUBSCRIBERS_FAILED = cast(HRESULT)0x00040200L }

enum : HRESULT { EVENT_E_ALL_SUBSCRIBERS_FAILED = cast(HRESULT)0x80040201L }

enum : HRESULT { EVENT_S_NOSUBSCRIBERS = cast(HRESULT)0x00040202L }

enum : HRESULT { EVENT_E_QUERYSYNTAX = cast(HRESULT)0x80040203L }

enum : HRESULT { EVENT_E_QUERYFIELD = cast(HRESULT)0x80040204L }

enum : HRESULT { EVENT_E_INTERNALEXCEPTION = cast(HRESULT)0x80040205L }

enum : HRESULT { EVENT_E_INTERNALERROR = cast(HRESULT)0x80040206L }

enum : HRESULT { EVENT_E_INVALID_PER_USER_SID = cast(HRESULT)0x80040207L }

enum : HRESULT { EVENT_E_USER_EXCEPTION = cast(HRESULT)0x80040208L }

enum : HRESULT { EVENT_E_TOO_MANY_METHODS = cast(HRESULT)0x80040209L }

enum : HRESULT { EVENT_E_MISSING_EVENTCLASS = cast(HRESULT)0x8004020AL }

enum : HRESULT { EVENT_E_NOT_ALL_REMOVED = cast(HRESULT)0x8004020BL }

enum : HRESULT { EVENT_E_COMPLUS_NOT_INSTALLED = cast(HRESULT)0x8004020CL }

enum : HRESULT { EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT = cast(HRESULT)0x8004020DL }

enum : HRESULT { EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT = cast(HRESULT)0x8004020EL }

enum : HRESULT { EVENT_E_INVALID_EVENT_CLASS_PARTITION = cast(HRESULT)0x8004020FL }

enum : HRESULT { EVENT_E_PER_USER_SID_NOT_LOGGED_ON = cast(HRESULT)0x80040210L }

enum : uint { XACT_E_FIRST = 0x8004D000 }
enum : uint { XACT_E_LAST = 0x8004D029 }
enum : uint { XACT_S_FIRST = 0x0004D000 }
enum : uint { XACT_S_LAST = 0x0004D010 }

enum : HRESULT { XACT_E_ALREADYOTHERSINGLEPHASE = cast(HRESULT)0x8004D000L }

enum : HRESULT { XACT_E_CANTRETAIN = cast(HRESULT)0x8004D001L }

enum : HRESULT { XACT_E_COMMITFAILED = cast(HRESULT)0x8004D002L }

enum : HRESULT { XACT_E_COMMITPREVENTED = cast(HRESULT)0x8004D003L }

enum : HRESULT { XACT_E_HEURISTICABORT = cast(HRESULT)0x8004D004L }

enum : HRESULT { XACT_E_HEURISTICCOMMIT = cast(HRESULT)0x8004D005L }

enum : HRESULT { XACT_E_HEURISTICDAMAGE = cast(HRESULT)0x8004D006L }

enum : HRESULT { XACT_E_HEURISTICDANGER = cast(HRESULT)0x8004D007L }

enum : HRESULT { XACT_E_ISOLATIONLEVEL = cast(HRESULT)0x8004D008L }

enum : HRESULT { XACT_E_NOASYNC = cast(HRESULT)0x8004D009L }

enum : HRESULT { XACT_E_NOENLIST = cast(HRESULT)0x8004D00AL }

enum : HRESULT { XACT_E_NOISORETAIN = cast(HRESULT)0x8004D00BL }

enum : HRESULT { XACT_E_NORESOURCE = cast(HRESULT)0x8004D00CL }

enum : HRESULT { XACT_E_NOTCURRENT = cast(HRESULT)0x8004D00DL }

enum : HRESULT { XACT_E_NOTRANSACTION = cast(HRESULT)0x8004D00EL }

enum : HRESULT { XACT_E_NOTSUPPORTED = cast(HRESULT)0x8004D00FL }

enum : HRESULT { XACT_E_UNKNOWNRMGRID = cast(HRESULT)0x8004D010L }

enum : HRESULT { XACT_E_WRONGSTATE = cast(HRESULT)0x8004D011L }

enum : HRESULT { XACT_E_WRONGUOW = cast(HRESULT)0x8004D012L }

enum : HRESULT { XACT_E_XTIONEXISTS = cast(HRESULT)0x8004D013L }

enum : HRESULT { XACT_E_NOIMPORTOBJECT = cast(HRESULT)0x8004D014L }

enum : HRESULT { XACT_E_INVALIDCOOKIE = cast(HRESULT)0x8004D015L }

enum : HRESULT { XACT_E_INDOUBT = cast(HRESULT)0x8004D016L }

enum : HRESULT { XACT_E_NOTIMEOUT = cast(HRESULT)0x8004D017L }

enum : HRESULT { XACT_E_ALREADYINPROGRESS = cast(HRESULT)0x8004D018L }

enum : HRESULT { XACT_E_ABORTED = cast(HRESULT)0x8004D019L }

enum : HRESULT { XACT_E_LOGFULL = cast(HRESULT)0x8004D01AL }

enum : HRESULT { XACT_E_TMNOTAVAILABLE = cast(HRESULT)0x8004D01BL }

enum : HRESULT { XACT_E_CONNECTION_DOWN = cast(HRESULT)0x8004D01CL }

enum : HRESULT { XACT_E_CONNECTION_DENIED = cast(HRESULT)0x8004D01DL }

enum : HRESULT { XACT_E_REENLISTTIMEOUT = cast(HRESULT)0x8004D01EL }

enum : HRESULT { XACT_E_TIP_CONNECT_FAILED = cast(HRESULT)0x8004D01FL }

enum : HRESULT { XACT_E_TIP_PROTOCOL_ERROR = cast(HRESULT)0x8004D020L }

enum : HRESULT { XACT_E_TIP_PULL_FAILED = cast(HRESULT)0x8004D021L }

enum : HRESULT { XACT_E_DEST_TMNOTAVAILABLE = cast(HRESULT)0x8004D022L }

enum : HRESULT { XACT_E_TIP_DISABLED = cast(HRESULT)0x8004D023L }

enum : HRESULT { XACT_E_NETWORK_TX_DISABLED = cast(HRESULT)0x8004D024L }

enum : HRESULT { XACT_E_PARTNER_NETWORK_TX_DISABLED = cast(HRESULT)0x8004D025L }

enum : HRESULT { XACT_E_XA_TX_DISABLED = cast(HRESULT)0x8004D026L }

enum : HRESULT { XACT_E_UNABLE_TO_READ_DTC_CONFIG = cast(HRESULT)0x8004D027L }

enum : HRESULT { XACT_E_UNABLE_TO_LOAD_DTC_PROXY = cast(HRESULT)0x8004D028L }

enum : HRESULT { XACT_E_ABORTING = cast(HRESULT)0x8004D029L }

enum : HRESULT { XACT_E_CLERKNOTFOUND = cast(HRESULT)0x8004D080L }

enum : HRESULT { XACT_E_CLERKEXISTS = cast(HRESULT)0x8004D081L }

enum : HRESULT { XACT_E_RECOVERYINPROGRESS = cast(HRESULT)0x8004D082L }

enum : HRESULT { XACT_E_TRANSACTIONCLOSED = cast(HRESULT)0x8004D083L }

enum : HRESULT { XACT_E_INVALIDLSN = cast(HRESULT)0x8004D084L }

enum : HRESULT { XACT_E_REPLAYREQUEST = cast(HRESULT)0x8004D085L }

enum : HRESULT { XACT_S_ASYNC = cast(HRESULT)0x0004D000L }

enum : HRESULT { XACT_S_DEFECT = cast(HRESULT)0x0004D001L }

enum : HRESULT { XACT_S_READONLY = cast(HRESULT)0x0004D002L }

enum : HRESULT { XACT_S_SOMENORETAIN = cast(HRESULT)0x0004D003L }

enum : HRESULT { XACT_S_OKINFORM = cast(HRESULT)0x0004D004L }

enum : HRESULT { XACT_S_MADECHANGESCONTENT = cast(HRESULT)0x0004D005L }

enum : HRESULT { XACT_S_MADECHANGESINFORM = cast(HRESULT)0x0004D006L }

enum : HRESULT { XACT_S_ALLNORETAIN = cast(HRESULT)0x0004D007L }

enum : HRESULT { XACT_S_ABORTING = cast(HRESULT)0x0004D008L }

enum : HRESULT { XACT_S_SINGLEPHASE = cast(HRESULT)0x0004D009L }

enum : HRESULT { XACT_S_LOCALLY_OK = cast(HRESULT)0x0004D00AL }

enum : HRESULT { XACT_S_LASTRESOURCEMANAGER = cast(HRESULT)0x0004D010L }

enum : uint { CONTEXT_E_FIRST = 0x8004E000 }
enum : uint { CONTEXT_E_LAST = 0x8004E02F }
enum : uint { CONTEXT_S_FIRST = 0x0004E000 }
enum : uint { CONTEXT_S_LAST = 0x0004E02F }

enum : HRESULT { CONTEXT_E_ABORTED = cast(HRESULT)0x8004E002L }

enum : HRESULT { CONTEXT_E_ABORTING = cast(HRESULT)0x8004E003L }

enum : HRESULT { CONTEXT_E_NOCONTEXT = cast(HRESULT)0x8004E004L }

enum : HRESULT { CONTEXT_E_SYNCH_TIMEOUT = cast(HRESULT)0x8004E006L }

enum : HRESULT { CONTEXT_E_OLDREF = cast(HRESULT)0x8004E007L }

enum : HRESULT { CONTEXT_E_ROLENOTFOUND = cast(HRESULT)0x8004E00CL }

enum : HRESULT { CONTEXT_E_TMNOTAVAILABLE = cast(HRESULT)0x8004E00FL }

enum : HRESULT { CO_E_ACTIVATIONFAILED = cast(HRESULT)0x8004E021L }

enum : HRESULT { CO_E_ACTIVATIONFAILED_EVENTLOGGED = cast(HRESULT)0x8004E022L }

enum : HRESULT { CO_E_ACTIVATIONFAILED_CATALOGERROR = cast(HRESULT)0x8004E023L }

enum : HRESULT { CO_E_ACTIVATIONFAILED_TIMEOUT = cast(HRESULT)0x8004E024L }

enum : HRESULT { CO_E_INITIALIZATIONFAILED = cast(HRESULT)0x8004E025L }

enum : HRESULT { CONTEXT_E_NOJIT = cast(HRESULT)0x8004E026L }

enum : HRESULT { CONTEXT_E_NOTRANSACTION = cast(HRESULT)0x8004E027L }

enum : HRESULT { CO_E_THREADINGMODEL_CHANGED = cast(HRESULT)0x8004E028L }

enum : HRESULT { CO_E_NOIISINTRINSICS = cast(HRESULT)0x8004E029L }

enum : HRESULT { CO_E_NOCOOKIES = cast(HRESULT)0x8004E02AL }

enum : HRESULT { CO_E_DBERROR = cast(HRESULT)0x8004E02BL }

enum : HRESULT { CO_E_NOTPOOLED = cast(HRESULT)0x8004E02CL }

enum : HRESULT { CO_E_NOTCONSTRUCTED = cast(HRESULT)0x8004E02DL }

enum : HRESULT { CO_E_NOSYNCHRONIZATION = cast(HRESULT)0x8004E02EL }

enum : HRESULT { CO_E_ISOLEVELMISMATCH = cast(HRESULT)0x8004E02FL }

enum : HRESULT { OLE_S_USEREG = cast(HRESULT)0x00040000L }

enum : HRESULT { OLE_S_STATIC = cast(HRESULT)0x00040001L }

enum : HRESULT { OLE_S_MAC_CLIPFORMAT = cast(HRESULT)0x00040002L }

enum : HRESULT { DRAGDROP_S_DROP = cast(HRESULT)0x00040100L }

enum : HRESULT { DRAGDROP_S_CANCEL = cast(HRESULT)0x00040101L }

enum : HRESULT { DRAGDROP_S_USEDEFAULTCURSORS = cast(HRESULT)0x00040102L }

enum : HRESULT { DATA_S_SAMEFORMATETC = cast(HRESULT)0x00040130L }

enum : HRESULT { VIEW_S_ALREADY_FROZEN = cast(HRESULT)0x00040140L }

enum : HRESULT { CACHE_S_FORMATETC_NOTSUPPORTED = cast(HRESULT)0x00040170L }

enum : HRESULT { CACHE_S_SAMECACHE = cast(HRESULT)0x00040171L }

enum : HRESULT { CACHE_S_SOMECACHES_NOTUPDATED = cast(HRESULT)0x00040172L }

enum : HRESULT { OLEOBJ_S_INVALIDVERB = cast(HRESULT)0x00040180L }

enum : HRESULT { OLEOBJ_S_CANNOT_DOVERB_NOW = cast(HRESULT)0x00040181L }

enum : HRESULT { OLEOBJ_S_INVALIDHWND = cast(HRESULT)0x00040182L }

enum : HRESULT { INPLACE_S_TRUNCATED = cast(HRESULT)0x000401A0L }

enum : HRESULT { CONVERT10_S_NO_PRESENTATION = cast(HRESULT)0x000401C0L }

enum : HRESULT { MK_S_REDUCED_TO_SELF = cast(HRESULT)0x000401E2L }

enum : HRESULT { MK_S_ME = cast(HRESULT)0x000401E4L }

enum : HRESULT { MK_S_HIM = cast(HRESULT)0x000401E5L }

enum : HRESULT { MK_S_US = cast(HRESULT)0x000401E6L }

enum : HRESULT { MK_S_MONIKERALREADYREGISTERED = cast(HRESULT)0x000401E7L }

enum : HRESULT { SCHED_S_TASK_READY = cast(HRESULT)0x00041300L }

enum : HRESULT { SCHED_S_TASK_RUNNING = cast(HRESULT)0x00041301L }

enum : HRESULT { SCHED_S_TASK_DISABLED = cast(HRESULT)0x00041302L }

enum : HRESULT { SCHED_S_TASK_HAS_NOT_RUN = cast(HRESULT)0x00041303L }

enum : HRESULT { SCHED_S_TASK_NO_MORE_RUNS = cast(HRESULT)0x00041304L }

enum : HRESULT { SCHED_S_TASK_NOT_SCHEDULED = cast(HRESULT)0x00041305L }

enum : HRESULT { SCHED_S_TASK_TERMINATED = cast(HRESULT)0x00041306L }

enum : HRESULT { SCHED_S_TASK_NO_VALID_TRIGGERS = cast(HRESULT)0x00041307L }

enum : HRESULT { SCHED_S_EVENT_TRIGGER = cast(HRESULT)0x00041308L }

enum : HRESULT { SCHED_E_TRIGGER_NOT_FOUND = cast(HRESULT)0x80041309L }

enum : HRESULT { SCHED_E_TASK_NOT_READY = cast(HRESULT)0x8004130AL }

enum : HRESULT { SCHED_E_TASK_NOT_RUNNING = cast(HRESULT)0x8004130BL }

enum : HRESULT { SCHED_E_SERVICE_NOT_INSTALLED = cast(HRESULT)0x8004130CL }

enum : HRESULT { SCHED_E_CANNOT_OPEN_TASK = cast(HRESULT)0x8004130DL }

enum : HRESULT { SCHED_E_INVALID_TASK = cast(HRESULT)0x8004130EL }

enum : HRESULT { SCHED_E_ACCOUNT_INFORMATION_NOT_SET = cast(HRESULT)0x8004130FL }

enum : HRESULT { SCHED_E_ACCOUNT_NAME_NOT_FOUND = cast(HRESULT)0x80041310L }

enum : HRESULT { SCHED_E_ACCOUNT_DBASE_CORRUPT = cast(HRESULT)0x80041311L }

enum : HRESULT { SCHED_E_NO_SECURITY_SERVICES = cast(HRESULT)0x80041312L }

enum : HRESULT { SCHED_E_UNKNOWN_OBJECT_VERSION = cast(HRESULT)0x80041313L }

enum : HRESULT { SCHED_E_UNSUPPORTED_ACCOUNT_OPTION = cast(HRESULT)0x80041314L }

enum : HRESULT { SCHED_E_SERVICE_NOT_RUNNING = cast(HRESULT)0x80041315L }

enum : HRESULT { CO_E_CLASS_CREATE_FAILED = cast(HRESULT)0x80080001L }

enum : HRESULT { CO_E_SCM_ERROR = cast(HRESULT)0x80080002L }

enum : HRESULT { CO_E_SCM_RPC_FAILURE = cast(HRESULT)0x80080003L }

enum : HRESULT { CO_E_BAD_PATH = cast(HRESULT)0x80080004L }

enum : HRESULT { CO_E_SERVER_EXEC_FAILURE = cast(HRESULT)0x80080005L }

enum : HRESULT { CO_E_OBJSRV_RPC_FAILURE = cast(HRESULT)0x80080006L }

enum : HRESULT { MK_E_NO_NORMALIZED = cast(HRESULT)0x80080007L }

enum : HRESULT { CO_E_SERVER_STOPPING = cast(HRESULT)0x80080008L }

enum : HRESULT { MEM_E_INVALID_ROOT = cast(HRESULT)0x80080009L }

enum : HRESULT { MEM_E_INVALID_LINK = cast(HRESULT)0x80080010L }

enum : HRESULT { MEM_E_INVALID_SIZE = cast(HRESULT)0x80080011L }

enum : HRESULT { CO_S_NOTALLINTERFACES = cast(HRESULT)0x00080012L }

enum : HRESULT { CO_S_MACHINENAMENOTFOUND = cast(HRESULT)0x00080013L }

enum : HRESULT { DISP_E_UNKNOWNINTERFACE = cast(HRESULT)0x80020001L }

enum : HRESULT { DISP_E_MEMBERNOTFOUND = cast(HRESULT)0x80020003L }

enum : HRESULT { DISP_E_PARAMNOTFOUND = cast(HRESULT)0x80020004L }

enum : HRESULT { DISP_E_TYPEMISMATCH = cast(HRESULT)0x80020005L }

enum : HRESULT { DISP_E_UNKNOWNNAME = cast(HRESULT)0x80020006L }

enum : HRESULT { DISP_E_NONAMEDARGS = cast(HRESULT)0x80020007L }

enum : HRESULT { DISP_E_BADVARTYPE = cast(HRESULT)0x80020008L }

enum : HRESULT { DISP_E_EXCEPTION = cast(HRESULT)0x80020009L }

enum : HRESULT { DISP_E_OVERFLOW = cast(HRESULT)0x8002000AL }

enum : HRESULT { DISP_E_BADINDEX = cast(HRESULT)0x8002000BL }

enum : HRESULT { DISP_E_UNKNOWNLCID = cast(HRESULT)0x8002000CL }

enum : HRESULT { DISP_E_ARRAYISLOCKED = cast(HRESULT)0x8002000DL }

enum : HRESULT { DISP_E_BADPARAMCOUNT = cast(HRESULT)0x8002000EL }

enum : HRESULT { DISP_E_PARAMNOTOPTIONAL = cast(HRESULT)0x8002000FL }

enum : HRESULT { DISP_E_BADCALLEE = cast(HRESULT)0x80020010L }

enum : HRESULT { DISP_E_NOTACOLLECTION = cast(HRESULT)0x80020011L }

enum : HRESULT { DISP_E_DIVBYZERO = cast(HRESULT)0x80020012L }

enum : HRESULT { DISP_E_BUFFERTOOSMALL = cast(HRESULT)0x80020013L }

enum : HRESULT { TYPE_E_BUFFERTOOSMALL = cast(HRESULT)0x80028016L }

enum : HRESULT { TYPE_E_FIELDNOTFOUND = cast(HRESULT)0x80028017L }

enum : HRESULT { TYPE_E_INVDATAREAD = cast(HRESULT)0x80028018L }

enum : HRESULT { TYPE_E_UNSUPFORMAT = cast(HRESULT)0x80028019L }

enum : HRESULT { TYPE_E_REGISTRYACCESS = cast(HRESULT)0x8002801CL }

enum : HRESULT { TYPE_E_LIBNOTREGISTERED = cast(HRESULT)0x8002801DL }

enum : HRESULT { TYPE_E_UNDEFINEDTYPE = cast(HRESULT)0x80028027L }

enum : HRESULT { TYPE_E_QUALIFIEDNAMEDISALLOWED = cast(HRESULT)0x80028028L }

enum : HRESULT { TYPE_E_INVALIDSTATE = cast(HRESULT)0x80028029L }

enum : HRESULT { TYPE_E_WRONGTYPEKIND = cast(HRESULT)0x8002802AL }

enum : HRESULT { TYPE_E_ELEMENTNOTFOUND = cast(HRESULT)0x8002802BL }

enum : HRESULT { TYPE_E_AMBIGUOUSNAME = cast(HRESULT)0x8002802CL }

enum : HRESULT { TYPE_E_NAMECONFLICT = cast(HRESULT)0x8002802DL }

enum : HRESULT { TYPE_E_UNKNOWNLCID = cast(HRESULT)0x8002802EL }

enum : HRESULT { TYPE_E_DLLFUNCTIONNOTFOUND = cast(HRESULT)0x8002802FL }

enum : HRESULT { TYPE_E_BADMODULEKIND = cast(HRESULT)0x800288BDL }

enum : HRESULT { TYPE_E_SIZETOOBIG = cast(HRESULT)0x800288C5L }

enum : HRESULT { TYPE_E_DUPLICATEID = cast(HRESULT)0x800288C6L }

enum : HRESULT { TYPE_E_INVALIDID = cast(HRESULT)0x800288CFL }

enum : HRESULT { TYPE_E_TYPEMISMATCH = cast(HRESULT)0x80028CA0L }

enum : HRESULT { TYPE_E_OUTOFBOUNDS = cast(HRESULT)0x80028CA1L }

enum : HRESULT { TYPE_E_IOERROR = cast(HRESULT)0x80028CA2L }

enum : HRESULT { TYPE_E_CANTCREATETMPFILE = cast(HRESULT)0x80028CA3L }

enum : HRESULT { TYPE_E_CANTLOADLIBRARY = cast(HRESULT)0x80029C4AL }

enum : HRESULT { TYPE_E_INCONSISTENTPROPFUNCS = cast(HRESULT)0x80029C83L }

enum : HRESULT { TYPE_E_CIRCULARTYPE = cast(HRESULT)0x80029C84L }

enum : HRESULT { STG_E_INVALIDFUNCTION = cast(HRESULT)0x80030001L }

enum : HRESULT { STG_E_FILENOTFOUND = cast(HRESULT)0x80030002L }

enum : HRESULT { STG_E_PATHNOTFOUND = cast(HRESULT)0x80030003L }

enum : HRESULT { STG_E_TOOMANYOPENFILES = cast(HRESULT)0x80030004L }

enum : HRESULT { STG_E_ACCESSDENIED = cast(HRESULT)0x80030005L }

enum : HRESULT { STG_E_INVALIDHANDLE = cast(HRESULT)0x80030006L }

enum : HRESULT { STG_E_INSUFFICIENTMEMORY = cast(HRESULT)0x80030008L }

enum : HRESULT { STG_E_INVALIDPOINTER = cast(HRESULT)0x80030009L }

enum : HRESULT { STG_E_NOMOREFILES = cast(HRESULT)0x80030012L }

enum : HRESULT { STG_E_DISKISWRITEPROTECTED = cast(HRESULT)0x80030013L }

enum : HRESULT { STG_E_SEEKERROR = cast(HRESULT)0x80030019L }

enum : HRESULT { STG_E_WRITEFAULT = cast(HRESULT)0x8003001DL }

enum : HRESULT { STG_E_READFAULT = cast(HRESULT)0x8003001EL }

enum : HRESULT { STG_E_SHAREVIOLATION = cast(HRESULT)0x80030020L }

enum : HRESULT { STG_E_LOCKVIOLATION = cast(HRESULT)0x80030021L }

enum : HRESULT { STG_E_FILEALREADYEXISTS = cast(HRESULT)0x80030050L }

enum : HRESULT { STG_E_INVALIDPARAMETER = cast(HRESULT)0x80030057L }

enum : HRESULT { STG_E_MEDIUMFULL = cast(HRESULT)0x80030070L }

enum : HRESULT { STG_E_PROPSETMISMATCHED = cast(HRESULT)0x800300F0L }

enum : HRESULT { STG_E_ABNORMALAPIEXIT = cast(HRESULT)0x800300FAL }

enum : HRESULT { STG_E_INVALIDHEADER = cast(HRESULT)0x800300FBL }

enum : HRESULT { STG_E_INVALIDNAME = cast(HRESULT)0x800300FCL }

enum : HRESULT { STG_E_UNKNOWN = cast(HRESULT)0x800300FDL }

enum : HRESULT { STG_E_UNIMPLEMENTEDFUNCTION = cast(HRESULT)0x800300FEL }

enum : HRESULT { STG_E_INVALIDFLAG = cast(HRESULT)0x800300FFL }

enum : HRESULT { STG_E_INUSE = cast(HRESULT)0x80030100L }

enum : HRESULT { STG_E_NOTCURRENT = cast(HRESULT)0x80030101L }

enum : HRESULT { STG_E_REVERTED = cast(HRESULT)0x80030102L }

enum : HRESULT { STG_E_CANTSAVE = cast(HRESULT)0x80030103L }

enum : HRESULT { STG_E_OLDFORMAT = cast(HRESULT)0x80030104L }

enum : HRESULT { STG_E_OLDDLL = cast(HRESULT)0x80030105L }

enum : HRESULT { STG_E_SHAREREQUIRED = cast(HRESULT)0x80030106L }

enum : HRESULT { STG_E_NOTFILEBASEDSTORAGE = cast(HRESULT)0x80030107L }

enum : HRESULT { STG_E_EXTANTMARSHALLINGS = cast(HRESULT)0x80030108L }

enum : HRESULT { STG_E_DOCFILECORRUPT = cast(HRESULT)0x80030109L }

enum : HRESULT { STG_E_BADBASEADDRESS = cast(HRESULT)0x80030110L }

enum : HRESULT { STG_E_DOCFILETOOLARGE = cast(HRESULT)0x80030111L }

enum : HRESULT { STG_E_NOTSIMPLEFORMAT = cast(HRESULT)0x80030112L }

enum : HRESULT { STG_E_INCOMPLETE = cast(HRESULT)0x80030201L }

enum : HRESULT { STG_E_TERMINATED = cast(HRESULT)0x80030202L }

enum : HRESULT { STG_S_CONVERTED = cast(HRESULT)0x00030200L }

enum : HRESULT { STG_S_BLOCK = cast(HRESULT)0x00030201L }

enum : HRESULT { STG_S_RETRYNOW = cast(HRESULT)0x00030202L }

enum : HRESULT { STG_S_MONITORING = cast(HRESULT)0x00030203L }

enum : HRESULT { STG_S_MULTIPLEOPENS = cast(HRESULT)0x00030204L }

enum : HRESULT { STG_S_CONSOLIDATIONFAILED = cast(HRESULT)0x00030205L }

enum : HRESULT { STG_S_CANNOTCONSOLIDATE = cast(HRESULT)0x00030206L }

enum : HRESULT { STG_E_STATUS_COPY_PROTECTION_FAILURE = cast(HRESULT)0x80030305L }

enum : HRESULT { STG_E_CSS_AUTHENTICATION_FAILURE = cast(HRESULT)0x80030306L }

enum : HRESULT { STG_E_CSS_KEY_NOT_PRESENT = cast(HRESULT)0x80030307L }

enum : HRESULT { STG_E_CSS_KEY_NOT_ESTABLISHED = cast(HRESULT)0x80030308L }

enum : HRESULT { STG_E_CSS_SCRAMBLED_SECTOR = cast(HRESULT)0x80030309L }

enum : HRESULT { STG_E_CSS_REGION_MISMATCH = cast(HRESULT)0x8003030AL }

enum : HRESULT { STG_E_RESETS_EXHAUSTED = cast(HRESULT)0x8003030BL }

enum : HRESULT { RPC_E_CALL_REJECTED = cast(HRESULT)0x80010001L }

enum : HRESULT { RPC_E_CALL_CANCELED = cast(HRESULT)0x80010002L }

enum : HRESULT { RPC_E_CANTPOST_INSENDCALL = cast(HRESULT)0x80010003L }

enum : HRESULT { RPC_E_CANTCALLOUT_INASYNCCALL = cast(HRESULT)0x80010004L }

enum : HRESULT { RPC_E_CANTCALLOUT_INEXTERNALCALL = cast(HRESULT)0x80010005L }

enum : HRESULT { RPC_E_CONNECTION_TERMINATED = cast(HRESULT)0x80010006L }

enum : HRESULT { RPC_E_SERVER_DIED = cast(HRESULT)0x80010007L }

enum : HRESULT { RPC_E_CLIENT_DIED = cast(HRESULT)0x80010008L }

enum : HRESULT { RPC_E_INVALID_DATAPACKET = cast(HRESULT)0x80010009L }

enum : HRESULT { RPC_E_CANTTRANSMIT_CALL = cast(HRESULT)0x8001000AL }

enum : HRESULT { RPC_E_CLIENT_CANTMARSHAL_DATA = cast(HRESULT)0x8001000BL }

enum : HRESULT { RPC_E_CLIENT_CANTUNMARSHAL_DATA = cast(HRESULT)0x8001000CL }

enum : HRESULT { RPC_E_SERVER_CANTMARSHAL_DATA = cast(HRESULT)0x8001000DL }

enum : HRESULT { RPC_E_SERVER_CANTUNMARSHAL_DATA = cast(HRESULT)0x8001000EL }

enum : HRESULT { RPC_E_INVALID_DATA = cast(HRESULT)0x8001000FL }

enum : HRESULT { RPC_E_INVALID_PARAMETER = cast(HRESULT)0x80010010L }

enum : HRESULT { RPC_E_CANTCALLOUT_AGAIN = cast(HRESULT)0x80010011L }

enum : HRESULT { RPC_E_SERVER_DIED_DNE = cast(HRESULT)0x80010012L }

enum : HRESULT { RPC_E_SYS_CALL_FAILED = cast(HRESULT)0x80010100L }

enum : HRESULT { RPC_E_OUT_OF_RESOURCES = cast(HRESULT)0x80010101L }

enum : HRESULT { RPC_E_ATTEMPTED_MULTITHREAD = cast(HRESULT)0x80010102L }

enum : HRESULT { RPC_E_NOT_REGISTERED = cast(HRESULT)0x80010103L }

enum : HRESULT { RPC_E_FAULT = cast(HRESULT)0x80010104L }

enum : HRESULT { RPC_E_SERVERFAULT = cast(HRESULT)0x80010105L }

enum : HRESULT { RPC_E_CHANGED_MODE = cast(HRESULT)0x80010106L }

enum : HRESULT { RPC_E_INVALIDMETHOD = cast(HRESULT)0x80010107L }

enum : HRESULT { RPC_E_DISCONNECTED = cast(HRESULT)0x80010108L }

enum : HRESULT { RPC_E_RETRY = cast(HRESULT)0x80010109L }

enum : HRESULT { RPC_E_SERVERCALL_RETRYLATER = cast(HRESULT)0x8001010AL }

enum : HRESULT { RPC_E_SERVERCALL_REJECTED = cast(HRESULT)0x8001010BL }

enum : HRESULT { RPC_E_INVALID_CALLDATA = cast(HRESULT)0x8001010CL }

enum : HRESULT { RPC_E_CANTCALLOUT_ININPUTSYNCCALL = cast(HRESULT)0x8001010DL }

enum : HRESULT { RPC_E_WRONG_THREAD = cast(HRESULT)0x8001010EL }

enum : HRESULT { RPC_E_THREAD_NOT_INIT = cast(HRESULT)0x8001010FL }

enum : HRESULT { RPC_E_VERSION_MISMATCH = cast(HRESULT)0x80010110L }

enum : HRESULT { RPC_E_INVALID_HEADER = cast(HRESULT)0x80010111L }

enum : HRESULT { RPC_E_INVALID_EXTENSION = cast(HRESULT)0x80010112L }

enum : HRESULT { RPC_E_INVALID_IPID = cast(HRESULT)0x80010113L }

enum : HRESULT { RPC_E_INVALID_OBJECT = cast(HRESULT)0x80010114L }

enum : HRESULT { RPC_S_CALLPENDING = cast(HRESULT)0x80010115L }

enum : HRESULT { RPC_S_WAITONTIMER = cast(HRESULT)0x80010116L }

enum : HRESULT { RPC_E_CALL_COMPLETE = cast(HRESULT)0x80010117L }

enum : HRESULT { RPC_E_UNSECURE_CALL = cast(HRESULT)0x80010118L }

enum : HRESULT { RPC_E_TOO_LATE = cast(HRESULT)0x80010119L }

enum : HRESULT { RPC_E_NO_GOOD_SECURITY_PACKAGES = cast(HRESULT)0x8001011AL }

enum : HRESULT { RPC_E_ACCESS_DENIED = cast(HRESULT)0x8001011BL }

enum : HRESULT { RPC_E_REMOTE_DISABLED = cast(HRESULT)0x8001011CL }

enum : HRESULT { RPC_E_INVALID_OBJREF = cast(HRESULT)0x8001011DL }

enum : HRESULT { RPC_E_NO_CONTEXT = cast(HRESULT)0x8001011EL }

enum : HRESULT { RPC_E_TIMEOUT = cast(HRESULT)0x8001011FL }

enum : HRESULT { RPC_E_NO_SYNC = cast(HRESULT)0x80010120L }

enum : HRESULT { RPC_E_FULLSIC_REQUIRED = cast(HRESULT)0x80010121L }

enum : HRESULT { RPC_E_INVALID_STD_NAME = cast(HRESULT)0x80010122L }

enum : HRESULT { CO_E_FAILEDTOIMPERSONATE = cast(HRESULT)0x80010123L }

enum : HRESULT { CO_E_FAILEDTOGETSECCTX = cast(HRESULT)0x80010124L }

enum : HRESULT { CO_E_FAILEDTOOPENTHREADTOKEN = cast(HRESULT)0x80010125L }

enum : HRESULT { CO_E_FAILEDTOGETTOKENINFO = cast(HRESULT)0x80010126L }

enum : HRESULT { CO_E_TRUSTEEDOESNTMATCHCLIENT = cast(HRESULT)0x80010127L }

enum : HRESULT { CO_E_FAILEDTOQUERYCLIENTBLANKET = cast(HRESULT)0x80010128L }

enum : HRESULT { CO_E_FAILEDTOSETDACL = cast(HRESULT)0x80010129L }

enum : HRESULT { CO_E_ACCESSCHECKFAILED = cast(HRESULT)0x8001012AL }

enum : HRESULT { CO_E_NETACCESSAPIFAILED = cast(HRESULT)0x8001012BL }

enum : HRESULT { CO_E_WRONGTRUSTEENAMESYNTAX = cast(HRESULT)0x8001012CL }

enum : HRESULT { CO_E_INVALIDSID = cast(HRESULT)0x8001012DL }

enum : HRESULT { CO_E_CONVERSIONFAILED = cast(HRESULT)0x8001012EL }

enum : HRESULT { CO_E_NOMATCHINGSIDFOUND = cast(HRESULT)0x8001012FL }

enum : HRESULT { CO_E_LOOKUPACCSIDFAILED = cast(HRESULT)0x80010130L }

enum : HRESULT { CO_E_NOMATCHINGNAMEFOUND = cast(HRESULT)0x80010131L }

enum : HRESULT { CO_E_LOOKUPACCNAMEFAILED = cast(HRESULT)0x80010132L }

enum : HRESULT { CO_E_SETSERLHNDLFAILED = cast(HRESULT)0x80010133L }

enum : HRESULT { CO_E_FAILEDTOGETWINDIR = cast(HRESULT)0x80010134L }

enum : HRESULT { CO_E_PATHTOOLONG = cast(HRESULT)0x80010135L }

enum : HRESULT { CO_E_FAILEDTOGENUUID = cast(HRESULT)0x80010136L }

enum : HRESULT { CO_E_FAILEDTOCREATEFILE = cast(HRESULT)0x80010137L }

enum : HRESULT { CO_E_FAILEDTOCLOSEHANDLE = cast(HRESULT)0x80010138L }

enum : HRESULT { CO_E_EXCEEDSYSACLLIMIT = cast(HRESULT)0x80010139L }

enum : HRESULT { CO_E_ACESINWRONGORDER = cast(HRESULT)0x8001013AL }

enum : HRESULT { CO_E_INCOMPATIBLESTREAMVERSION = cast(HRESULT)0x8001013BL }

enum : HRESULT { CO_E_FAILEDTOOPENPROCESSTOKEN = cast(HRESULT)0x8001013CL }

enum : HRESULT { CO_E_DECODEFAILED = cast(HRESULT)0x8001013DL }

enum : HRESULT { CO_E_ACNOTINITIALIZED = cast(HRESULT)0x8001013FL }

enum : HRESULT { CO_E_CANCEL_DISABLED = cast(HRESULT)0x80010140L }

enum : HRESULT { RPC_E_UNEXPECTED = cast(HRESULT)0x8001FFFFL }

enum : HRESULT { ERROR_AUDITING_DISABLED = cast(HRESULT)0xC0090001L }

enum : HRESULT { ERROR_ALL_SIDS_FILTERED = cast(HRESULT)0xC0090002L }

enum : HRESULT { NTE_BAD_UID = cast(HRESULT)0x80090001L }

enum : HRESULT { NTE_BAD_HASH = cast(HRESULT)0x80090002L }

enum : HRESULT { NTE_BAD_KEY = cast(HRESULT)0x80090003L }

enum : HRESULT { NTE_BAD_LEN = cast(HRESULT)0x80090004L }

enum : HRESULT { NTE_BAD_DATA = cast(HRESULT)0x80090005L }

enum : HRESULT { NTE_BAD_SIGNATURE = cast(HRESULT)0x80090006L }

enum : HRESULT { NTE_BAD_VER = cast(HRESULT)0x80090007L }

enum : HRESULT { NTE_BAD_ALGID = cast(HRESULT)0x80090008L }

enum : HRESULT { NTE_BAD_FLAGS = cast(HRESULT)0x80090009L }

enum : HRESULT { NTE_BAD_TYPE = cast(HRESULT)0x8009000AL }

enum : HRESULT { NTE_BAD_KEY_STATE = cast(HRESULT)0x8009000BL }

enum : HRESULT { NTE_BAD_HASH_STATE = cast(HRESULT)0x8009000CL }

enum : HRESULT { NTE_NO_KEY = cast(HRESULT)0x8009000DL }

enum : HRESULT { NTE_NO_MEMORY = cast(HRESULT)0x8009000EL }

enum : HRESULT { NTE_EXISTS = cast(HRESULT)0x8009000FL }

enum : HRESULT { NTE_PERM = cast(HRESULT)0x80090010L }

enum : HRESULT { NTE_NOT_FOUND = cast(HRESULT)0x80090011L }

enum : HRESULT { NTE_DOUBLE_ENCRYPT = cast(HRESULT)0x80090012L }

enum : HRESULT { NTE_BAD_PROVIDER = cast(HRESULT)0x80090013L }

enum : HRESULT { NTE_BAD_PROV_TYPE = cast(HRESULT)0x80090014L }

enum : HRESULT { NTE_BAD_PUBLIC_KEY = cast(HRESULT)0x80090015L }

enum : HRESULT { NTE_BAD_KEYSET = cast(HRESULT)0x80090016L }

enum : HRESULT { NTE_PROV_TYPE_NOT_DEF = cast(HRESULT)0x80090017L }

enum : HRESULT { NTE_PROV_TYPE_ENTRY_BAD = cast(HRESULT)0x80090018L }

enum : HRESULT { NTE_KEYSET_NOT_DEF = cast(HRESULT)0x80090019L }

enum : HRESULT { NTE_KEYSET_ENTRY_BAD = cast(HRESULT)0x8009001AL }

enum : HRESULT { NTE_PROV_TYPE_NO_MATCH = cast(HRESULT)0x8009001BL }

enum : HRESULT { NTE_SIGNATURE_FILE_BAD = cast(HRESULT)0x8009001CL }

enum : HRESULT { NTE_PROVIDER_DLL_FAIL = cast(HRESULT)0x8009001DL }

enum : HRESULT { NTE_PROV_DLL_NOT_FOUND = cast(HRESULT)0x8009001EL }

enum : HRESULT { NTE_BAD_KEYSET_PARAM = cast(HRESULT)0x8009001FL }

enum : HRESULT { NTE_FAIL = cast(HRESULT)0x80090020L }

enum : HRESULT { NTE_SYS_ERR = cast(HRESULT)0x80090021L }

enum : HRESULT { NTE_SILENT_CONTEXT = cast(HRESULT)0x80090022L }

enum : HRESULT { NTE_TOKEN_KEYSET_STORAGE_FULL = cast(HRESULT)0x80090023L }

enum : HRESULT { NTE_TEMPORARY_PROFILE = cast(HRESULT)0x80090024L }

enum : HRESULT { NTE_FIXEDPARAMETER = cast(HRESULT)0x80090025L }

enum : HRESULT { SEC_E_INSUFFICIENT_MEMORY = cast(HRESULT)0x80090300L }

enum : HRESULT { SEC_E_INVALID_HANDLE = cast(HRESULT)0x80090301L }

enum : HRESULT { SEC_E_UNSUPPORTED_FUNCTION = cast(HRESULT)0x80090302L }

enum : HRESULT { SEC_E_TARGET_UNKNOWN = cast(HRESULT)0x80090303L }

enum : HRESULT { SEC_E_INTERNAL_ERROR = cast(HRESULT)0x80090304L }

enum : HRESULT { SEC_E_SECPKG_NOT_FOUND = cast(HRESULT)0x80090305L }

enum : HRESULT { SEC_E_NOT_OWNER = cast(HRESULT)0x80090306L }

enum : HRESULT { SEC_E_CANNOT_INSTALL = cast(HRESULT)0x80090307L }

enum : HRESULT { SEC_E_INVALID_TOKEN = cast(HRESULT)0x80090308L }

enum : HRESULT { SEC_E_CANNOT_PACK = cast(HRESULT)0x80090309L }

enum : HRESULT { SEC_E_QOP_NOT_SUPPORTED = cast(HRESULT)0x8009030AL }

enum : HRESULT { SEC_E_NO_IMPERSONATION = cast(HRESULT)0x8009030BL }

enum : HRESULT { SEC_E_LOGON_DENIED = cast(HRESULT)0x8009030CL }

enum : HRESULT { SEC_E_UNKNOWN_CREDENTIALS = cast(HRESULT)0x8009030DL }

enum : HRESULT { SEC_E_NO_CREDENTIALS = cast(HRESULT)0x8009030EL }

enum : HRESULT { SEC_E_MESSAGE_ALTERED = cast(HRESULT)0x8009030FL }

enum : HRESULT { SEC_E_OUT_OF_SEQUENCE = cast(HRESULT)0x80090310L }

enum : HRESULT { SEC_E_NO_AUTHENTICATING_AUTHORITY = cast(HRESULT)0x80090311L }

enum : HRESULT { SEC_I_CONTINUE_NEEDED = cast(HRESULT)0x00090312L }

enum : HRESULT { SEC_I_COMPLETE_NEEDED = cast(HRESULT)0x00090313L }

enum : HRESULT { SEC_I_COMPLETE_AND_CONTINUE = cast(HRESULT)0x00090314L }

enum : HRESULT { SEC_I_LOCAL_LOGON = cast(HRESULT)0x00090315L }

enum : HRESULT { SEC_E_BAD_PKGID = cast(HRESULT)0x80090316L }

enum : HRESULT { SEC_E_CONTEXT_EXPIRED = cast(HRESULT)0x80090317L }

enum : HRESULT { SEC_I_CONTEXT_EXPIRED = cast(HRESULT)0x00090317L }

enum : HRESULT { SEC_E_INCOMPLETE_MESSAGE = cast(HRESULT)0x80090318L }

enum : HRESULT { SEC_E_INCOMPLETE_CREDENTIALS = cast(HRESULT)0x80090320L }

enum : HRESULT { SEC_E_BUFFER_TOO_SMALL = cast(HRESULT)0x80090321L }

enum : HRESULT { SEC_I_INCOMPLETE_CREDENTIALS = cast(HRESULT)0x00090320L }

enum : HRESULT { SEC_I_RENEGOTIATE = cast(HRESULT)0x00090321L }

enum : HRESULT { SEC_E_WRONG_PRINCIPAL = cast(HRESULT)0x80090322L }

enum : HRESULT { SEC_I_NO_LSA_CONTEXT = cast(HRESULT)0x00090323L }

enum : HRESULT { SEC_E_TIME_SKEW = cast(HRESULT)0x80090324L }

enum : HRESULT { SEC_E_UNTRUSTED_ROOT = cast(HRESULT)0x80090325L }

enum : HRESULT { SEC_E_ILLEGAL_MESSAGE = cast(HRESULT)0x80090326L }

enum : HRESULT { SEC_E_CERT_UNKNOWN = cast(HRESULT)0x80090327L }

enum : HRESULT { SEC_E_CERT_EXPIRED = cast(HRESULT)0x80090328L }

enum : HRESULT { SEC_E_ENCRYPT_FAILURE = cast(HRESULT)0x80090329L }

enum : HRESULT { SEC_E_DECRYPT_FAILURE = cast(HRESULT)0x80090330L }

enum : HRESULT { SEC_E_ALGORITHM_MISMATCH = cast(HRESULT)0x80090331L }

enum : HRESULT { SEC_E_SECURITY_QOS_FAILED = cast(HRESULT)0x80090332L }

enum : HRESULT { SEC_E_UNFINISHED_CONTEXT_DELETED = cast(HRESULT)0x80090333L }

enum : HRESULT { SEC_E_NO_TGT_REPLY = cast(HRESULT)0x80090334L }

enum : HRESULT { SEC_E_NO_IP_ADDRESSES = cast(HRESULT)0x80090335L }

enum : HRESULT { SEC_E_WRONG_CREDENTIAL_HANDLE = cast(HRESULT)0x80090336L }

enum : HRESULT { SEC_E_CRYPTO_SYSTEM_INVALID = cast(HRESULT)0x80090337L }

enum : HRESULT { SEC_E_MAX_REFERRALS_EXCEEDED = cast(HRESULT)0x80090338L }

enum : HRESULT { SEC_E_MUST_BE_KDC = cast(HRESULT)0x80090339L }

enum : HRESULT { SEC_E_STRONG_CRYPTO_NOT_SUPPORTED = cast(HRESULT)0x8009033AL }

enum : HRESULT { SEC_E_TOO_MANY_PRINCIPALS = cast(HRESULT)0x8009033BL }

enum : HRESULT { SEC_E_NO_PA_DATA = cast(HRESULT)0x8009033CL }

enum : HRESULT { SEC_E_PKINIT_NAME_MISMATCH = cast(HRESULT)0x8009033DL }

enum : HRESULT { SEC_E_SMARTCARD_LOGON_REQUIRED = cast(HRESULT)0x8009033EL }

enum : HRESULT { SEC_E_SHUTDOWN_IN_PROGRESS = cast(HRESULT)0x8009033FL }

enum : HRESULT { SEC_E_KDC_INVALID_REQUEST = cast(HRESULT)0x80090340L }

enum : HRESULT { SEC_E_KDC_UNABLE_TO_REFER = cast(HRESULT)0x80090341L }

enum : HRESULT { SEC_E_KDC_UNKNOWN_ETYPE = cast(HRESULT)0x80090342L }

enum : HRESULT { SEC_E_UNSUPPORTED_PREAUTH = cast(HRESULT)0x80090343L }

enum : HRESULT { SEC_E_DELEGATION_REQUIRED = cast(HRESULT)0x80090345L }

enum : HRESULT { SEC_E_BAD_BINDINGS = cast(HRESULT)0x80090346L }

enum : HRESULT { SEC_E_MULTIPLE_ACCOUNTS = cast(HRESULT)0x80090347L }

enum : HRESULT { SEC_E_NO_KERB_KEY = cast(HRESULT)0x80090348L }

alias SEC_E_INTERNAL_ERROR SEC_E_NO_SPM;
alias SEC_E_UNSUPPORTED_FUNCTION SEC_E_NOT_SUPPORTED;

enum : HRESULT { CRYPT_E_MSG_ERROR = cast(HRESULT)0x80091001L }

enum : HRESULT { CRYPT_E_UNKNOWN_ALGO = cast(HRESULT)0x80091002L }

enum : HRESULT { CRYPT_E_OID_FORMAT = cast(HRESULT)0x80091003L }

enum : HRESULT { CRYPT_E_INVALID_MSG_TYPE = cast(HRESULT)0x80091004L }

enum : HRESULT { CRYPT_E_UNEXPECTED_ENCODING = cast(HRESULT)0x80091005L }

enum : HRESULT { CRYPT_E_AUTH_ATTR_MISSING = cast(HRESULT)0x80091006L }

enum : HRESULT { CRYPT_E_HASH_VALUE = cast(HRESULT)0x80091007L }

enum : HRESULT { CRYPT_E_INVALID_INDEX = cast(HRESULT)0x80091008L }

enum : HRESULT { CRYPT_E_ALREADY_DECRYPTED = cast(HRESULT)0x80091009L }

enum : HRESULT { CRYPT_E_NOT_DECRYPTED = cast(HRESULT)0x8009100AL }

enum : HRESULT { CRYPT_E_RECIPIENT_NOT_FOUND = cast(HRESULT)0x8009100BL }

enum : HRESULT { CRYPT_E_CONTROL_TYPE = cast(HRESULT)0x8009100CL }

enum : HRESULT { CRYPT_E_ISSUER_SERIALNUMBER = cast(HRESULT)0x8009100DL }

enum : HRESULT { CRYPT_E_SIGNER_NOT_FOUND = cast(HRESULT)0x8009100EL }

enum : HRESULT { CRYPT_E_ATTRIBUTES_MISSING = cast(HRESULT)0x8009100FL }

enum : HRESULT { CRYPT_E_STREAM_MSG_NOT_READY = cast(HRESULT)0x80091010L }

enum : HRESULT { CRYPT_E_STREAM_INSUFFICIENT_DATA = cast(HRESULT)0x80091011L }

enum : HRESULT { CRYPT_I_NEW_PROTECTION_REQUIRED = cast(HRESULT)0x00091012L }

enum : HRESULT { CRYPT_E_BAD_LEN = cast(HRESULT)0x80092001L }

enum : HRESULT { CRYPT_E_BAD_ENCODE = cast(HRESULT)0x80092002L }

enum : HRESULT { CRYPT_E_FILE_ERROR = cast(HRESULT)0x80092003L }

enum : HRESULT { CRYPT_E_NOT_FOUND = cast(HRESULT)0x80092004L }

enum : HRESULT { CRYPT_E_EXISTS = cast(HRESULT)0x80092005L }

enum : HRESULT { CRYPT_E_NO_PROVIDER = cast(HRESULT)0x80092006L }

enum : HRESULT { CRYPT_E_SELF_SIGNED = cast(HRESULT)0x80092007L }

enum : HRESULT { CRYPT_E_DELETED_PREV = cast(HRESULT)0x80092008L }

enum : HRESULT { CRYPT_E_NO_MATCH = cast(HRESULT)0x80092009L }

enum : HRESULT { CRYPT_E_UNEXPECTED_MSG_TYPE = cast(HRESULT)0x8009200AL }

enum : HRESULT { CRYPT_E_NO_KEY_PROPERTY = cast(HRESULT)0x8009200BL }

enum : HRESULT { CRYPT_E_NO_DECRYPT_CERT = cast(HRESULT)0x8009200CL }

enum : HRESULT { CRYPT_E_BAD_MSG = cast(HRESULT)0x8009200DL }

enum : HRESULT { CRYPT_E_NO_SIGNER = cast(HRESULT)0x8009200EL }

enum : HRESULT { CRYPT_E_PENDING_CLOSE = cast(HRESULT)0x8009200FL }

enum : HRESULT { CRYPT_E_REVOKED = cast(HRESULT)0x80092010L }

enum : HRESULT { CRYPT_E_NO_REVOCATION_DLL = cast(HRESULT)0x80092011L }

enum : HRESULT { CRYPT_E_NO_REVOCATION_CHECK = cast(HRESULT)0x80092012L }

enum : HRESULT { CRYPT_E_REVOCATION_OFFLINE = cast(HRESULT)0x80092013L }

enum : HRESULT { CRYPT_E_NOT_IN_REVOCATION_DATABASE = cast(HRESULT)0x80092014L }

enum : HRESULT { CRYPT_E_INVALID_NUMERIC_STRING = cast(HRESULT)0x80092020L }

enum : HRESULT { CRYPT_E_INVALID_PRINTABLE_STRING = cast(HRESULT)0x80092021L }

enum : HRESULT { CRYPT_E_INVALID_IA5_STRING = cast(HRESULT)0x80092022L }

enum : HRESULT { CRYPT_E_INVALID_X500_STRING = cast(HRESULT)0x80092023L }

enum : HRESULT { CRYPT_E_NOT_CHAR_STRING = cast(HRESULT)0x80092024L }

enum : HRESULT { CRYPT_E_FILERESIZED = cast(HRESULT)0x80092025L }

enum : HRESULT { CRYPT_E_SECURITY_SETTINGS = cast(HRESULT)0x80092026L }

enum : HRESULT { CRYPT_E_NO_VERIFY_USAGE_DLL = cast(HRESULT)0x80092027L }

enum : HRESULT { CRYPT_E_NO_VERIFY_USAGE_CHECK = cast(HRESULT)0x80092028L }

enum : HRESULT { CRYPT_E_VERIFY_USAGE_OFFLINE = cast(HRESULT)0x80092029L }

enum : HRESULT { CRYPT_E_NOT_IN_CTL = cast(HRESULT)0x8009202AL }

enum : HRESULT { CRYPT_E_NO_TRUSTED_SIGNER = cast(HRESULT)0x8009202BL }

enum : HRESULT { CRYPT_E_MISSING_PUBKEY_PARA = cast(HRESULT)0x8009202CL }

enum : HRESULT { CRYPT_E_OSS_ERROR = cast(HRESULT)0x80093000L }

enum : HRESULT { OSS_MORE_BUF = cast(HRESULT)0x80093001L }

enum : HRESULT { OSS_NEGATIVE_UINTEGER = cast(HRESULT)0x80093002L }

enum : HRESULT { OSS_PDU_RANGE = cast(HRESULT)0x80093003L }

enum : HRESULT { OSS_MORE_INPUT = cast(HRESULT)0x80093004L }

enum : HRESULT { OSS_DATA_ERROR = cast(HRESULT)0x80093005L }

enum : HRESULT { OSS_BAD_ARG = cast(HRESULT)0x80093006L }

enum : HRESULT { OSS_BAD_VERSION = cast(HRESULT)0x80093007L }

enum : HRESULT { OSS_OUT_MEMORY = cast(HRESULT)0x80093008L }

enum : HRESULT { OSS_PDU_MISMATCH = cast(HRESULT)0x80093009L }

enum : HRESULT { OSS_LIMITED = cast(HRESULT)0x8009300AL }

enum : HRESULT { OSS_BAD_PTR = cast(HRESULT)0x8009300BL }

enum : HRESULT { OSS_BAD_TIME = cast(HRESULT)0x8009300CL }

enum : HRESULT { OSS_INDEFINITE_NOT_SUPPORTED = cast(HRESULT)0x8009300DL }

enum : HRESULT { OSS_MEM_ERROR = cast(HRESULT)0x8009300EL }

enum : HRESULT { OSS_BAD_TABLE = cast(HRESULT)0x8009300FL }

enum : HRESULT { OSS_TOO_LONG = cast(HRESULT)0x80093010L }

enum : HRESULT { OSS_CONSTRAINT_VIOLATED = cast(HRESULT)0x80093011L }

enum : HRESULT { OSS_FATAL_ERROR = cast(HRESULT)0x80093012L }

enum : HRESULT { OSS_ACCESS_SERIALIZATION_ERROR = cast(HRESULT)0x80093013L }

enum : HRESULT { OSS_NULL_TBL = cast(HRESULT)0x80093014L }

enum : HRESULT { OSS_NULL_FCN = cast(HRESULT)0x80093015L }

enum : HRESULT { OSS_BAD_ENCRULES = cast(HRESULT)0x80093016L }

enum : HRESULT { OSS_UNAVAIL_ENCRULES = cast(HRESULT)0x80093017L }

enum : HRESULT { OSS_CANT_OPEN_TRACE_WINDOW = cast(HRESULT)0x80093018L }

enum : HRESULT { OSS_UNIMPLEMENTED = cast(HRESULT)0x80093019L }

enum : HRESULT { OSS_OID_DLL_NOT_LINKED = cast(HRESULT)0x8009301AL }

enum : HRESULT { OSS_CANT_OPEN_TRACE_FILE = cast(HRESULT)0x8009301BL }

enum : HRESULT { OSS_TRACE_FILE_ALREADY_OPEN = cast(HRESULT)0x8009301CL }

enum : HRESULT { OSS_TABLE_MISMATCH = cast(HRESULT)0x8009301DL }

enum : HRESULT { OSS_TYPE_NOT_SUPPORTED = cast(HRESULT)0x8009301EL }

enum : HRESULT { OSS_REAL_DLL_NOT_LINKED = cast(HRESULT)0x8009301FL }

enum : HRESULT { OSS_REAL_CODE_NOT_LINKED = cast(HRESULT)0x80093020L }

enum : HRESULT { OSS_OUT_OF_RANGE = cast(HRESULT)0x80093021L }

enum : HRESULT { OSS_COPIER_DLL_NOT_LINKED = cast(HRESULT)0x80093022L }

enum : HRESULT { OSS_CONSTRAINT_DLL_NOT_LINKED = cast(HRESULT)0x80093023L }

enum : HRESULT { OSS_COMPARATOR_DLL_NOT_LINKED = cast(HRESULT)0x80093024L }

enum : HRESULT { OSS_COMPARATOR_CODE_NOT_LINKED = cast(HRESULT)0x80093025L }

enum : HRESULT { OSS_MEM_MGR_DLL_NOT_LINKED = cast(HRESULT)0x80093026L }

enum : HRESULT { OSS_PDV_DLL_NOT_LINKED = cast(HRESULT)0x80093027L }

enum : HRESULT { OSS_PDV_CODE_NOT_LINKED = cast(HRESULT)0x80093028L }

enum : HRESULT { OSS_API_DLL_NOT_LINKED = cast(HRESULT)0x80093029L }

enum : HRESULT { OSS_BERDER_DLL_NOT_LINKED = cast(HRESULT)0x8009302AL }

enum : HRESULT { OSS_PER_DLL_NOT_LINKED = cast(HRESULT)0x8009302BL }

enum : HRESULT { OSS_OPEN_TYPE_ERROR = cast(HRESULT)0x8009302CL }

enum : HRESULT { OSS_MUTEX_NOT_CREATED = cast(HRESULT)0x8009302DL }

enum : HRESULT { OSS_CANT_CLOSE_TRACE_FILE = cast(HRESULT)0x8009302EL }

enum : HRESULT { CRYPT_E_ASN1_ERROR = cast(HRESULT)0x80093100L }

enum : HRESULT { CRYPT_E_ASN1_INTERNAL = cast(HRESULT)0x80093101L }

enum : HRESULT { CRYPT_E_ASN1_EOD = cast(HRESULT)0x80093102L }

enum : HRESULT { CRYPT_E_ASN1_CORRUPT = cast(HRESULT)0x80093103L }

enum : HRESULT { CRYPT_E_ASN1_LARGE = cast(HRESULT)0x80093104L }

enum : HRESULT { CRYPT_E_ASN1_CONSTRAINT = cast(HRESULT)0x80093105L }

enum : HRESULT { CRYPT_E_ASN1_MEMORY = cast(HRESULT)0x80093106L }

enum : HRESULT { CRYPT_E_ASN1_OVERFLOW = cast(HRESULT)0x80093107L }

enum : HRESULT { CRYPT_E_ASN1_BADPDU = cast(HRESULT)0x80093108L }

enum : HRESULT { CRYPT_E_ASN1_BADARGS = cast(HRESULT)0x80093109L }

enum : HRESULT { CRYPT_E_ASN1_BADREAL = cast(HRESULT)0x8009310AL }

enum : HRESULT { CRYPT_E_ASN1_BADTAG = cast(HRESULT)0x8009310BL }

enum : HRESULT { CRYPT_E_ASN1_CHOICE = cast(HRESULT)0x8009310CL }

enum : HRESULT { CRYPT_E_ASN1_RULE = cast(HRESULT)0x8009310DL }

enum : HRESULT { CRYPT_E_ASN1_UTF8 = cast(HRESULT)0x8009310EL }

enum : HRESULT { CRYPT_E_ASN1_PDU_TYPE = cast(HRESULT)0x80093133L }

enum : HRESULT { CRYPT_E_ASN1_NYI = cast(HRESULT)0x80093134L }

enum : HRESULT { CRYPT_E_ASN1_EXTENDED = cast(HRESULT)0x80093201L }

enum : HRESULT { CRYPT_E_ASN1_NOEOD = cast(HRESULT)0x80093202L }

enum : HRESULT { CERTSRV_E_BAD_REQUESTSUBJECT = cast(HRESULT)0x80094001L }

enum : HRESULT { CERTSRV_E_NO_REQUEST = cast(HRESULT)0x80094002L }

enum : HRESULT { CERTSRV_E_BAD_REQUESTSTATUS = cast(HRESULT)0x80094003L }

enum : HRESULT { CERTSRV_E_PROPERTY_EMPTY = cast(HRESULT)0x80094004L }

enum : HRESULT { CERTSRV_E_INVALID_CA_CERTIFICATE = cast(HRESULT)0x80094005L }

enum : HRESULT { CERTSRV_E_SERVER_SUSPENDED = cast(HRESULT)0x80094006L }

enum : HRESULT { CERTSRV_E_ENCODING_LENGTH = cast(HRESULT)0x80094007L }

enum : HRESULT { CERTSRV_E_ROLECONFLICT = cast(HRESULT)0x80094008L }

enum : HRESULT { CERTSRV_E_RESTRICTEDOFFICER = cast(HRESULT)0x80094009L }

enum : HRESULT { CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED = cast(HRESULT)0x8009400AL }

enum : HRESULT { CERTSRV_E_NO_VALID_KRA = cast(HRESULT)0x8009400BL }

enum : HRESULT { CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL = cast(HRESULT)0x8009400CL }

enum : HRESULT { CERTSRV_E_NO_CAADMIN_DEFINED = cast(HRESULT)0x8009400DL }

enum : HRESULT { CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE = cast(HRESULT)0x8009400EL }

enum : HRESULT { CERTSRV_E_NO_DB_SESSIONS = cast(HRESULT)0x8009400FL }

enum : HRESULT { CERTSRV_E_ALIGNMENT_FAULT = cast(HRESULT)0x80094010L }

enum : HRESULT { CERTSRV_E_ENROLL_DENIED = cast(HRESULT)0x80094011L }

enum : HRESULT { CERTSRV_E_TEMPLATE_DENIED = cast(HRESULT)0x80094012L }

enum : HRESULT { CERTSRV_E_UNSUPPORTED_CERT_TYPE = cast(HRESULT)0x80094800L }

enum : HRESULT { CERTSRV_E_NO_CERT_TYPE = cast(HRESULT)0x80094801L }

enum : HRESULT { CERTSRV_E_TEMPLATE_CONFLICT = cast(HRESULT)0x80094802L }

enum : HRESULT { CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED = cast(HRESULT)0x80094803L }

enum : HRESULT { CERTSRV_E_ARCHIVED_KEY_REQUIRED = cast(HRESULT)0x80094804L }

enum : HRESULT { CERTSRV_E_SMIME_REQUIRED = cast(HRESULT)0x80094805L }

enum : HRESULT { CERTSRV_E_BAD_RENEWAL_SUBJECT = cast(HRESULT)0x80094806L }

enum : HRESULT { CERTSRV_E_BAD_TEMPLATE_VERSION = cast(HRESULT)0x80094807L }

enum : HRESULT { CERTSRV_E_TEMPLATE_POLICY_REQUIRED = cast(HRESULT)0x80094808L }

enum : HRESULT { CERTSRV_E_SIGNATURE_POLICY_REQUIRED = cast(HRESULT)0x80094809L }

enum : HRESULT { CERTSRV_E_SIGNATURE_COUNT = cast(HRESULT)0x8009480AL }

enum : HRESULT { CERTSRV_E_SIGNATURE_REJECTED = cast(HRESULT)0x8009480BL }

enum : HRESULT { CERTSRV_E_ISSUANCE_POLICY_REQUIRED = cast(HRESULT)0x8009480CL }

enum : HRESULT { CERTSRV_E_SUBJECT_UPN_REQUIRED = cast(HRESULT)0x8009480DL }

enum : HRESULT { CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED = cast(HRESULT)0x8009480EL }

enum : HRESULT { CERTSRV_E_SUBJECT_DNS_REQUIRED = cast(HRESULT)0x8009480FL }

enum : HRESULT { CERTSRV_E_ARCHIVED_KEY_UNEXPECTED = cast(HRESULT)0x80094810L }

enum : HRESULT { CERTSRV_E_KEY_LENGTH = cast(HRESULT)0x80094811L }

enum : HRESULT { XENROLL_E_KEY_NOT_EXPORTABLE = cast(HRESULT)0x80095000L }

enum : HRESULT { XENROLL_E_CANNOT_ADD_ROOT_CERT = cast(HRESULT)0x80095001L }

enum : HRESULT { XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND = cast(HRESULT)0x80095002L }

enum : HRESULT { XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH = cast(HRESULT)0x80095003L }

enum : HRESULT { XENROLL_E_RESPONSE_KA_HASH_MISMATCH = cast(HRESULT)0x80095004L }

enum : HRESULT { XENROLL_E_KEYSPEC_SMIME_MISMATCH = cast(HRESULT)0x80095005L }

enum : HRESULT { TRUST_E_SYSTEM_ERROR = cast(HRESULT)0x80096001L }

enum : HRESULT { TRUST_E_NO_SIGNER_CERT = cast(HRESULT)0x80096002L }

enum : HRESULT { TRUST_E_COUNTER_SIGNER = cast(HRESULT)0x80096003L }

enum : HRESULT { TRUST_E_CERT_SIGNATURE = cast(HRESULT)0x80096004L }

enum : HRESULT { TRUST_E_TIME_STAMP = cast(HRESULT)0x80096005L }

enum : HRESULT { TRUST_E_BAD_DIGEST = cast(HRESULT)0x80096010L }

enum : HRESULT { TRUST_E_BASIC_CONSTRAINTS = cast(HRESULT)0x80096019L }

enum : HRESULT { TRUST_E_FINANCIAL_CRITERIA = cast(HRESULT)0x8009601EL }

enum : HRESULT { MSSIPOTF_E_OUTOFMEMRANGE = cast(HRESULT)0x80097001L }

enum : HRESULT { MSSIPOTF_E_CANTGETOBJECT = cast(HRESULT)0x80097002L }

enum : HRESULT { MSSIPOTF_E_NOHEADTABLE = cast(HRESULT)0x80097003L }

enum : HRESULT { MSSIPOTF_E_BAD_MAGICNUMBER = cast(HRESULT)0x80097004L }

enum : HRESULT { MSSIPOTF_E_BAD_OFFSET_TABLE = cast(HRESULT)0x80097005L }

enum : HRESULT { MSSIPOTF_E_TABLE_TAGORDER = cast(HRESULT)0x80097006L }

enum : HRESULT { MSSIPOTF_E_TABLE_LONGWORD = cast(HRESULT)0x80097007L }

enum : HRESULT { MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT = cast(HRESULT)0x80097008L }

enum : HRESULT { MSSIPOTF_E_TABLES_OVERLAP = cast(HRESULT)0x80097009L }

enum : HRESULT { MSSIPOTF_E_TABLE_PADBYTES = cast(HRESULT)0x8009700AL }

enum : HRESULT { MSSIPOTF_E_FILETOOSMALL = cast(HRESULT)0x8009700BL }

enum : HRESULT { MSSIPOTF_E_TABLE_CHECKSUM = cast(HRESULT)0x8009700CL }

enum : HRESULT { MSSIPOTF_E_FILE_CHECKSUM = cast(HRESULT)0x8009700DL }

enum : HRESULT { MSSIPOTF_E_FAILED_POLICY = cast(HRESULT)0x80097010L }

enum : HRESULT { MSSIPOTF_E_FAILED_HINTS_CHECK = cast(HRESULT)0x80097011L }

enum : HRESULT { MSSIPOTF_E_NOT_OPENTYPE = cast(HRESULT)0x80097012L }

enum : HRESULT { MSSIPOTF_E_FILE = cast(HRESULT)0x80097013L }

enum : HRESULT { MSSIPOTF_E_CRYPT = cast(HRESULT)0x80097014L }

enum : HRESULT { MSSIPOTF_E_BADVERSION = cast(HRESULT)0x80097015L }

enum : HRESULT { MSSIPOTF_E_DSIG_STRUCTURE = cast(HRESULT)0x80097016L }

enum : HRESULT { MSSIPOTF_E_PCONST_CHECK = cast(HRESULT)0x80097017L }

enum : HRESULT { MSSIPOTF_E_STRUCTURE = cast(HRESULT)0x80097018L }

enum : uint { NTE_OP_OK = 0 }

enum : HRESULT { TRUST_E_PROVIDER_UNKNOWN = cast(HRESULT)0x800B0001L }

enum : HRESULT { TRUST_E_ACTION_UNKNOWN = cast(HRESULT)0x800B0002L }

enum : HRESULT { TRUST_E_SUBJECT_FORM_UNKNOWN = cast(HRESULT)0x800B0003L }

enum : HRESULT { TRUST_E_SUBJECT_NOT_TRUSTED = cast(HRESULT)0x800B0004L }

enum : HRESULT { DIGSIG_E_ENCODE = cast(HRESULT)0x800B0005L }

enum : HRESULT { DIGSIG_E_DECODE = cast(HRESULT)0x800B0006L }

enum : HRESULT { DIGSIG_E_EXTENSIBILITY = cast(HRESULT)0x800B0007L }

enum : HRESULT { DIGSIG_E_CRYPTO = cast(HRESULT)0x800B0008L }

enum : HRESULT { PERSIST_E_SIZEDEFINITE = cast(HRESULT)0x800B0009L }

enum : HRESULT { PERSIST_E_SIZEINDEFINITE = cast(HRESULT)0x800B000AL }

enum : HRESULT { PERSIST_E_NOTSELFSIZING = cast(HRESULT)0x800B000BL }

enum : HRESULT { TRUST_E_NOSIGNATURE = cast(HRESULT)0x800B0100L }

enum : HRESULT { CERT_E_EXPIRED = cast(HRESULT)0x800B0101L }

enum : HRESULT { CERT_E_VALIDITYPERIODNESTING = cast(HRESULT)0x800B0102L }

enum : HRESULT { CERT_E_ROLE = cast(HRESULT)0x800B0103L }

enum : HRESULT { CERT_E_PATHLENCONST = cast(HRESULT)0x800B0104L }

enum : HRESULT { CERT_E_CRITICAL = cast(HRESULT)0x800B0105L }

enum : HRESULT { CERT_E_PURPOSE = cast(HRESULT)0x800B0106L }

enum : HRESULT { CERT_E_ISSUERCHAINING = cast(HRESULT)0x800B0107L }

enum : HRESULT { CERT_E_MALFORMED = cast(HRESULT)0x800B0108L }

enum : HRESULT { CERT_E_UNTRUSTEDROOT = cast(HRESULT)0x800B0109L }

enum : HRESULT { CERT_E_CHAINING = cast(HRESULT)0x800B010AL }

enum : HRESULT { TRUST_E_FAIL = cast(HRESULT)0x800B010BL }

enum : HRESULT { CERT_E_REVOKED = cast(HRESULT)0x800B010CL }

enum : HRESULT { CERT_E_UNTRUSTEDTESTROOT = cast(HRESULT)0x800B010DL }

enum : HRESULT { CERT_E_REVOCATION_FAILURE = cast(HRESULT)0x800B010EL }

enum : HRESULT { CERT_E_CN_NO_MATCH = cast(HRESULT)0x800B010FL }

enum : HRESULT { CERT_E_WRONG_USAGE = cast(HRESULT)0x800B0110L }

enum : HRESULT { TRUST_E_EXPLICIT_DISTRUST = cast(HRESULT)0x800B0111L }

enum : HRESULT { CERT_E_UNTRUSTEDCA = cast(HRESULT)0x800B0112L }

enum : HRESULT { CERT_E_INVALID_POLICY = cast(HRESULT)0x800B0113L }

enum : HRESULT { CERT_E_INVALID_NAME = cast(HRESULT)0x800B0114L }

// #define HRESULT_FROM_SETUPAPI(x) ((((x) & (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR)) == (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR)) ? ((HRESULT) (((x) & 0x0000FFFF) | (FACILITY_SETUPAPI << 16) | 0x80000000)) : HRESULT_FROM_WIN32(x))

enum : HRESULT { SPAPI_E_EXPECTED_SECTION_NAME = cast(HRESULT)0x800F0000L }

enum : HRESULT { SPAPI_E_BAD_SECTION_NAME_LINE = cast(HRESULT)0x800F0001L }

enum : HRESULT { SPAPI_E_SECTION_NAME_TOO_LONG = cast(HRESULT)0x800F0002L }

enum : HRESULT { SPAPI_E_GENERAL_SYNTAX = cast(HRESULT)0x800F0003L }

enum : HRESULT { SPAPI_E_WRONG_INF_STYLE = cast(HRESULT)0x800F0100L }

enum : HRESULT { SPAPI_E_SECTION_NOT_FOUND = cast(HRESULT)0x800F0101L }

enum : HRESULT { SPAPI_E_LINE_NOT_FOUND = cast(HRESULT)0x800F0102L }

enum : HRESULT { SPAPI_E_NO_BACKUP = cast(HRESULT)0x800F0103L }

enum : HRESULT { SPAPI_E_NO_ASSOCIATED_CLASS = cast(HRESULT)0x800F0200L }

enum : HRESULT { SPAPI_E_CLASS_MISMATCH = cast(HRESULT)0x800F0201L }

enum : HRESULT { SPAPI_E_DUPLICATE_FOUND = cast(HRESULT)0x800F0202L }

enum : HRESULT { SPAPI_E_NO_DRIVER_SELECTED = cast(HRESULT)0x800F0203L }

enum : HRESULT { SPAPI_E_KEY_DOES_NOT_EXIST = cast(HRESULT)0x800F0204L }

enum : HRESULT { SPAPI_E_INVALID_DEVINST_NAME = cast(HRESULT)0x800F0205L }

enum : HRESULT { SPAPI_E_INVALID_CLASS = cast(HRESULT)0x800F0206L }

enum : HRESULT { SPAPI_E_DEVINST_ALREADY_EXISTS = cast(HRESULT)0x800F0207L }

enum : HRESULT { SPAPI_E_DEVINFO_NOT_REGISTERED = cast(HRESULT)0x800F0208L }

enum : HRESULT { SPAPI_E_INVALID_REG_PROPERTY = cast(HRESULT)0x800F0209L }

enum : HRESULT { SPAPI_E_NO_INF = cast(HRESULT)0x800F020AL }

enum : HRESULT { SPAPI_E_NO_SUCH_DEVINST = cast(HRESULT)0x800F020BL }

enum : HRESULT { SPAPI_E_CANT_LOAD_CLASS_ICON = cast(HRESULT)0x800F020CL }

enum : HRESULT { SPAPI_E_INVALID_CLASS_INSTALLER = cast(HRESULT)0x800F020DL }

enum : HRESULT { SPAPI_E_DI_DO_DEFAULT = cast(HRESULT)0x800F020EL }

enum : HRESULT { SPAPI_E_DI_NOFILECOPY = cast(HRESULT)0x800F020FL }

enum : HRESULT { SPAPI_E_INVALID_HWPROFILE = cast(HRESULT)0x800F0210L }

enum : HRESULT { SPAPI_E_NO_DEVICE_SELECTED = cast(HRESULT)0x800F0211L }

enum : HRESULT { SPAPI_E_DEVINFO_LIST_LOCKED = cast(HRESULT)0x800F0212L }

enum : HRESULT { SPAPI_E_DEVINFO_DATA_LOCKED = cast(HRESULT)0x800F0213L }

enum : HRESULT { SPAPI_E_DI_BAD_PATH = cast(HRESULT)0x800F0214L }

enum : HRESULT { SPAPI_E_NO_CLASSINSTALL_PARAMS = cast(HRESULT)0x800F0215L }

enum : HRESULT { SPAPI_E_FILEQUEUE_LOCKED = cast(HRESULT)0x800F0216L }

enum : HRESULT { SPAPI_E_BAD_SERVICE_INSTALLSECT = cast(HRESULT)0x800F0217L }

enum : HRESULT { SPAPI_E_NO_CLASS_DRIVER_LIST = cast(HRESULT)0x800F0218L }

enum : HRESULT { SPAPI_E_NO_ASSOCIATED_SERVICE = cast(HRESULT)0x800F0219L }

enum : HRESULT { SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE = cast(HRESULT)0x800F021AL }

enum : HRESULT { SPAPI_E_DEVICE_INTERFACE_ACTIVE = cast(HRESULT)0x800F021BL }

enum : HRESULT { SPAPI_E_DEVICE_INTERFACE_REMOVED = cast(HRESULT)0x800F021CL }

enum : HRESULT { SPAPI_E_BAD_INTERFACE_INSTALLSECT = cast(HRESULT)0x800F021DL }

enum : HRESULT { SPAPI_E_NO_SUCH_INTERFACE_CLASS = cast(HRESULT)0x800F021EL }

enum : HRESULT { SPAPI_E_INVALID_REFERENCE_STRING = cast(HRESULT)0x800F021FL }

enum : HRESULT { SPAPI_E_INVALID_MACHINENAME = cast(HRESULT)0x800F0220L }

enum : HRESULT { SPAPI_E_REMOTE_COMM_FAILURE = cast(HRESULT)0x800F0221L }

enum : HRESULT { SPAPI_E_MACHINE_UNAVAILABLE = cast(HRESULT)0x800F0222L }

enum : HRESULT { SPAPI_E_NO_CONFIGMGR_SERVICES = cast(HRESULT)0x800F0223L }

enum : HRESULT { SPAPI_E_INVALID_PROPPAGE_PROVIDER = cast(HRESULT)0x800F0224L }

enum : HRESULT { SPAPI_E_NO_SUCH_DEVICE_INTERFACE = cast(HRESULT)0x800F0225L }

enum : HRESULT { SPAPI_E_DI_POSTPROCESSING_REQUIRED = cast(HRESULT)0x800F0226L }

enum : HRESULT { SPAPI_E_INVALID_COINSTALLER = cast(HRESULT)0x800F0227L }

enum : HRESULT { SPAPI_E_NO_COMPAT_DRIVERS = cast(HRESULT)0x800F0228L }

enum : HRESULT { SPAPI_E_NO_DEVICE_ICON = cast(HRESULT)0x800F0229L }

enum : HRESULT { SPAPI_E_INVALID_INF_LOGCONFIG = cast(HRESULT)0x800F022AL }

enum : HRESULT { SPAPI_E_DI_DONT_INSTALL = cast(HRESULT)0x800F022BL }

enum : HRESULT { SPAPI_E_INVALID_FILTER_DRIVER = cast(HRESULT)0x800F022CL }

enum : HRESULT { SPAPI_E_NON_WINDOWS_NT_DRIVER = cast(HRESULT)0x800F022DL }

enum : HRESULT { SPAPI_E_NON_WINDOWS_DRIVER = cast(HRESULT)0x800F022EL }

enum : HRESULT { SPAPI_E_NO_CATALOG_FOR_OEM_INF = cast(HRESULT)0x800F022FL }

enum : HRESULT { SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE = cast(HRESULT)0x800F0230L }

enum : HRESULT { SPAPI_E_NOT_DISABLEABLE = cast(HRESULT)0x800F0231L }

enum : HRESULT { SPAPI_E_CANT_REMOVE_DEVINST = cast(HRESULT)0x800F0232L }

enum : HRESULT { SPAPI_E_INVALID_TARGET = cast(HRESULT)0x800F0233L }

enum : HRESULT { SPAPI_E_DRIVER_NONNATIVE = cast(HRESULT)0x800F0234L }

enum : HRESULT { SPAPI_E_IN_WOW64 = cast(HRESULT)0x800F0235L }

enum : HRESULT { SPAPI_E_SET_SYSTEM_RESTORE_POINT = cast(HRESULT)0x800F0236L }

enum : HRESULT { SPAPI_E_INCORRECTLY_COPIED_INF = cast(HRESULT)0x800F0237L }

enum : HRESULT { SPAPI_E_SCE_DISABLED = cast(HRESULT)0x800F0238L }

enum : HRESULT { SPAPI_E_ERROR_NOT_INSTALLED = cast(HRESULT)0x800F1000L }

alias NO_ERROR SCARD_S_SUCCESS;

enum : HRESULT { SCARD_F_INTERNAL_ERROR = cast(HRESULT)0x80100001L }

enum : HRESULT { SCARD_E_CANCELLED = cast(HRESULT)0x80100002L }

enum : HRESULT { SCARD_E_INVALID_HANDLE = cast(HRESULT)0x80100003L }

enum : HRESULT { SCARD_E_INVALID_PARAMETER = cast(HRESULT)0x80100004L }

enum : HRESULT { SCARD_E_INVALID_TARGET = cast(HRESULT)0x80100005L }

enum : HRESULT { SCARD_E_NO_MEMORY = cast(HRESULT)0x80100006L }

enum : HRESULT { SCARD_F_WAITED_TOO_LONG = cast(HRESULT)0x80100007L }

enum : HRESULT { SCARD_E_INSUFFICIENT_BUFFER = cast(HRESULT)0x80100008L }

enum : HRESULT { SCARD_E_UNKNOWN_READER = cast(HRESULT)0x80100009L }

enum : HRESULT { SCARD_E_TIMEOUT = cast(HRESULT)0x8010000AL }

enum : HRESULT { SCARD_E_SHARING_VIOLATION = cast(HRESULT)0x8010000BL }

enum : HRESULT { SCARD_E_NO_SMARTCARD = cast(HRESULT)0x8010000CL }

enum : HRESULT { SCARD_E_UNKNOWN_CARD = cast(HRESULT)0x8010000DL }

enum : HRESULT { SCARD_E_CANT_DISPOSE = cast(HRESULT)0x8010000EL }

enum : HRESULT { SCARD_E_PROTO_MISMATCH = cast(HRESULT)0x8010000FL }

enum : HRESULT { SCARD_E_NOT_READY = cast(HRESULT)0x80100010L }

enum : HRESULT { SCARD_E_INVALID_VALUE = cast(HRESULT)0x80100011L }

enum : HRESULT { SCARD_E_SYSTEM_CANCELLED = cast(HRESULT)0x80100012L }

enum : HRESULT { SCARD_F_COMM_ERROR = cast(HRESULT)0x80100013L }

enum : HRESULT { SCARD_F_UNKNOWN_ERROR = cast(HRESULT)0x80100014L }

enum : HRESULT { SCARD_E_INVALID_ATR = cast(HRESULT)0x80100015L }

enum : HRESULT { SCARD_E_NOT_TRANSACTED = cast(HRESULT)0x80100016L }

enum : HRESULT { SCARD_E_READER_UNAVAILABLE = cast(HRESULT)0x80100017L }

enum : HRESULT { SCARD_P_SHUTDOWN = cast(HRESULT)0x80100018L }

enum : HRESULT { SCARD_E_PCI_TOO_SMALL = cast(HRESULT)0x80100019L }

enum : HRESULT { SCARD_E_READER_UNSUPPORTED = cast(HRESULT)0x8010001AL }

enum : HRESULT { SCARD_E_DUPLICATE_READER = cast(HRESULT)0x8010001BL }

enum : HRESULT { SCARD_E_CARD_UNSUPPORTED = cast(HRESULT)0x8010001CL }

enum : HRESULT { SCARD_E_NO_SERVICE = cast(HRESULT)0x8010001DL }

enum : HRESULT { SCARD_E_SERVICE_STOPPED = cast(HRESULT)0x8010001EL }

enum : HRESULT { SCARD_E_UNEXPECTED = cast(HRESULT)0x8010001FL }

enum : HRESULT { SCARD_E_ICC_INSTALLATION = cast(HRESULT)0x80100020L }

enum : HRESULT { SCARD_E_ICC_CREATEORDER = cast(HRESULT)0x80100021L }

enum : HRESULT { SCARD_E_UNSUPPORTED_FEATURE = cast(HRESULT)0x80100022L }

enum : HRESULT { SCARD_E_DIR_NOT_FOUND = cast(HRESULT)0x80100023L }

enum : HRESULT { SCARD_E_FILE_NOT_FOUND = cast(HRESULT)0x80100024L }

enum : HRESULT { SCARD_E_NO_DIR = cast(HRESULT)0x80100025L }

enum : HRESULT { SCARD_E_NO_FILE = cast(HRESULT)0x80100026L }

enum : HRESULT { SCARD_E_NO_ACCESS = cast(HRESULT)0x80100027L }

enum : HRESULT { SCARD_E_WRITE_TOO_MANY = cast(HRESULT)0x80100028L }

enum : HRESULT { SCARD_E_BAD_SEEK = cast(HRESULT)0x80100029L }

enum : HRESULT { SCARD_E_INVALID_CHV = cast(HRESULT)0x8010002AL }

enum : HRESULT { SCARD_E_UNKNOWN_RES_MNG = cast(HRESULT)0x8010002BL }

enum : HRESULT { SCARD_E_NO_SUCH_CERTIFICATE = cast(HRESULT)0x8010002CL }

enum : HRESULT { SCARD_E_CERTIFICATE_UNAVAILABLE = cast(HRESULT)0x8010002DL }

enum : HRESULT { SCARD_E_NO_READERS_AVAILABLE = cast(HRESULT)0x8010002EL }

enum : HRESULT { SCARD_E_COMM_DATA_LOST = cast(HRESULT)0x8010002FL }

enum : HRESULT { SCARD_E_NO_KEY_CONTAINER = cast(HRESULT)0x80100030L }

enum : HRESULT { SCARD_W_UNSUPPORTED_CARD = cast(HRESULT)0x80100065L }

enum : HRESULT { SCARD_W_UNRESPONSIVE_CARD = cast(HRESULT)0x80100066L }

enum : HRESULT { SCARD_W_UNPOWERED_CARD = cast(HRESULT)0x80100067L }

enum : HRESULT { SCARD_W_RESET_CARD = cast(HRESULT)0x80100068L }

enum : HRESULT { SCARD_W_REMOVED_CARD = cast(HRESULT)0x80100069L }

enum : HRESULT { SCARD_W_SECURITY_VIOLATION = cast(HRESULT)0x8010006AL }

enum : HRESULT { SCARD_W_WRONG_CHV = cast(HRESULT)0x8010006BL }

enum : HRESULT { SCARD_W_CHV_BLOCKED = cast(HRESULT)0x8010006CL }

enum : HRESULT { SCARD_W_EOF = cast(HRESULT)0x8010006DL }

enum : HRESULT { SCARD_W_CANCELLED_BY_USER = cast(HRESULT)0x8010006EL }

enum : HRESULT { SCARD_W_CARD_NOT_AUTHENTICATED = cast(HRESULT)0x8010006FL }

enum : HRESULT { COMADMIN_E_OBJECTERRORS = cast(HRESULT)0x80110401L }

enum : HRESULT { COMADMIN_E_OBJECTINVALID = cast(HRESULT)0x80110402L }

enum : HRESULT { COMADMIN_E_KEYMISSING = cast(HRESULT)0x80110403L }

enum : HRESULT { COMADMIN_E_ALREADYINSTALLED = cast(HRESULT)0x80110404L }

enum : HRESULT { COMADMIN_E_APP_FILE_WRITEFAIL = cast(HRESULT)0x80110407L }

enum : HRESULT { COMADMIN_E_APP_FILE_READFAIL = cast(HRESULT)0x80110408L }

enum : HRESULT { COMADMIN_E_APP_FILE_VERSION = cast(HRESULT)0x80110409L }

enum : HRESULT { COMADMIN_E_BADPATH = cast(HRESULT)0x8011040AL }

enum : HRESULT { COMADMIN_E_APPLICATIONEXISTS = cast(HRESULT)0x8011040BL }

enum : HRESULT { COMADMIN_E_ROLEEXISTS = cast(HRESULT)0x8011040CL }

enum : HRESULT { COMADMIN_E_CANTCOPYFILE = cast(HRESULT)0x8011040DL }

enum : HRESULT { COMADMIN_E_NOUSER = cast(HRESULT)0x8011040FL }

enum : HRESULT { COMADMIN_E_INVALIDUSERIDS = cast(HRESULT)0x80110410L }

enum : HRESULT { COMADMIN_E_NOREGISTRYCLSID = cast(HRESULT)0x80110411L }

enum : HRESULT { COMADMIN_E_BADREGISTRYPROGID = cast(HRESULT)0x80110412L }

enum : HRESULT { COMADMIN_E_AUTHENTICATIONLEVEL = cast(HRESULT)0x80110413L }

enum : HRESULT { COMADMIN_E_USERPASSWDNOTVALID = cast(HRESULT)0x80110414L }

enum : HRESULT { COMADMIN_E_CLSIDORIIDMISMATCH = cast(HRESULT)0x80110418L }

enum : HRESULT { COMADMIN_E_REMOTEINTERFACE = cast(HRESULT)0x80110419L }

enum : HRESULT { COMADMIN_E_DLLREGISTERSERVER = cast(HRESULT)0x8011041AL }

enum : HRESULT { COMADMIN_E_NOSERVERSHARE = cast(HRESULT)0x8011041BL }

enum : HRESULT { COMADMIN_E_DLLLOADFAILED = cast(HRESULT)0x8011041DL }

enum : HRESULT { COMADMIN_E_BADREGISTRYLIBID = cast(HRESULT)0x8011041EL }

enum : HRESULT { COMADMIN_E_APPDIRNOTFOUND = cast(HRESULT)0x8011041FL }

enum : HRESULT { COMADMIN_E_REGISTRARFAILED = cast(HRESULT)0x80110423L }

enum : HRESULT { COMADMIN_E_COMPFILE_DOESNOTEXIST = cast(HRESULT)0x80110424L }

enum : HRESULT { COMADMIN_E_COMPFILE_LOADDLLFAIL = cast(HRESULT)0x80110425L }

enum : HRESULT { COMADMIN_E_COMPFILE_GETCLASSOBJ = cast(HRESULT)0x80110426L }

enum : HRESULT { COMADMIN_E_COMPFILE_CLASSNOTAVAIL = cast(HRESULT)0x80110427L }

enum : HRESULT { COMADMIN_E_COMPFILE_BADTLB = cast(HRESULT)0x80110428L }

enum : HRESULT { COMADMIN_E_COMPFILE_NOTINSTALLABLE = cast(HRESULT)0x80110429L }

enum : HRESULT { COMADMIN_E_NOTCHANGEABLE = cast(HRESULT)0x8011042AL }

enum : HRESULT { COMADMIN_E_NOTDELETEABLE = cast(HRESULT)0x8011042BL }

enum : HRESULT { COMADMIN_E_SESSION = cast(HRESULT)0x8011042CL }

enum : HRESULT { COMADMIN_E_COMP_MOVE_LOCKED = cast(HRESULT)0x8011042DL }

enum : HRESULT { COMADMIN_E_COMP_MOVE_BAD_DEST = cast(HRESULT)0x8011042EL }

enum : HRESULT { COMADMIN_E_REGISTERTLB = cast(HRESULT)0x80110430L }

enum : HRESULT { COMADMIN_E_SYSTEMAPP = cast(HRESULT)0x80110433L }

enum : HRESULT { COMADMIN_E_COMPFILE_NOREGISTRAR = cast(HRESULT)0x80110434L }

enum : HRESULT { COMADMIN_E_COREQCOMPINSTALLED = cast(HRESULT)0x80110435L }

enum : HRESULT { COMADMIN_E_SERVICENOTINSTALLED = cast(HRESULT)0x80110436L }

enum : HRESULT { COMADMIN_E_PROPERTYSAVEFAILED = cast(HRESULT)0x80110437L }

enum : HRESULT { COMADMIN_E_OBJECTEXISTS = cast(HRESULT)0x80110438L }

enum : HRESULT { COMADMIN_E_COMPONENTEXISTS = cast(HRESULT)0x80110439L }

enum : HRESULT { COMADMIN_E_REGFILE_CORRUPT = cast(HRESULT)0x8011043BL }

enum : HRESULT { COMADMIN_E_PROPERTY_OVERFLOW = cast(HRESULT)0x8011043CL }

enum : HRESULT { COMADMIN_E_NOTINREGISTRY = cast(HRESULT)0x8011043EL }

enum : HRESULT { COMADMIN_E_OBJECTNOTPOOLABLE = cast(HRESULT)0x8011043FL }

enum : HRESULT { COMADMIN_E_APPLID_MATCHES_CLSID = cast(HRESULT)0x80110446L }

enum : HRESULT { COMADMIN_E_ROLE_DOES_NOT_EXIST = cast(HRESULT)0x80110447L }

enum : HRESULT { COMADMIN_E_START_APP_NEEDS_COMPONENTS = cast(HRESULT)0x80110448L }

enum : HRESULT { COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM = cast(HRESULT)0x80110449L }

enum : HRESULT { COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY = cast(HRESULT)0x8011044AL }

enum : HRESULT { COMADMIN_E_CAN_NOT_START_APP = cast(HRESULT)0x8011044BL }

enum : HRESULT { COMADMIN_E_CAN_NOT_EXPORT_SYS_APP = cast(HRESULT)0x8011044CL }

enum : HRESULT { COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT = cast(HRESULT)0x8011044DL }

enum : HRESULT { COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER = cast(HRESULT)0x8011044EL }

enum : HRESULT { COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE = cast(HRESULT)0x8011044FL }

enum : HRESULT { COMADMIN_E_BASE_PARTITION_ONLY = cast(HRESULT)0x80110450L }

enum : HRESULT { COMADMIN_E_START_APP_DISABLED = cast(HRESULT)0x80110451L }

enum : HRESULT { COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME = cast(HRESULT)0x80110457L }

enum : HRESULT { COMADMIN_E_CAT_INVALID_PARTITION_NAME = cast(HRESULT)0x80110458L }

enum : HRESULT { COMADMIN_E_CAT_PARTITION_IN_USE = cast(HRESULT)0x80110459L }

enum : HRESULT { COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES = cast(HRESULT)0x8011045AL }

enum : HRESULT { COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED = cast(HRESULT)0x8011045BL }

enum : HRESULT { COMADMIN_E_AMBIGUOUS_APPLICATION_NAME = cast(HRESULT)0x8011045CL }

enum : HRESULT { COMADMIN_E_AMBIGUOUS_PARTITION_NAME = cast(HRESULT)0x8011045DL }

enum : HRESULT { COMADMIN_E_REGDB_NOTINITIALIZED = cast(HRESULT)0x80110472L }

enum : HRESULT { COMADMIN_E_REGDB_NOTOPEN = cast(HRESULT)0x80110473L }

enum : HRESULT { COMADMIN_E_REGDB_SYSTEMERR = cast(HRESULT)0x80110474L }

enum : HRESULT { COMADMIN_E_REGDB_ALREADYRUNNING = cast(HRESULT)0x80110475L }

enum : HRESULT { COMADMIN_E_MIG_VERSIONNOTSUPPORTED = cast(HRESULT)0x80110480L }

enum : HRESULT { COMADMIN_E_MIG_SCHEMANOTFOUND = cast(HRESULT)0x80110481L }

enum : HRESULT { COMADMIN_E_CAT_BITNESSMISMATCH = cast(HRESULT)0x80110482L }

enum : HRESULT { COMADMIN_E_CAT_UNACCEPTABLEBITNESS = cast(HRESULT)0x80110483L }

enum : HRESULT { COMADMIN_E_CAT_WRONGAPPBITNESS = cast(HRESULT)0x80110484L }

enum : HRESULT { COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED = cast(HRESULT)0x80110485L }

enum : HRESULT { COMADMIN_E_CAT_SERVERFAULT = cast(HRESULT)0x80110486L }

enum : HRESULT { COMQC_E_APPLICATION_NOT_QUEUED = cast(HRESULT)0x80110600L }

enum : HRESULT { COMQC_E_NO_QUEUEABLE_INTERFACES = cast(HRESULT)0x80110601L }

enum : HRESULT { COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE = cast(HRESULT)0x80110602L }

enum : HRESULT { COMQC_E_NO_IPERSISTSTREAM = cast(HRESULT)0x80110603L }

enum : HRESULT { COMQC_E_BAD_MESSAGE = cast(HRESULT)0x80110604L }

enum : HRESULT { COMQC_E_UNAUTHENTICATED = cast(HRESULT)0x80110605L }

enum : HRESULT { COMQC_E_UNTRUSTED_ENQUEUER = cast(HRESULT)0x80110606L }

enum : HRESULT { MSDTC_E_DUPLICATE_RESOURCE = cast(HRESULT)0x80110701L }

enum : HRESULT { COMADMIN_E_OBJECT_PARENT_MISSING = cast(HRESULT)0x80110808L }

enum : HRESULT { COMADMIN_E_OBJECT_DOES_NOT_EXIST = cast(HRESULT)0x80110809L }

enum : HRESULT { COMADMIN_E_APP_NOT_RUNNING = cast(HRESULT)0x8011080AL }

enum : HRESULT { COMADMIN_E_INVALID_PARTITION = cast(HRESULT)0x8011080BL }

enum : HRESULT { COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE = cast(HRESULT)0x8011080DL }

enum : HRESULT { COMADMIN_E_USER_IN_SET = cast(HRESULT)0x8011080EL }

enum : HRESULT { COMADMIN_E_CANTRECYCLELIBRARYAPPS = cast(HRESULT)0x8011080FL }

enum : HRESULT { COMADMIN_E_CANTRECYCLESERVICEAPPS = cast(HRESULT)0x80110811L }

enum : HRESULT { COMADMIN_E_PROCESSALREADYRECYCLED = cast(HRESULT)0x80110812L }

enum : HRESULT { COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED = cast(HRESULT)0x80110813L }

enum : HRESULT { COMADMIN_E_CANTMAKEINPROCSERVICE = cast(HRESULT)0x80110814L }

enum : HRESULT { COMADMIN_E_PROGIDINUSEBYCLSID = cast(HRESULT)0x80110815L }

enum : HRESULT { COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET = cast(HRESULT)0x80110816L }

enum : HRESULT { COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED = cast(HRESULT)0x80110817L }

enum : HRESULT { COMADMIN_E_PARTITION_ACCESSDENIED = cast(HRESULT)0x80110818L }

enum : HRESULT { COMADMIN_E_PARTITION_MSI_ONLY = cast(HRESULT)0x80110819L }

enum : HRESULT { COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT = cast(HRESULT)0x8011081AL }

enum : HRESULT { COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS = cast(HRESULT)0x8011081BL }

enum : HRESULT { COMADMIN_E_COMP_MOVE_SOURCE = cast(HRESULT)0x8011081CL }

enum : HRESULT { COMADMIN_E_COMP_MOVE_DEST = cast(HRESULT)0x8011081DL }

enum : HRESULT { COMADMIN_E_COMP_MOVE_PRIVATE = cast(HRESULT)0x8011081EL }

enum : HRESULT { COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET = cast(HRESULT)0x8011081FL }

enum : HRESULT { COMADMIN_E_CANNOT_ALIAS_EVENTCLASS = cast(HRESULT)0x80110820L }

enum : HRESULT { COMADMIN_E_PRIVATE_ACCESSDENIED = cast(HRESULT)0x80110821L }

enum : HRESULT { COMADMIN_E_SAFERINVALID = cast(HRESULT)0x80110822L }

enum : HRESULT { COMADMIN_E_REGISTRY_ACCESSDENIED = cast(HRESULT)0x80110823L }

enum : HRESULT { COMADMIN_E_CAT_DUPLICATE_PARTITION_SET_NAME = cast(HRESULT)0x80110900L }

enum : HRESULT { COMADMIN_E_CAT_INVALID_PARTITION_SET_NAME = cast(HRESULT)0x80110901L }

// #endif//_WINERROR_
